<?php
/*------------------------------------------------------------------------
# com_vchart - VChart
# ------------------------------------------------------------------------
# author    Team WDMtech
# copyright Copyright (C) 2014 wwww.wdmtech.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.wdmtech..com
# Technical Support:  Forum - http://www.wdmtech.com/support-forum
-----------------------------------------------------------------------*/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class  VchartControllerVchart extends VchartController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		
		JRequest::setVar( 'view', 'vchart' );
		
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
        $this->registerTask( 'unpublish', 'publish' );
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		JRequest::setVar( 'view', 'vchart' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	//to publish/unpublish the items
	function publish()
	{	
		$model = $this->getModel('vchart');
		
		$task = JRequest::getCmd('task', '');
		$text = $task=="publish"?'Published':'Unpublished';
		
		if(!$model->publish()) {
			jerror::raiseWarning('', $model->getError());
			$link = 'index.php?option=com_vchart&view=vchart';
		    $this->setRedirect($link, $msg);
		} else {
			$msg = JText::sprintf( '%s successfully', $text );
			$link = 'index.php?option=com_vchart&view=vchart';
		     $this->setRedirect($link, $msg);
		}
			
	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('vchart');
		
		if(!$model->store()) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vchart');
		} else {
			$msg = JText::_( 'vchart Saved' );
			$this->setRedirect( 'index.php?option=com_vchart&view=vchart', $msg );
		}

	}
	
	function apply()
	{
		$model = $this->getModel('vchart');
		
		if(!$model->store()) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vchart&task=edit&cid[]='.JRequest::getInt('id', 0) );
		} else {
			$msg = JText::_( 'health Saved' );
		    $this->setRedirect( 'index.php?option=com_vchart&view=vchart&task=edit&cid[]='.JRequest::getInt('id', 0), $msg );
		}

	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('vchart');
		
		if(!$model->delete()) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vchart');
		} else {
			$msg = JText::_( 'Record(s) Deleted' );
			$this->setRedirect( 'index.php?option=com_vchart&view=vchart', $msg );
		}
		
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_vchart&view=vchart', $msg );
	
	}

	
}