<?php 
/*------------------------------------------------------------------------
# com_vchart - VChart
# ------------------------------------------------------------------------
# author    Team WDMtech
# copyright Copyright (C) 2014 wwww.wdmtech.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.wdmtech..com
# Technical Support:  Forum - http://www.wdmtech.com/support-forum
-----------------------------------------------------------------------*/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class  VchartControllerVcharts extends VchartController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		
		JRequest::setVar( 'view', 'vcharts' );
		
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
        $this->registerTask( 'unpublish', 'publish' );
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		JRequest::setVar( 'view', 'vcharts' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	//to publish/unpublish the items
	
	function publish()
	{	
		if(!JFactory::getUser()->authorise('core.edit.state','com_vchart'))
		{
				$msg = JText::_( 'NOT_AUTHORISED_TO_CHANGE_STATE');
				$link = 'index.php?option=com_vchart&view=vcharts';
				$this->setRedirect($link, $msg, 'warning');	
		}
		
		
		$model = $this->getModel('vcharts');
		
		$task = JRequest::getCmd('task', '');
		$text = $task=="publish"?'Published':'Unpublished';
		
		if(!$model->publish()) {
			jerror::raiseWarning('', $model->getError());
			$link = 'index.php?option=com_vchart&view=vcharts';
		    $this->setRedirect($link, $msg);
		} else {
			$msg = JText::sprintf( '%s successfully', $text );
			$link = 'index.php?option=com_vchart&view=vcharts';
		     $this->setRedirect($link, $msg);
		}
			
	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('vcharts');
		
		if(!$model->store()) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts');
		} else {
			$msg = JText::_( 'vchart Saved' );
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts', $msg );
		}

	}
	
	function apply()
	{
		$model = $this->getModel('vcharts');
		$chartid=$model->store();
		if($chartid <= 0) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts&task=edit&cid[]='.$chartid);
		} else {
			$msg = JText::_( 'Chart Saved' );
		    $this->setRedirect( 'index.php?option=com_vchart&view=vcharts&task=edit&cid[]='.$chartid,$msg);
		}

	}
	function apply2()
	{
		$model = $this->getModel('vcharts');
		
		if(!$model->store()) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts&task=edit&cid[]='.JRequest::getInt('id', 0) );
		} else {
			$msg = JText::_( 'Chart Saved' );
		    $this->setRedirect( 'index.php?option=com_vchart&view=vcharts&task=edit&cid[]='.JRequest::getInt('id', 0), $msg );
		}

	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function load_csv_data()	{
	    
		$db = JFactory::getDbo();
		$dir = JPATH_ADMINISTRATOR.'/components/com_vchart/uploads/data.csv';
		jimport('joomla.filesystem.file');
		$file = JRequest::getVar("file", null, 'FILES', 'array');
		$vchart_type = JRequest::getVar("vchart_type", null, 'string');
	    $file_name    = str_replace(' ', '', JFile::makeSafe($file['name']));		
		$file_tmp     = $file["tmp_name"];
	
		$ext = strrchr($file_name, '.');
		
		if(filesize($file_tmp) == 0 and is_file($dir))	{
			return true;
		}
	
		if(filesize($file_tmp) == 0)	{
			$this->setError(JText::_('PLZ_SELECT_FILE'));
			return false;
		}
		
		if($ext <> '.csv')	{
			$this->setError(JText::_('ONLY_CSV'));
			return false;
		}
		
		if(!move_uploaded_file($file_tmp, $dir))	{
			$this->setError(JText::_('FILE_NOT_UPLOADED'));
			return false;
		}
		$model = $this->getModel('vcharts');
		$obj = vChart::data_csv($vchart_type);
		jexit(json_encode($obj));
		}
	function load_csv_remote()
	 {
	   $vchart_type = JRequest::getVar("vchart_type",'');
	 
	   if(empty($vchart_type))
	   {
		$this->setError(JText::_('VCHART_PLZ_SELECT_CHART_TYPE'));
		return false;   
		}
	    $obj = vChart::data_csv($vchart_type);
		jexit(json_encode($obj));	
	 }	
	function remove()
	{
		$model = $this->getModel('vcharts');
		
		if(!$model->delete()) {
			jerror::raiseWarning('', $model->getError());
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts');
		} else {
			$msg = JText::_( 'Record(s) Deleted' );
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts', $msg );
		}
		
	}
function make_list($name, $current_value, &$items, $first = 0, $extra='')
{
	$html = "\n".'<select name="'.$name.'" id="'.$name.'" class="inputbox" size="1" '.$extra.'>';
	if ($items == null)
		return '';
	foreach ($items as $key => $value)
		{
		if (strncmp($key,"OPTGROUP_START",14) == 0)
			{
			$html .= "\n".'<optgroup label="'.$value.'">';
			continue;
			}
		if (strncmp($key,"OPTGROUP_END",12) == 0)
			{
			$html .= "\n".'</optgroup>';
			continue;
			}
		if ($key < $first)					// skip unwanted entries
			continue;
		$selected = '';
		if ($current_value == $key)
			$selected = ' selected="selected"';
		$html .= "\n".'<option value="'.$key.'"'.$selected.'>'.$value.'</option>';
		}
	$html .= '</select>'."\n";
	return $html;
}
	/**
	 * cancel editing a record
	 * @return void
	 */
	function copy()					// make a copy of one chart and edit it
     {
	JRequest::checkToken() or jexit('Invalid Token');
	
	$model = $this->getModel('vcharts');
	if(!$model->copy()) 
			$msg = JText::_( 'Error: Could not be Copy' );
			else 	 
			$msg = JText::_( 'Copy Succesfully' );
			$this->setRedirect( 'index.php?option=com_vchart&view=vcharts', $msg );	
      }
	
 function load_columns()
	{
		
		JRequest::checkToken() or jexit( JText::_('INVALID_TOKEN') );
		
		$model = $this->getModel('vcharts');
		$obj = $model->getColumns();
		jexit(json_encode($obj));
		
	}
	
	function load_refer_columns()
	{
		$model = $this->getModel('vcharts');
		$obj = $model->getReferColumns();
		
		jexit(json_encode($obj));
		
	}
	function value_from_existing_database()
	{
		
		$model = $this->getModel('vcharts');
		$obj = $model->value_existing_database();
		jexit(json_encode($obj));
	}
	function value_from_existing_database_extra_condition()
	{
		
		$model = $this->getModel('vcharts');
		$obj = $model->value_from_existing_database_extra_condition();
		jexit(json_encode($obj));
	}
	function value_from_existing_database_sql_query()
	{
		
		$model = $this->getModel('vcharts');
		$obj = $model->value_from_existing_database_sql_query(); 
		jexit(json_encode($obj));
	}
	function series_data()
	{
	    $model = $this->getModel('vcharts');
		$obj = $model->series_data();
		jexit(json_encode($obj));
	}
	function getTableFromOtherDatabase(){
		
		$model = $this->getModel('vcharts');
		$obj = $model->getTableFromOtherDatabase();
		jexit(json_encode($obj));
		}
		
		function value_from_map_information(){
		
		$model = $this->getModel('vcharts');
		$obj = $model->value_from_map_information();
		jexit(json_encode($obj));
		
		}
	function series_column()
	{
	    $model = $this->getModel('vcharts');
		$obj = $model->series_column();
		jexit(json_encode($obj));
	}
	function delete_backgroun_image()
	{
	    $model = $this->getModel('vcharts');
		$obj = $model->delete_backgroun_image();
		jexit(json_encode($obj));
	}
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_vchart&view=vcharts', $msg );
	
	}
}