<?php 
/*------------------------------------------------------------------------
# com_vchart - VChart
# ------------------------------------------------------------------------
# author    Zaheer Abbas
# copyright Copyright (C) 2014 wwww.wdmtech.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.wdmtech..com
# Technical Support:  Forum - http://www.wdmtech.com/support-forum
-----------------------------------------------------------------------*/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

class VchartModelVcharts extends VCModel 
{
	
	var $_data;
	var $_list;
	var $_total;
	
	
	function __construct()
	{
		parent::__construct();

		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		$controller = JRequest::getWord('controller');
          $context			= 'com_vchart.vcharts.list.'; 
		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
			
		$this->limitstart = $mainframe->getUserStateFromRequest ( $option . 'limitstart', 'limitstart', 0, 'int' );
		$this->limit = $mainframe->getUserStateFromRequest ( $option . 'limit', 'limit', 20, 'int' );
	    $this->main_chart_type		= $mainframe->getUserStateFromRequest($context.'main_chart_type',	'main_chart_type',	'',	'string' );
		$this->_filter_state	= $mainframe->getUserStateFromRequest($context.'filter_state',	'filter_state',	'',	'word' );
		
		$this->setState('limit', $this->limit);
		$this->setState('limitstart', 0);
	}

	
	function _buildQuery()
	{
		$query = ' SELECT v.* '
			. ' FROM #__vchart as v'
		;

		return $query;
	}

	
	function setId($id)
	{
		
		$this->_id		= $id;
		$this->_data	= null;
	}

	function getItems()
	{
        
		if (empty( $this->_list ))
		{
			$query = $this->_buildQuery();
			$query .= $this->_buildItemFilter();
			$query .= $this->_buildItemOrderBy();
			
			//$comments = $this->getDbo ()->setQuery ( $query, $this->limitstart, $this->limit )->loadObjectList ();
            $this->_list = $this->_getList( $query, $this->limitstart, $this->limit);
		}
		
		
		
		return $this->_list;
	}
	function _buildItemOrderBy()
	{
        $mainframe = JFactory::getApplication();
		
		$context			= 'com_calculators.vcharts.list.';
 
        $filter_order     = $mainframe->getUserStateFromRequest( $context.'filter_order', 'filter_order', 'id', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );
 
        $orderby = ' order by '.$filter_order.' '.$filter_order_Dir . ' ';
 
        return $orderby;
	}
	function copy()
				{
				
				$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
				if (count( $cids )) {
					foreach($cids as $cid) {
						$query = ' SELECT * FROM #__vchart WHERE id = '.$cid;
					    $this->_db->setQuery( $query );
					    $result= $this->_db->loadObject();
						
						$insert = new stdClass();
						$insert->id = null;
						$insert->published = $result->published;
						$insert->vchart_type = $result->vchart_type;
						$insert->database_type = $result->database_type;
						$insert->chart_title_option = $result->chart_title_option;
						$insert->chart_data_option = $result->chart_data_option;
						$insert->chart_name = $result->chart_name;
						$insert->chart_data = $result->chart_data;
						$insert->chart_option = $result->chart_option;
						$insert->chart_data_option = $result->chart_data_option;
						$insert->chart_width = $result->chart_width;
						$insert->chart_height = $result->chart_height;
						$insert->legend_position = $result->legend_position;
						$insert->x_axis_columns = $result->x_axis_columns;
						$insert->existing_database_table = $result->existing_database_table;
						$insert->db_driver =$result->db_driver;
						$insert->db_host = $result->db_host;
						$insert->db_root = $result->db_root;
						$insert->db_pass = $result->db_pass;
						$insert->db_database = $result->db_database;
						$insert->limit_value = $result->limit_value;
						$insert->groupby = $result->groupby;
						$insert->extra_parms = $result->extra_parms;
						$insert->extra_condition = $result->extra_condition;
						$insert->extra_condition = $result->extra_condition;
						$insert->chart_extra_parms = $result->chart_extra_parms;
						$insert->ordering  = $result->ordering ;
										
						if(!$this->_db->insertObject('#__vchart', $insert, 'id'))	{
						$msg = $this->setError($this->_db->stderr());
						$this->setRedirect( 'index.php?option=com_vchart&view=vcharts', $msg );
						return false;
						}
						$queszid = $this->_db->insertid();
					}
				  }
				  return true;
				}
	function getItem()
	{
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__vchart '.
					'  WHERE id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = '';
			$this->_data->published = 1;
			//$this->_data->chart_type = '';
			$this->_data->vchart_type = '';
			$this->_data->database_type= '';
			$this->_data->chart_title_option = 0;
			$this->_data->chart_data_option = '';
			$this->_data->chart_name = '';
			$this->_data->chart_data = '';
			$this->_data->chart_option = '';
			$this->_data->chart_data_option = '';
			$this->_data->chart_width = 512;
			$this->_data->chart_height = 256;
			$this->_data->legend_position = 'right';
			$this->_data->x_axis_columns = '';
			$this->_data->db_driver = '';
			$this->_data->db_host = '';
			$this->_data->db_root = '';
			$this->_data->db_pass = '';
			$this->_data->existing_database_table = '';
			$this->_data->db_database = '';
			$this->_data->db_prefix = '';
			$this->_data->chart_extra_parms='';
			$this->_data->show_raw_data = false;
			$this->_data->show_script = false;
			$this->_data->x_title = '';
			$this->_data->x_start = '';
			$this->_data->chart_title_colour = '';
			$this->_data->limit_value = '';
			$this->_data->groupby = '';
			$this->_data->ordering = '';
			$this->_data->extra_parms = '';
			$this->_data->extra_condition = '';
			$this->_data->enter_manually = '';
			$this->_data->date_created = date('Y-m-d');
			$this->_data->date_updated = date('Y-m-d');
			
			
			}

		return $this->_data;
	   
	
	}
	
	function _buildItemFilter()
	{  
	   $mainframe = JFactory::getApplication();
	    $context			= 'com_vchart.vcharts.list.';
        $chart_query = $mainframe->getUserStateFromRequest ( $context . 'chart_query', 'chart_query', '' );  
        $where = array();
     if (trim ( $chart_query ) != '') {
			$where [] = 'v.chart_name LIKE ' . $this->getDbo ()->quote ( "%{$chart_query}%" );
		}
	 
	 if ($this->_filter_state == 'U' )
			$where[] = 'v.published = 0';
			elseif($this->_filter_state == 'P' )
			$where[] = 'v.published = 1';
			 if ($this->main_chart_type != '' )
			$where[] = 'v.vchart_type = "'.$this->main_chart_type.'"';
	
            $filter = count($where) ? ' WHERE ' . implode(' AND ', $where) : '';
		 
        return $filter;
	}
	function getPagination()
	{
		jimport('joomla.html.pagination');
		$this->_pagination = new JPagination( $this->getTotal(), $this->limitstart, $this->limit);
		return $this->_pagination;
	}		
	
	function getTables()
	{
		
		$query = 'show tables';
		$this->_db->setQuery( $query );
		$items = $this->_db->loadColumn();
		
		return $items;
		
	}
	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$query .= $this->_buildItemFilter();
			$this->_total = $this->_getListCount($query);
		}

        return $this->_total;
	}

function getColumns()
	    {
		    $obj = new stdClass();
			$obj->result = 'error';
			
			$table = JRequest::getString('table', '');
			$id = JRequest::getInt('id', 0);
			$database_type = JRequest::getVar('database_type', '');
			$chart_type = JRequest::getVar('chart_type', '');
			$x_axis_column_name = JRequest::getString('x_axis_columns', '');
			$groupby = JRequest::getString('groupby', '');
			$orderbycolumn = JRequest::getString('orderbycolumn', '');
			$map_mode = JRequest::getVar('map_information', 'map');
			if($table == '')
			{
			
			$obj->html='';
			$obj->group='';
			$obj->orderbycolumn='';
			$obj->result = 'success';
			return $obj;
			}
			
			if($database_type =='chart_data_from_existing'){
			
			$query = 'show fields FROM '.$this->_db->quotename($table);
			$this->_db->setQuery( $query );
			
			if($this->_db->getErrorNum())	{
			$obj->result = 'error';
			$obj->error = $this->_db->getErrorMsg();
			return $obj;
			}
			
			$columns = $this->_db->loadObjectList();}
			if($id>0){
			$chart_details = $this->getChart($id); 
			$x_axis = $chart_detail = json_decode($chart_details->chart_data);
			$chart_options = json_decode($chart_details->chart_option);
	        $x_axis_column_name = $x_axis_column_name==''?isset($x_axis->x_axis_columns)&& $x_axis->x_axis_columns!=''?$x_axis->x_axis_columns:$x_axis_column_name:$x_axis_column_name;
		    $groupby = $groupby==''?isset($chart_details->groupby)&&$chart_details->groupby!=''?$chart_details->groupby:$groupby:$groupby;
			  
			$orderbycolumn = $orderbycolumn==''?isset($chart_options->orderbycolumn)&&$chart_options->orderbycolumn!=''?$chart_options->orderbycolumn:$orderbycolumn:$orderbycolumn;
			//new changes
			}
			if($database_type =='chart_data_from_other_database'){
			$driver = JRequest::getVar('driver', '');
			$host = JRequest::getVar('host', '');
			$user = JRequest::getVar('user', '');
			$password = JRequest::getVar('password', '');
			$database = JRequest::getVar('database', '');
			$prefix = JRequest::getVar('prefix', '');
			$other_databas_table = JRequest::getVar('other_databas_table', '');
			$table_column_name = JRequest::getVar('table_column_name', '');
			
			$option = array(); //prevent problems
			try
			{
			$option['driver']   = $driver;            
			$option['host']     = $host;  
			$option['user']     = $user;  
			$option['password'] = $password; 
			$option['database'] = $database; 
			$option['prefix']   = $prefix;  
			
			$db = JDatabaseDriver::getInstance( $option );
			 $db->connect(); 
			}
			catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage();
					return $obj;
					
					}
			$query = 'show fields FROM `'.$table.'`';
			$db->setQuery( $query ); 
			if($db->getErrorNum())	{
			$obj->error = $db->getErrorMsg();
			return $obj;
			}
			
			$columns = $db->loadObjectList();
			}
			
			
			if($chart_type=='Line Chart' || $chart_type=='Area Chart' || $chart_type=='Column Charts'|| $chart_type=='Combo Charts' || $chart_type=='Bar Chart' || $chart_type=='Stepped AreaChart'){
					$obj->html = '';
					$obj->group = '';
					$obj->orderbycolumn = '';
					$obj->html .= '';
					
					
					$obj->html .= '<td><span><label id="x_axis_columns-lbl" for="x_axis_columns" class="hasTip" title="'.JText::_('COM_VCHART_GENRAL_CHART_SELECT_COLUMN_FOR_X_AXIS_DESC').'">'.JText::_('COM_VCHART_GENRAL_CHART_SELECT_COLUMN_FOR_X_AXIS').'</label></td><td><select  name="params[x_axis_columns]" class="required" id="x_axis_columns" data-type="" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column X Axis Value').'</option>'; 
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').' </label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').'</label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>';
					for($i=0;$i<count($columns);$i++)   
					{
					$selected = '';
					if($id>0 &&$chart_details->vchart_type == $chart_type && $columns[$i]->Field == $x_axis_column_name){ $selected =' selected="selected"';}
					
					
					$obj->html .= '<option value="'.$columns[$i]->Field.'"';
					$obj->html .= $selected.'>'.$columns[$i]->Field.'</option>';
					$selected = '';
					//echo $columns[$i]->Field.' '.$groupby;
					if($id>0 && $chart_details->vchart_type == $chart_type && $columns[$i]->Field == $groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					$selected = '';
					//echo $columns[$i]->Field.' '.$groupby;
					if($id>0 && $chart_details->vchart_type == $chart_type && $columns[$i]->Field == $orderbycolumn){ $selected =' selected="selected"';}
					
					$obj->orderbycolumn .= '<option value="'.$columns[$i]->Field.'"';
					$obj->orderbycolumn .= $selected.'>'.$columns[$i]->Field.'</option>';
					}
					$obj->html .= '</select></span></td>';
					$obj->group .= '</select></span></td>';
					$obj->orderbycolumn .= '</select></span></td>';
					}
					elseif($chart_type=='Annotation chart' ){
					$obj->html = '';
					$obj->group = '';
					$obj->orderbycolumn = '';
					$obj->html .= '';
					
					$obj->html .= '<td><span><label id="x_axis_columns-lbl" for="x_axis_columns" class="hasTip" title="'.JText::_('COM_VCHART_ANNOTATION_CHART_SELECT_COLUMN_FOR_X_AXIS_DESC').'">'.JText::_('COM_VCHART_ANNOTATION_CHART_SELECT_COLUMN_FOR_X_AXIS').' </label></td><td><select  name="x_axis_columns" id="x_axis_columns" data-type="date_value" class="required" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Date').'</option>'; 
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').'</label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>';
					
					for($i=0;$i<count($columns);$i++)   
					{
					$selected = '';
					if($id>0 &&$chart_details->vchart_type == $chart_type && $columns[$i]->Field == $x_axis_column_name){ $selected =' selected="selected"';}
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='date'||$type_v[0]=='datetime' || $type_v[0]=='timestamp'|| $type_v[0]=='time'|| $type_v[0]=='year'){
					$obj->html .= '<option value="'.$columns[$i]->Field.'"';
					$obj->html .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					}
					$selected = '';
					if($id>0 &&$chart_details->vchart_type == $chart_type && $columns[$i]->Field == $groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					$selected = '';
					if($id>0 &&$chart_details->vchart_type == $chart_type && $columns[$i]->Field == $orderbycolumn){ $selected =' selected="selected"';}
					
					$obj->orderbycolumn .= '<option value="'.$columns[$i]->Field.'"';
					$obj->orderbycolumn .= $selected.'>'.$columns[$i]->Field.'</option>';
					}
					$obj->html .= '</select></span></td>';
					$obj->group .= '</select></span></td>';
					
			}
			elseif($chart_type=='Scatter Chart'){
					$obj->html = '';
					$obj->group = '';
					$obj->orderbycolumn = '';
					$obj->html .= '';
					
					$obj->html .= '<td><span><label class="hasTip" id="x_axis_columns-lbl" for="x_axis_columns" title="'.JText::_('COM_VCHART_SCATTER_CHART_SELECT_COLUMN_FOR_X_AXIS_DESC').'"> '.JText::_('COM_VCHART_SCATTER_CHART_SELECT_COLUMN_FOR_X_AXIS').'</label></td><td><select  name="x_axis_columns" id="x_axis_columns" data-type="axis_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column X Axis Value').'</option>'; 
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" for="orderbycolumn" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').' </label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>';
					for($i=0;$i<count($columns);$i++)   
					{
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type &&  $columns[$i]->Field == $x_axis_column_name){ $selected =' selected="selected"';}
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'){
					$obj->html .= '<option value="'.$columns[$i]->Field.'"';
					$obj->html .= $selected.'>'.$columns[$i]->Field.'</option>';
					}
					$selected = '';
					
					if($id>0 &&$chart_details->vchart_type == $chart_type &&  $columns[$i]->Field == $groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					$selected = '';
					if($id>0 &&$chart_details->vchart_type == $chart_type &&  $columns[$i]->Field == $orderbycolumn){ $selected =' selected="selected"';}
					
					$obj->orderbycolumn .= '<option value="'.$columns[$i]->Field.'"';
					$obj->orderbycolumn .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					}
					$obj->html .= '</select></span></td>';
					$obj->group .= '</select></span></td>';
					$obj->orderbycolumn .= '</select></span></td>';
					}
					
					elseif($chart_type=='Pie Chart'|| $chart_type=='Slice Pie Chart'){
					$obj->html = '';
					$obj->group = '';
                   $obj->orderbycolumn = '';					
					$obj->html .= '<td></td><td><span class="d_pie"><label id="series_col_nice-lbl" for="series_col_nice" class="hasTip" title="Select column name for Title">Select Column for Title </label><select class="series_col_nice" name="params[series_title_name]" data-type="jform_params_chartparams_series" id="series_col_nice" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For title').'</option>';
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" for="orderbycolumn" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').' </label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>';
					for($i=0;$i<count($columns);$i++)	{
					
					$selected = '';
					
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_title_name) &&  $columns[$i]->Field == $chart_detail->series_title_name){ $selected =' selected="selected"';} 
					
					$obj->html .= '<option value="'.$columns[$i]->Field.'"';
					
					$obj->html .= $selected.'>'.$columns[$i]->Field.'</option>';
					$selected = '';
					if($id>0 &&$columns[$i]->Field == $groupby){ $selected =' selected="selected"';}
					
					
					$selected = '';
					
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->groupby) &&  $columns[$i]->Field == $groupby ){ $selected =' selected="selected"';} 
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					$selected = '';
					
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->orderbycolumn) &&  $columns[$i]->Field == $orderbycolumn ){ $selected =' selected="selected"';} 
					
					$obj->orderbycolumn .= '<option value="'.$columns[$i]->Field.'"';
					$obj->orderbycolumn .= $selected.'>'.$columns[$i]->Field.'</option>';
					}
					$obj->html .= '</select></span>'; 
					$obj->group .= '</select></span></td>';
					$obj->orderbycolumn .= '</select></span></td>';
					$obj->html .= '<span class="d_pie"><label class="hasTip" title="Select column name for Value">Select Column for Values </label><select  name="params[series_title_value]" id="x_axis_columns" data-type="jform_params_chartparams_axis_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Value').'</option>';
					
					
					for($i=0;$i<count($columns);$i++) 
					{
					$selected = '';
					
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_title_value) &&  $columns[$i]->Field == $chart_detail->series_title_value){ $selected =' selected="selected"';}
					
					$obj->html .= '<option value="'.$columns[$i]->Field.'"';
					$obj->html .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					
					}
					$obj->html .= '</select></span></td>';
					
			}
			elseif($chart_type=='Geo Charts'){
			
					$obj->html = '';
					$obj->group = '';
                    $obj->orderbycolumn	 = '';
					
                    if($map_mode=='map')
					{
						$obj->html .= '<td><span><label class="hasTip" id="mapinfo-lbl" for="mapinfo" title="'.JText::_("GEO_CHART_SELECT_TYPE_DESC").'">'.JText::_("GEO_CHART_SELECT_TYPE").' </label></span></td><td><span><select class="mapinfo required" name="params[series_mod_name]" id="mapinfo_type" onchange="load_change_functions(this);"><option value="">'.JText::_('GEO_CHART_SELECT_TYPE').'</option>';
					    $selected = '';
					   if($id>0 && $chart_details->vchart_type == $chart_type  && 'latlng' == $chart_detail->series_mod_name){ $selected =' selected="selected"';}
					
					    $obj->html .= '<option value="latlng"';
					    $obj->html .= $selected.'>'.JText::_('GEO_CHART_SELECT_TYPE_LATITUDE_LONGITUDE').'</option>'; $selected = '';
					   if($id>0 && $chart_details->vchart_type == $chart_type  && 'region' == $chart_detail->series_mod_name){ $selected =' selected="selected"';} 
					   $obj->html .= '<option value="region"';
					  $obj->html .= $selected.'>'.JText::_('GEO_CHART_SELECT_TYPE_REGION_BASE').'</option></select></span>';
					   $obj->html .= '<br><span class="map_information"></span></td>';
					   	$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" for="orderbycolumn" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').' </label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>';
					for($i=0;$i<count($columns);$i++)	{
					
					$selected = '';
					
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->orderbycolumn) &&  $columns[$i]->Field == $chart_details->orderbycolumn){ $selected =' selected="selected"';} 
					
					$obj->orderbycolumn .= '<option value="'.$columns[$i]->Field.'"';
					
					$obj->orderbycolumn .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					$selected = '';
					
					
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->groupby) &&  $columns[$i]->Field == $chart_details->groupby){ $selected =' selected="selected"';} 
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					}
					$obj->group .= '</select></span></td>';
					$obj->orderbycolumn .= '</select></span></td>';
					$obj->html .= '</td>';
					}
                    else
					{
					$obj->html = '';
					if($map_mode=='latlng'){
					$obj->html .= '<span><label class="hasTip" id="column_for_latitude-lbl" for="column_for_latitude" title="'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_LATITUDE_DESC").'">'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_LATITUDE").'</label><select class="series_col_nice required" id="column_for_latitude" name="params[series_latitude]"><option value="">'.JText::_('GEO_CHART_SELECT_COLUMN_FOR_LATITUDE').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double' || $type_v[0]=='varchar'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_latitude){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span><br><span><label class="hasTip" id="column_for_longitude-lbl" for="column_for_longitude" title="'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_LONGITUDE_DESC").'">'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_LONGITUDE").'</label><select class="series_col_nice required" id="column_for_longitude" name="params[series_longitude]"><option value="">'.JText::_('Select Column For Longitude').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double' || $type_v[0]=='varchar'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_longitude){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					}
					elseif($map_mode=='region'){ 
					$obj->html = '';
					$obj->html .= '<br><span><label class="hasTip" id="column_for_region-lbl" for="column_for_region" title="'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_REGION_DESC").'">'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_REGION").' </label><select class="series_col_nice required" id="column_for_region" name="params[series_region]"><option value="">'.JText::_('GEO_CHART_SELECT_COLUMN_FOR_REGION').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='varchar'||$type_v[0]=='text'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_region) && $columns[$i]->Field == $chart_detail->series_region){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					
					
					
					}
					
					$obj->html .= '<br><span><label class="hasTip" id="x_axis_columns_info-lbl" for="x_axis_columns_info" title="'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_VALUE_DESC").'">'.JText::_("GEO_CHART_SELECT_COLUMN_FOR_VALUE").' </label><select class="series_col_nice required" name="params[series_markerinfo]" data-type="chartparams_series_x_axis" id="x_axis_columns_info"><option value="">'.JText::_('GEO_CHART_SELECT_COLUMN_FOR_VALUE').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double' || $type_v[0]=='varchar'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_markerinfo){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select><span>'.JText::_("GEOCHART_INOF_AS_DEFINED").'<input type="text" name="params[asdefined]" value="';
					if(isset($chart_detail->asdefined))
					$obj->html .= $chart_detail->asdefined;
					
					$obj->html .= '"></span></span>';
					}					
					
					
			}
			
			elseif($chart_type=='Bubble Chart')
			{
			
					$obj->html = '';
					
					//$obj->html .= '<span class="create_series btn btn-small btn-success">'.JText::_('ADD Series').'</span>';
					$obj->html .= '<td></td><td><span class="chart_bub"><label class="hasTip" id="x_axis_columns-lbl" for="x_axis_columns" title="Select column name for the Label">Select Column for Bubble Label </label><select class="series_col_nice required" name="params[series_bubble_label]" data-type="chartparams_series_bubble_label" id="x_axis_columns" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Bubble Label').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					
					$type_v = explode('(',$columns[$i]->Type);
					//if($type_v[0]=='varchar'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_bubble_label) &&   $columns[$i]->Field == $chart_detail->series_bubble_label ){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';
					}
					
					
					//}
					$obj->html .= '</select></span>'; 
					$obj->html .= '<span class="chart_bub"><label class="hasTip" id="x_axis_columns_region-lbl" for="x_axis_columns_region" title="Select column name for Legend">Select Column for Legend </label><select class="series_col_nice" name="params[series_column_region]" data-type="chartparams_series_region_label" id="x_axis_columns_region" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Legend').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					//if($type_v[0]=='varchar'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type && $id>0 && isset($chart_detail->series_column_region) && $columns[$i]->Field == $chart_detail->series_column_region ){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';
					//}
					
					
					}
					$obj->html .= '</select></span>'; 
					$obj->html .= '<span class="chart_bub"><label class="hasTip" id="x_axis_columns_value-lbl" for="x_axis_columns_value" title="Select column name for  Value">Select Column for Values </label><select class="series_col_nice required" name="params[series_x_axis_column_value]" data-type="chartparams_series_x_axis" id="x_axis_columns_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For  Value').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'|| $type_v[0]=='smallint'|| $type_v[0]=='mediumint'|| $type_v[0]=='bigint'|| $type_v[0]=='decimal'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_x_axis_column_value) &&  $columns[$i]->Field == $chart_detail->series_x_axis_column_value){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';   
					
					
					
					$obj->html .= '<span class="chart_bub"><label class="hasTip" id="x_axis_columns_name-lbl" for="x_axis_columns_name" title="Select column name for the X axis Value">Select Column for X Axis Values </label><select class="series_col_nice required" name="params[series_x_axis]" data-type="chartparams_series_x_axis" id="x_axis_columns_name" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For X Axis Value').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'|| $type_v[0]=='smallint'|| $type_v[0]=='mediumint'|| $type_v[0]=='bigint'|| $type_v[0]=='decimal'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_x_axis) &&   $columns[$i]->Field == $chart_detail->series_x_axis){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					
					
					
					$obj->html .= '<span class="chart_bub"><label class="hasTip" id="y_axis_columns_name-lbl" for="y_axis_columns_name" title="Select column name for the Y axis Value">Select Column for Y Axis Values </label><select class="required" name="params[series_y_axis]" id="y_axis_columns_name" data-type="chartparams_series_y_axis" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column Y Axis Value').'</option>';
					$obj->group = '';
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" for="orderbycolumn" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').' </label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>';
					
					for($i=0;$i<count($columns);$i++)  
					{
					$selected = ''; 
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'|| $type_v[0]=='smallint'|| $type_v[0]=='mediumint'|| $type_v[0]=='bigint'|| $type_v[0]=='decimal'){
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->series_y_axis) &&  $columns[$i]->Field == $chart_detail->series_y_axis){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"';
					$obj->html .= $selected.'>'.$columns[$i]->Field.'</option>';}
					$selected = '';
					if($id>0 && $columns[$i]->Field == $groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					}
					$obj->html .= '</select></span></td>';
					$obj->group .= '</select></span></td>';
					
			
			}
			elseif($chart_type=='Candlestick Charts'){ 
			
					$col0 = '';
					$col1 = '';
					$col2 = '';
					$col3 = '';
					$col4 = '';
					
					$obj->group = '';
					
					$col0 .= '<td></td><td><span class="cand_chart"><label class="hasTip" id="x_axis_columns_label-lbl" for="x_axis_columns_label" title="Select column name for the Title Value">Select Column for Labeling Values </label><select class="required" name="params[labeling_axis_columns_name]" id="x_axis_columns_label" data-type="series_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column X Axis Value').'</option>';
					$col1 .= '<span class="cand_chart"><label class="hasTip" id="x_axis_columns_minimum-lbl" for="x_axis_columns_minimum" title="Select column name for minimum value">Select Column for Minimum Values </label><select class="required" name="params[minimum_axis_columns_name]" id="x_axis_columns_minimum" data-type="minimum_axis_columns_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Minimum Value').'</option>';
					$col2 .= '<span class="cand_chart"><label class="hasTip" id="x_axis_columns_opening-lbl" for="x_axis_columns_opening" title="Select column name for opening value">Select Column for Opening Values </label><select  name="params[opening_axis_columns_name]"  class="required" id="x_axis_columns_opening" data-type="opening_axis_columns_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Opening Value').'</option>';
					$col3 .= '<span class="cand_chart"><label class="hasTip" id="x_axis_columns_closing-lbl" for="x_axis_columns_closing" title="Select column name for the X axis Value">Select Column for closing Values </label><select  name="params[closing_axis_columns_name]" id="x_axis_columns_closing" data-type="closing_axis_columns_value" class="required" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Closing Value').'</option>';
					$col4 .= '<span class="cand_chart"><label class="hasTip" id="x_axis_columns_maximum-lbl" for="x_axis_columns_maximum" title="Select column name for the X axis Value">Select Column for Maximum Values </label><select  name="params[maximum_axis_columns_name]" id="x_axis_columns_maximum" class="required" data-type="maximum_axis_columns_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Maximum Value').'</option>';
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" for="orderbycolumn" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').' </label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>'; 
					
					for($i=0;$i<count($columns);$i++)  
					{
					$selected = '';
					if($id >0 && $chart_details->vchart_type == $chart_type && $columns[$i]->Field == $x_axis_column_name){ $selected =' selected="selected"';}
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='varchar'){
					
					$selected = '';
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->labeling_axis_columns_name) && $columns[$i]->Field == $chart_detail->labeling_axis_columns_name){ $selected =' selected="selected"';}
					
					$col0 .= '<option value="'.$columns[$i]->Field.'"';
					$col0 .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					
					
					}
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'|| $type_v[0]=='smallint'|| $type_v[0]=='mediumint'|| $type_v[0]=='bigint'|| $type_v[0]=='decimal'|| $type_v[0]=='bigint'){
					$selected = '';
					
					if($id >0 &&$chart_details->vchart_type == $chart_type && isset($chart_detail->minimum_axis_columns_name) && $columns[$i]->Field == $chart_detail->minimum_axis_columns_name){ $selected =' selected="selected"';}
					
					$col1 .= '<option value="'.$columns[$i]->Field.'"';
					$col1 .= $selected.'>'.$columns[$i]->Field.'</option>';
					$selected = '';
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->opening_axis_columns_name) && $columns[$i]->Field == $chart_detail->opening_axis_columns_name && $chart_details->vchart_type == $chart_type){ $selected =' selected="selected"';}
					$col2 .= '<option value="'.$columns[$i]->Field.'"';
					$col2 .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					$selected = '';
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->closing_axis_columns_name) && $columns[$i]->Field == $chart_detail->closing_axis_columns_name && $chart_details->vchart_type == $chart_type){ $selected =' selected="selected"';}
					$col3 .= '<option value="'.$columns[$i]->Field.'"';
					$col3 .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					$selected = '';
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->maximum_axis_columns_name) && $columns[$i]->Field == $chart_detail->maximum_axis_columns_name && $chart_details->vchart_type == $chart_type){ $selected =' selected="selected"';}
					$col4 .= '<option value="'.$columns[$i]->Field.'"';
					$col4 .= $selected.'>'.$columns[$i]->Field.'</option>';}
					
					$selected = '';
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->groupby) && $columns[$i]->Field == $chart_details->groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					}
					$col0 .= '</select></span>';
					
					$col1 .= '</select></span>';
					$col2 .= '</select></span>';
					$col3 .= '</select></span>';
					$col4 .= '</select></span></td>';
					$obj->html='';	  
					$obj->html .= $col0.$col1.$col2.$col3.$col4;
					$obj->group .= '</select></span></td>';
			}
			elseif($chart_type=='Timeline Chart'){
			
					$col0 = '';
					$col1 = '';
					$col2 = '';
					$col3 = '';
					
					
					$obj->group = '';
					
					$col0 .= '<td><span class="existing_timeline_chart"><label class="hasTip" id="x_axis_columns_section-lbl" for="x_axis_columns_section" title="Select column name for the Section Value">Select Column for Section Values: </label><select class="required" name="params[labeling_section_columns_name]" id="x_axis_columns_section"><option value="">'.JText::_('Select Column Section Value').'</option>';
					$col1 .= '<td><span class="existing_timeline_chart"><label class="hasTip" id="x_axis_columns_bar-lbl" for="x_axis_columns_bar" title="Select column name for bar label">Select Column for Bar Label: </label><select  class="required" name="params[bar_label_columns_name]" id="x_axis_columns_bar" data-type="series_value" onchange="value_from_existing_database(this);"><option value="">'.JText::_('Select Column For Bar Label').'</option>';
					$col2 .= '<td><span class="existing_timeline_chart"><label class="hasTip" id="x_axis_columns_start_date-lbl" for="x_axis_columns_start_date" title="Select column name for the X axis Value">Select Column for Start Date: </label><select class="required" name="params[start_date_columns_name]" id="x_axis_columns_start_date" data-type="opening_axis_columns_value"><option value="">'.JText::_('Select Column For Start Date').'</option>';
					$col3 .= '<td><span class="existing_timeline_chart"><label class="hasTip" id="x_axis_columns_end_date-lbl" for="x_axis_columns_end_date" title="Select column name for End date">Select Column for End Date: </label><select  class="required" name="params[end_date_columns_name]" id="x_axis_columns_end_date" data-type="closing_axis_columns_value"><option value="">'.JText::_('Select Column For End Date').'</option>';
					
					$obj->group .= '<td><span><label class="hasTip" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY').'</label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_GROUPBY_SELECT').'</option>';
					$obj->orderbycolumn .= '<td><span><label class="hasTip" for="orderbycolumn" title="'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_DESC').'">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING').' </label></td><td><select  name="options[orderbycolumn]" id="orderbycolumn" onchange="update_column_value();"><option value="">'.JText::_('COM_VCHART_SELECT_COLUMN_FOR_ORDERING_SELECT').'</option>'; 
					
					for($i=0;$i<count($columns);$i++)  
					{
					$selected = '';
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='varchar' || $type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'|| $type_v[0]=='smallint'|| $type_v[0]=='mediumint'|| $type_v[0]=='bigint'|| $type_v[0]=='decimal'|| $type_v[0]=='bigint'){
					
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->labeling_section_columns_name) && $columns[$i]->Field == $chart_detail->labeling_section_columns_name){ $selected =' selected="selected"';}
					
					$col0 .= '<option value="'.$columns[$i]->Field.'"';
					$col0 .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					
					
					}
					if($type_v[0]=='varchar' || $type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'|| $type_v[0]=='smallint'|| $type_v[0]=='mediumint'|| $type_v[0]=='bigint'|| $type_v[0]=='decimal'|| $type_v[0]=='bigint'){
					$selected = '';
					
					if($id >0 &&$chart_details->vchart_type == $chart_type && isset($chart_detail->bar_label_columns_name) && $columns[$i]->Field == $chart_detail->bar_label_columns_name){ $selected =' selected="selected"';}
					
					$col1 .= '<option value="'.$columns[$i]->Field.'"';
					$col1 .= $selected.'>'.$columns[$i]->Field.'</option>';}
					$selected = '';
					
					
					if($type_v[0]=='date'||$type_v[0]=='datetime' || $type_v[0]=='timestamp'|| $type_v[0]=='time'|| $type_v[0]=='year'){
					if($id >0 && $chart_details->vchart_type == $chart_type && $columns[$i]->Field == $chart_detail->start_date_columns_name && $chart_details->vchart_type == $chart_type){ $selected =' selected="selected"';}
					$col2 .= '<option value="'.$columns[$i]->Field.'"';
					$col2 .= $selected.'>'.$columns[$i]->Field.'</option>';}
					
					$selected = '';
					
					if($type_v[0]=='date'||$type_v[0]=='datetime' || $type_v[0]=='timestamp'|| $type_v[0]=='time'|| $type_v[0]=='year')
					{
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->end_date_columns_name) && $columns[$i]->Field == $chart_detail->end_date_columns_name && $chart_details->vchart_type == $chart_type){ $selected =' selected="selected"';}
					$col3 .= '<option value="'.$columns[$i]->Field.'"';
					$col3 .= $selected.'>'.$columns[$i]->Field.'</option>';}
					
					$selected = '';
					
					if($id >0 && $chart_details->vchart_type == $chart_type && isset($chart_detail->groupby) && $columns[$i]->Field == $chart_details->groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					}
					
					$col0 .= '</select></span></td>';
					
					$col1 .= '</select></span></td>';
					$col2 .= '</select></span></td>';
					$col3 .= '</select></span></td>';
					
					$obj->html='';	  
					$obj->html .= $col0.$col1.$col2.$col3;
					$obj->group .= '</select></span></td>';
					
			}
			elseif($chart_type=='Table'){
					$obj->html = '';
					$obj->group = '';
				    $obj->group .= '<td><span><label class="hasTip" title="Select column name for Group by in sql query">Select Column For Group By </label></td><td><select  name="groupby" id="groupby" onchange="update_column_value();"><option value="">'.JText::_('Select Column For Group By').'</option>';
					
					for($i=0;$i<count($columns);$i++)   
					{
					
					$selected = '';
					if($id>0 &&$chart_details->vchart_type == $chart_type && $columns[$i]->Field == $groupby){ $selected =' selected="selected"';}
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					
					}
					
					$obj->group .= '</select></span></td>';
					
					
			
			}
			elseif($chart_type=='Maps'){
			
					if($map_mode=='map'){
					$obj->html = '';
					$obj->group = '';	
					$obj->html .= '<td><span><label class="hasTip" id="mapinfo-lbl" for="mapinfo" title="Select mod of information">Select Mod for Information </label></td><td><select class="mapinfo required" name="params[series_mod_name]" id="mapinfo" onchange="load_change_functions(this);"><option value="">'.JText::_('Select Column Mod').'</option>';
					
					
					
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && 'latlng' == $chart_detail->series_mod_name){ $selected =' selected="selected"';}
					
					$obj->html .= '<option value="latlng"';
					$obj->html .= $selected.'>Latitide and Longitide</option>'; $selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && 'region' == $chart_detail->series_mod_name){ $selected =' selected="selected"';} 
					$obj->html .= '<option value="region"';
					$obj->html .= $selected.'>Region base</option>';
					
					$obj->html .= '</select></span><br><span class="map_information"></span></td>';
					
					$obj->group .= '<td><span><label class="hasTip" id="groupby_table_value-lbl" for="groupby_table_value" title="Select column name for Group by in sql query">Select Column For Group By </label></td><td><select  name="groupby_table_value" id="groupby_table_value" onchange="update_column_value();"><option value="">'.JText::_('Select Column For Group By').'</option>';
					for($i=0;$i<count($columns);$i++)	{
					
					$selected = '';
					
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_details->groupby ){ 
					$selected =' selected="selected"';
					} 
					
					$obj->group .= '<option value="'.$columns[$i]->Field.'"';
					$obj->group .= $selected.'>'.$columns[$i]->Field.'</option>';
					}
					
					$obj->group .= '</select></span></td>';
					
					} 
					else{
					$obj->html = '';
					if($map_mode=='latlng'){
					$obj->html .= '<span><label class="hasTip" id="column_for_latitude-lbl" for="column_for_latitude" title="Select column name for Latitude Value">Select Column for Latitude </label><select class="series_col_nice required" id="column_for_latitude" name="params[series_latitude]"><option value="">'.JText::_('Select Column For Latitude').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_latitude){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					$obj->html .= '<br><span><label class="hasTip" id="column_for_longitude-lbl" for="column_for_longitude" title="Select column name for Longitude">Select Column for Longitude </label><select class="series_col_nice required" id="column_for_longitude" name="params[series_longitude]"><option value="">'.JText::_('Select Column For Longitude').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='int'||$type_v[0]=='float' || $type_v[0]=='long'|| $type_v[0]=='double'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_longitude){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					}
					elseif($map_mode=='region'){ 
					$obj->html = '';
					$obj->html .= '<br><span><label class="hasTip" id="column_for_region-lbl" for="column_for_region" title="Select column name that contain region name">Select Column for Region </label><select class="series_col_nice required" id="column_for_region" name="params[series_region]"><option value="">'.JText::_('Select Column For Region').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='varchar'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_region){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					
					
					
					}
					
					$obj->html .= '<br><span><label class="hasTip" id="x_axis_columns_info-lbl" for="x_axis_columns_info" title="Select column name for marker information">Select Column for Marker Info </label><select class="series_col_nice required" name="params[series_markerinfo]" data-type="chartparams_series_x_axis" id="x_axis_columns_info"><option value="">'.JText::_('Select Column Name').'</option>';
					for($i=0;$i<count($columns);$i++)	{ 
					
					$type_v = explode('(',$columns[$i]->Type);
					if($type_v[0]=='varchar'||$type_v[0]=='text'){
					$selected = '';
					if($id>0 && $chart_details->vchart_type == $chart_type  && $columns[$i]->Field == $chart_detail->series_markerinfo){ $selected =' selected="selected"';}
					$obj->html .= '<option value="'.$columns[$i]->Field.'"'.$selected;
					$obj->html .= '>'.$columns[$i]->Field.'</option>';}
					
					
					}
					$obj->html .= '</select></span>';
					
					
					}
			
			}
			$obj->extra_condition_html = '<td></td><td><label class="hasTip btn btn-small btn-success" onclick="add_extra_condition();"><strong>'.JText::_("Extra Condition").'</strong></label><br><textarea name="extra_condition" id="extra_condition" rows="5" cols="5" readonly="readonly">';
			if(isset($chart_details->extra_condition)&& $chart_details->extra_condition!='')
			$obj->extra_condition_html .= $chart_details->extra_condition;
			$obj->extra_condition_html .= '</textarea></td>';
			$obj->limit_value_html = '<td><label class="hasTip required">'.JText::_("Limit for value").'</label></td>       
			<td><input type="text" class="fontsize" name="limit_value" id="limit_value" value="';
			if(isset($chart_details->limit_value)&& $chart_details->limit_value!=''&& $chart_details->limit_value!=0 )
			$obj->limit_value_html .= $chart_details->limit_value;
			$obj->limit_value_html .= '" onchange="update_column_value();" /></td>';
			
			// new changes
			$obj->ordering_value_html = '<td><label class="hasTip">'.JText::_("Ordering of Primery key").'</label></td>      
			<td><select name="ordering" id="ordering_table_value" onchange="update_column_value();">    
			<option value="">'.JText::_("Select Order").'</option>';
			$select = '';
			if(isset($chart_details->ordering) && $chart_details->ordering!=''&& $chart_details->ordering =='asc')
				$select = ' selected="selected"';
			$obj->ordering_value_html .= '<option value="asc"'.$select.'>'.JText::_("Ascending").'</option>';
			$select = '';
			if(isset($chart_details->ordering)&& $chart_details->ordering!=''&& $chart_details->ordering == 'desc')
				$select = ' selected="selected"';
			$obj->ordering_value_html .= '<option value="desc"'.$select.'>'.JText::_("Descending").'</option>
			</select></td>';
			
			
			
			$obj->result = 'success';
		
		return $obj;
	 	}	
	public function value_existing_database()
	{  
	     $obj = new stdClass();
	     $obj->result = 'error';
	     $table_name = JRequest::getVar('table_name', '');
		//$series_column = JRequest::getVar('series_columns', '');
		$x_axis_column = JRequest::getVar('x_axis_column', '');	
		$extra_condition = JRequest::getVar('extra_condition', '');	
		$ordering = JRequest::getVar('ordering', '');
		$groupby = JRequest::getVar('groupby', '');
		$limit_value = JRequest::getVar('limit', '');
		
		$database_type = JRequest::getVar('database_type', '');
		$driver = JRequest::getVar('driver', '');
		$host = JRequest::getVar('host', '');
		$user = JRequest::getVar('user', '');
		$password = JRequest::getVar('password', '');
		$database = JRequest::getVar('database', '');
		$prefix = JRequest::getVar('prefix', '');
		if($database_type == 'chart_data_from_other_database'){
			$option = array(); //prevent problems
			try
			{
			$option['driver']   = $driver;            
			$option['host']     = $host;  
			$option['user']     = $user;  
			$option['password'] = $password; 
			$option['database'] = $database; 
			$option['prefix']   = $prefix;  
 
             $db = JDatabaseDriver::getInstance( $option );
			  $db->connect(); 
			}
			catch (RuntimeException $e)
					{                   
					
					 $obj->result = 'error';
					 $obj->error = $e->getMessage();
					return $obj;
					
					}
			 
		}
		else
		$db = JFactory::getDbo(); 
		
		$query = 'show fields FROM '.$table_name;
		$db->setQuery( $query );
		
		if($this->_db->getErrorNum())	{
			$obj->error = $db->getErrorMsg();
			return $obj;
		}
		
		$columns = $db->loadObjectList();
		  
		
		  $series_val = $axis_val = array();
		  
		//$db = JFactory::getDbo();
		
		
		if($x_axis_column != '' && $table_name != ''){
		$query = 'select '.$db->quotename($x_axis_column).' from '.$db->quotename($table_name);
		 if($extra_condition != ''){
			$query .=  ' WHERE '.$extra_condition; 
			 }
		  if($groupby){$query .= ' GROUP BY '.$db->quotename($groupby); }
		 if($ordering){$query .= ' ORDER BY '.$db->quotename($x_axis_column).' '.$ordering; }
		 
		 if($limit_value){
			 $query .= ' LIMIT '.$limit_value;
			 }
		 
		$db->setQuery($query);
		$axis_v = $db->loadObjectList();
		
		
			for($i=0;$i<count($axis_v);$i++){
			$item = $axis_v[$i];
			$axis_val[$i] = $item->$x_axis_column;
			}
		$obj->axis = implode(',',$axis_val);
		}
		else{
			$obj->axis = '';
			}
		
		
		
		$obj->result = 'success';
		return $obj;
		
	}
	public function value_from_existing_database_extra_condition(){
		$db = JFactory::getDbo();
		$obj = new stdClass();
	   $table_name = JRequest::getVar('table_name', '');
		//$series_column = JRequest::getVar('series_columns', '');
		$x_series_title_column = JRequest::getVar('x_series_title_column', '');	
		$x_series_value_column = JRequest::getVar('x_series_value_column', '');	
		$extra_condition = JRequest::getVar('extra_condition', '');	
		$ordering = JRequest::getVar('ordering', '');	
		$limit_value = JRequest::getVar('limit', '');	
		$group = JRequest::getVar('group', '');	
		
		$query = 'show fields FROM '.$table_name;
		$db->setQuery( $query );
		

		if($this->_db->getErrorNum())	{
			$obj->error = $db->getErrorMsg();
			return $obj;
		}
		
		$columns = $db->loadObjectList();
		  
		  $obj->result = 'error';
		  $series_val = $axis_val = array();
		  
		//$db = JFactory::getDbo();
		
		
			if($x_axis_column != '' && $table_name){
			$query = 'select '.$x_axis_column.' from '.$table_name;
			
			if($extra_condition != ''){
			$query .=  ' WHERE '.$extra_condition; 
			}
		 if($ordering){$query .= ' ORDER BY '.$x_axis_column.' '.$ordering; }
		  if($group){
			 $query .= ' group by '.$group;
			 }
		 if($limit_value){
			 $query .= ' LIMIT '.$limit;
			 }
		 
		$db->setQuery($query);
		$axis_v = $db->loadObjectList();
		
		
			for($i=0;$i<count($axis_v);$i++){
			$item = $axis_v[$i];
			$axis_val[$i] = $item->$x_axis_column;
			}
		$obj->axis = implode(',',$axis_val);
		}
		else{
			$obj->axis = '';
			}
		
		
		
		$obj->result = 'success';
		return $obj;
		
		
		
		}
	public function series_column(){
		$obj = new stdClass();
		$table = JRequest::getVar('table_name', '');
		$id = JRequest::getInt('id', 0);
		$chart_type = JRequest::getVar('chart_type', '');
		$database_type = JRequest::getVar('database_type', '');
		$driver = JRequest::getVar('driver', '');
		$host = JRequest::getVar('host', '');
		$user = JRequest::getVar('user', '');
		$password = JRequest::getVar('password', '');
		$database = JRequest::getVar('database', '');
		$prefix = JRequest::getVar('prefix', '');
		if($database_type == 'chart_data_from_other_database'){
			$option = array(); //prevent problems
			try
			{
			$option['driver']   = $driver;            
			$option['host']     = $host;  
			$option['user']     = $user;  
			$option['password'] = $password; 
			$option['database'] = $database; 
			$option['prefix']   = $prefix;  
 
            $db = JDatabaseDriver::getInstance( $option );
			 $db->connect(); 
			}
			catch (RuntimeException $e)
					{                   
					$obj->error = $e->getMessage();
					return $obj;
					
					}
		}
		else
		$db = JFactory::getDbo();
		
		$ht = $hts = $columns_details= array();
		if($chart_type=='Annotation chart'){
		$query1 = 'show fields FROM '.$this->_db->quotename($table);
		$db->setQuery( $query1 );
		
		if($db->getErrorNum())	{
			$obj->error = $db->getErrorMsg();
			return $obj;
		}
		
		$columns1 = $db->loadObjectList();
		for($i=0;$i<count($columns1);$i++)	{
			 $columns_details[$i] = $columns1[$i]->Field;
			}
		$obj->html_column = $columns_details;
		}
		
		
		 if($chart_type=='Table'){
			$query = 'show fields FROM '.$this->_db->quotename($table);
			}
		 else
		 $query = 'show fields FROM '.$this->_db->quotename($table).' where Type like "int%" or  Type like "long%" or Type like "smallint%" or Type like "double%" or Type like "date%" or Type like "datetime%" or Type like "varchar%" or Type like "tinyint%" or Type like "mediumint%" or Type like "bigint%" or Type like "bigint%" or Type like "decimal%" or Type like "float%"';
		$db->setQuery( $query );
		
		if($db->getErrorNum())	{
			$obj->error = $db->getErrorMsg();
			return $obj;
		}
		
		$columns = $db->loadObjectList();//print_r($columns);
		
		
		
		for($i=0;$i<count($columns);$i++)	{
			 $ht[$i] = $columns[$i]->Field;
		     $type  = explode('(',$columns[$i]->Type);
			 $hts[$i] = 	$type[0];						   
			
		}
	
		$obj->html = $ht;
		
		$obj->column_type = $hts;
		
		//print_r($obj->html); jexit();
		$obj->result = 'success';
		
		return $obj;
		
		}
	
	public function series_data()
	{    $obj = new stdClass();
	     $table_name = JRequest::getVar('table_name', '');
		 $series = JRequest::getVar('series', '');
		  $x_axis_column = JRequest::getVar('x_axis_column', '');	
		  $send_series_data = '';
		 $db = JFactory::getDbo();
		 $obj = new stdClass();
		if($series!=''){
	
		
			 
			
			 $query = 'select '.$series.' from '.$table_name;
			 $db->setQuery($query);
			 $data = $db->loadRowList(); 
			
			 $obj->series = $data;
			
		}
		 
		
		  
		  
		  $obj->result = 'success';
		  return $obj;
	}
	public function getTable($type = 'vcharts', $prefix = 'JTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	function store()
	{
		$row = $this->getTable('Vcharts', 'VchartTable');
		
        jimport('joomla.filesystem.file');
		$data = JRequest::get( 'post' );
        $mainframe = JFactory::getApplication();
		$db		=  JFactory::getDBO();
        $data = JRequest::get( 'post' );
		if(!$data['id'])
		{
			if(!JFactory::getUser()->authorise('core.create','com_vchart'))
			{
			$this->setError(JText::_( 'NOT_AUTHORISED_TO_ADD' ));
		    return false;	
			}
		}
		if($data['id'])
		{
			if(!JFactory::getUser()->authorise('core.edit','com_vchart') && !JFactory::getUser()->authorise('core.edit.own','com_vchart'))
			{
			$this->setError(JText::_( 'NOT_AUTHORISED_TO_EDIT' ));
			return false;	
			}
		}
		
		switch($data['vchart_type']){
			case JText::_('Line Chart'):
			case JText::_('Combo Charts'):
			case JText::_('Area Chart'):
			case JText::_('Stepped AreaChart'):
			case JText::_('Pie Chart'):
			case JText::_('Slice Pie Chart'):
			case JText::_('Donut Pie Chart'):
			case JText::_('Bar Chart'):
			case JText::_('Column Charts'):
			case JText::_('Bubble Chart'):
			case JText::_('Candlestick Charts'):
			case JText::_('Geo Charts'):
			case JText::_('Scatter Chart'):
			case JText::_('Timeline Chart'):
			case JText::_('Maps'):
			case JText::_('Annotation chart'):
			case JText::_('Table'):
			case JText::_('Gauge'):
			case JText::_('Stock Chart'): // new changes
			
				$jFileInput = new JInput($_FILES);
				$theFileb = $jFileInput->get('background_images',array(),'array');
				$type_image = array(".gif",".jpg",".jpeg",".png",".bmp"); 
				
				$file_nameb = $_FILES['background_images']['name'];
				$image_tmp =  $_FILES['background_images']['tmp_name'];
				
				$theFileNameb = $theFileb['name'];
				$tmp_src    = $theFileb['tmp_name'];
				$tmp_dest   = JPATH_COMPONENT_SITE . '/images/background/' . $theFileNameb; 
				
				$ext = strrchr($file_nameb,'.');
				$ext = strtolower($ext);
				
				if(!empty($theFileNameb)){
				if (!in_array( $ext, $type_image )) 
				{
				echo "<script> alert('".JText::_( 'BAD EXTENSION')."'); window.history.go(-1); </script>";
				exit();
				}
				
				if (!is_array($theFileNameb)) {
				$background_image = $theFileNameb;
				}
				$max_size = 4366000; 
				if(filesize($image_tmp) > $max_size){
				echo "<script> alert('".JText::_( 'image size is more')."'); window.history.go(-1); </script>";
				exit();
				}
				
				$this->dataFile = $theFileNameb;
				
				// Move uploaded file
				
				$uploaded = JFile::upload($tmp_src, $tmp_dest);
				if($uploaded==true){
				echo 'image upload';}
				else{
				echo 'image not upload';} 
				}
		
		if($data['vchart_type']=='Maps'){
			
			$jFileInput = new JInput($_FILES);
			$theFile = $jFileInput->get('image',array(),'array');
			$type_image = array(".gif",".jpg",".jpeg",".png",".bmp"); 
			$file_name = $_FILES['image']['name'];
			$image_tmp =  $_FILES['image']['tmp_name'];
			
			$theFileName2 = $theFile['name'];
			$tmp_src    = $theFile['tmp_name'];
			$tmp_dest   = JPATH_COMPONENT_SITE . '/images/markers/selected/' . $theFileName2; 
			$ext = strrchr($file_name,'.');
			$ext = strtolower($ext);
         
			if(!empty($theFileName2)){
			if (!in_array( $ext, $type_image )) 
			{
			echo "<script> alert('".JText::_( 'BAD EXTENSION')."'); window.history.go(-1); </script>";
			exit();
			}
			
			if (!is_array($theFileName2)) {
			$upload_file = $theFileName2;
			}
			$max_size = 4366000; 
			if(filesize($image_tmp) > $max_size){
			echo "<script> alert('".JText::_( 'image size is more')."'); window.history.go(-1); </script>";
			exit();
			}
			
			$this->dataFile = $theFileName2;
			
			// Move uploaded file
			
			$uploaded = JFile::upload($tmp_src, $tmp_dest);
			if($uploaded==true){
			echo 'image upload';}
			else{
			echo 'image not upload';} 
			}
		       $jFileInput = new JInput($_FILES);
                $theFiles = $jFileInput->get('images',array(),'array');
                $type_image = array(".gif",".jpg",".jpeg",".png",".bmp"); 
     
	            $file_name = $_FILES['images']['name'];
                $image_tmp =  $_FILES['images']['tmp_name'];
      
			$theFileName1 = $theFiles['name'];
			$tmp_src    = $theFiles['tmp_name'];
			$tmp_dest   = JPATH_COMPONENT_SITE . '/images/markers/normal/' . $theFileName1; 
	  
			$ext = strrchr($file_name,'.');
			$ext = strtolower($ext);
         
			if(!empty($theFileName1)){
			if (!in_array( $ext, $type_image )) 

			{
			echo "<script> alert('".JText::_( 'BAD EXTENSION')."'); window.history.go(-1); </script>";
			exit();
			}
			
			if (!is_array($theFileName1)) {
			$normal_file = $theFileName1;
			}
			$max_size = 4366000; 
			if(filesize($image_tmp) > $max_size){
			echo "<script> alert('".JText::_( 'image size is more')."'); window.history.go(-1); </script>";
			exit();
			}
			
			$this->dataFile = $theFileName1;
			
			// Move uploaded file
			
			$uploaded = JFile::upload($tmp_src, $tmp_dest);
			if($uploaded==true){
			echo 'image upload';}
			else{
			echo 'image not upload';} 
			}
			}
		
		 if($data['database_type']=='chart_data_from_csv'){
			 if($data['chart_title_option']['remote_csv_url']=='')
			     $data['database_type']='chart_data_manually';
			  
			 }
		 
		 
		
		 $series = $axies = $chart_option = array();
		 $chart_option=JRequest::getVar('options', array(), 'post', 'array');
		 /* $range_value=JRequest::getVar('params[range][value]', array(), 'post', 'array');
		 $color_value=JRequest::getVar('params[range][color]', array(), 'post', 'array'); */
		 
		 
		 
		 if($data['id']){
		 $previous_chart_data = $this->getChart($data['id']);
		 $previous_chart_data = json_decode($previous_chart_data->chart_option);
		 
		 }
		 
		 if($upload_file!=''){
		  $chart_option['selected_marker_path']= $upload_file;}
		 
		 if($normal_file!='')
		 $chart_option['normal_marker_path']= $normal_file;
		  
		 $series = explode(",",$data['series']);
		 $axies  =  explode(",", $data['axis_value']);
         $params = JRequest::getVar('params', array(), 'post', 'array');
	    
		 break;
		 
			
			
			
			}
		 
		 
		  $params['series'] = htmlspecialchars($params['series']);
		  $data['chart_data'] = $this->json_encode_unicode($params);//preg_replace("/\\\\u([a-f0-9]{4})/e", "iconv('UCS-4LE','UTF-8',pack('V', hexdec('U$1')))", json_encode($params));;
		 $data['chart_option'] = $this->json_encode_unicode($chart_option);//str_replace("'", "&apos;", json_encode($chart_option, JSON_UNESCAPED_UNICODE));
		 $data['sstatus'] = 1;
	     $data_area = $data['enter_manually'];
		
		$lines = explode("\n", $data_area);
        $head = str_getcsv(array_shift($lines));

		$array = array(); 
			for($i=0;$i<count($head);$i++)
			   {
				$array[0][$i] = $head[$i]; 
				}
			 foreach ($lines as $line) 
			 {
			 $rows = array_pad(str_getcsv($line), count($head), '');
			 $array[] = $rows;
			   }
	   $data['enter_manually']= json_encode($array); 	
	    if($background_image!=''){
		  $data['chart_title_option']['bacground_image']= $background_image;}
	  
		 $data['chart_title_option']=json_encode($data['chart_title_option']);
		if(isset($data['chart_extra_parms']))
		$data['chart_extra_parms'] = JRequest::getVar('chart_extra_parms', '', 'post', 'string', JREQUEST_ALLOWRAW);    
		
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return 0;
		}

		
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return 0;
		}
		
		
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg() );
			return 0;
		}
      
	 return $row->id;
	}
function json_encode_unicode($data) {
	if (defined('JSON_UNESCAPED_UNICODE')) {
		return json_encode($data, JSON_UNESCAPED_UNICODE);
	}
	return preg_replace_callback('/(?<!\\\\)\\\\u([0-9a-f]{4})/i',
		function ($m) {
			$d = pack("H*", $m[1]);
			$r = mb_convert_encoding($d, "UTF8", "UTF-16BE");
			return $r!=="?" && $r!=="" ? $r : $m[0];
		}, json_encode($data)
	);
}
	function getReferColumns()
	{
		
		$obj = new stdClass();
		$obj->result = 'error';
		
		$table = JRequest::getVar('table', '');
		$column = JRequest::getVar('column', '');
		$id = JRequest::getInt('id', 0);
		
		if(empty($column))	{
			$obj->error = JText::_('PLZ_SEL_COLUMN_FIRST');
			return $obj;
		}
		
		$query = 'show fields FROM '.$table;
		$this->_db->setQuery( $query );
		
		if($this->_db->getErrorNum())	{
			$obj->error = $this->_db->getErrorMsg();
			return $obj;
		}
		
		$columns = $this->_db->loadObjectList();
		
		$query = 'select title, params from #__hd_profile_field where '.$this->_db->quoteName('profileid').' = '.$id.' and '.$this->_db->quoteName('column').' = '.$this->_db->quote($column);
		$this->_db->setQuery( $query );
		$item = $this->_db->loadObject();
		
		
			$params = new stdClass();
		
		
		/*$obj->html = '<span class="label">'.JText::_('REFERENCED_ID').'</span> <select name="params['.$column.'][refid]">';
		
		for($i=0;$i<count($columns);$i++)	{
			$obj->html .= '<option value="'.$columns[$i]->Field.'"';
			if(isset($params->refid) and $columns[$i]->Field==$params->refid)	{
				$obj->html .= ' selected="selected"';
			}
			$obj->html .= '>'.$columns[$i]->Field.'</option>';
		}
		
		$obj->html .= '</select>';*/
		
		$obj->html = ' <span class="label">'.JText::_('REFERENCED_COLUMN').'</span> <select name="params['.$column.'][reftext]">';
		
		for($i=0;$i<count($columns);$i++)	{
			$obj->html .= '<option value="'.$columns[$i]->Field.'"';
			if(isset($params->reftext) and $columns[$i]->Field==$params->reftext)	{
				$obj->html .= ' selected="selected"';
			}
			$obj->html .= '>'.$columns[$i]->Field.'</option>';
		}
		
		$obj->html .= '</select>';
		
		$obj->result = 'success';
		
		return $obj;
		
	}
	
	
	function delete()
	{
		
		if(!JFactory::getUser()->authorise('core.delete','com_vchart')){
	    $this->setError(JText::_( 'NOT_AUTHORISED_TO_DELETE' ));
		return false;	
		}
		
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable('Vcharts', 'VchartTable');

		if (count( $cids ))
		{
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}						
		}
		return true;
	}
function getCsv_fields()
	{
		
		$mainframe = JFactory::getApplication();
		
		$file = JPATH_ADMINISTRATOR.'/components/com_vchart/uploads/data.csv';
		
		if(!is_file($file))	{
			jerror::raiseWarning('', JText::_('PLZ_SELECT_FILE'));
			$mainframe->redirect('index.php?option=com_vchart&view=Vcharts');
		}
	
		if(filesize($file) == 0)	{
			
			jerror::raiseWarning('', JText::_('PLZ_UPLOAD_VALID_CSV_FILE'));
			$mainframe->redirect('index.php?option=com_vchart&view=Vcharts');
		}
		
		$fp = fopen($file, "r");
	
		$invalid = ''; 
	
		$data = fgetcsv($fp, 100000, ",");
		
		return $data;		
		
	}			
   function get_csv_fields()
	{
		
		$dir = JPATH_ADMINISTRATOR.'/components/com_vchart/uploads/data.csv';
		
		jimport('joomla.filesystem.file');
		
		
		$file = JRequest::getVar("file", null, 'FILES', 'array');
	   
		$file_name    = str_replace(' ', '', JFile::makeSafe($file['name']));		
		$file_tmp     = $file["tmp_name"];
	
		$ext = strrchr($file_name, '.');
		
		if(filesize($file_tmp) == 0 and is_file($dir))	{
			return true;
		}
	
		if(filesize($file_tmp) == 0)	{
			$this->setError(JText::_('PLZ_SELECT_FILE'));
			return false;
		}
		
		if($ext <> '.csv')	{
			$this->setError(JText::_('ONLY_CSV'));
			return false;
		}
		
		if(!move_uploaded_file($file_tmp, $dir))	{
			$this->setError(JText::_('FILE_NOT_UPLOADED'));
			return false;
		}
		
		return true;
		
	}
  function get_csv_field()
	{
		
		$dir = JPATH_ADMINISTRATOR.'/components/com_vchart/uploads/data.csv';
		
		jimport('joomla.filesystem.file');
		echo $file_name  =  str_replace(' ', '', JFile::makeSafe(basename($_FILES['file']['name']))); 
		echo $file_tmp = $_FILES['file']['tmp_name']; echo 'zaheer';jexit();
	    $type = $_FILES['file']['type']; // get the type of the file 
        $size = $_FILES['file']['size']; 
		//$file = JRequest::getVar("file", null, 'FILES', 'array');
	    
		//$file_name    = str_replace(' ', '', JFile::makeSafe($file['name']));		
		//$file_tmp     = $file["tmp_name"];
	
		$ext = strrchr($file_name, '.');
		
		if(filesize($file_tmp) == 0 and is_file($dir))	{
			return true;
		}
	
		if(filesize($file_tmp) == 0)	{
			$this->setError(JText::_('PLZ_SELECT_FILE'));
			return false;
		}
		
		if($ext <> '.csv')	{
			$this->setError(JText::_('ONLY_CSV'));
			return false;
		}
		
		if(!move_uploaded_file($file_tmp, $dir))	{
			$this->setError(JText::_('FILE_NOT_UPLOADED'));
			return false;
		}
		
		return true;
		
	}
   function getTableFromOtherDatabase(){
	  
	       
	        $obj = new stdClass();
		    $obj->result = 'error';
		
		$driver = JRequest::getVar('driver', '');
		$host = JRequest::getVar('host', '');
		$id = JRequest::getVar('id', '');
		$user = JRequest::getVar('user', '');
		$password = JRequest::getVar('password', '');
		$database = JRequest::getVar('database', '');
		$prefix = JRequest::getVar('prefix', '');
		$other_databas_table = JRequest::getVar('other_databas_table', '');
		$table_column_name = JRequest::getVar('table_column_name', '');
		$database_type = JRequest::getVar('database_types', '');
		$vchart_type = JRequest::getVar('vchart_type', '');
		
		if($vchart_type==''){
			$obj->html = '';
			$obj->result = 'success';
			return $obj;
			}
		if($id>0){
		$chart_details = $this->getChart($id);}
		else
		$chart_details='';
		
		if($database_type == 'chart_data_from_other_database'){
			$option = array(); //prevent problems
			  
				try
				{
					$option['driver']   = $driver;            // Database driver name
					$option['host']     = $host;    // Database host name
					$option['user']     = $user;       // User for database authentication
					$option['password'] = $password;   // Password for database authentication
					$option['database'] = $database;       // Database name
					
					$option['prefix']   = $prefix;              // Database prefix (may be empty)
					/*if (!@mysql_connect($host, $user, $password, $database))
					{
					$error_message = ' ('.$host.') - '.mysql_error().' ['.mysql_errno().']';
					$obj->result = 'error';
					$obj->error = $error_message;
					return $obj;
					}*/
					$db = JDatabaseDriver::getInstance( $option );
					$db->connect(); 
				}
				catch (RuntimeException $e)
				{ 
					$obj->error = $e->getMessage();
					$obj->result = 'error';
					return $obj;
				
				}
			 
		}
		else{
			 $db = JFactory::getDbo();
			
			}
	    
		
			try
			{
			$query = 'show tables';
			$db->setQuery( $query );
			$items = $db->loadColumn();
			}
			catch (RuntimeException $e)
			{  
			$obj->result = 'error';
			$obj->error = $e->getMessage();
			return $obj;
			
			}
		
		$obj->html = '';
		$obj->htmls ='';
		
	    $obj->html .= '<tr><td width="180"><label id="existing_database_table-lbl" class="hasTip" title="Select table name to show the data" for="existing_database_table"  aria-invalid="false">'.JText::_("Select the table to get the data").'</label></td>
        <td><select class="required svminput" name="existing_database_table" id="existing_database_table" onchange="load_change_function(this);" >';
	   $obj->html .= '<option value="">Select Table</option>';
		for($i=0;$i<count($items);$i++)	{
		
		$table = str_replace($db->getPrefix(), '#__', $items[$i]);
		$select ='';
		if($chart_details!='' && $table == $chart_details->existing_database_table)
		$select = ' selected="selected"';
		
		$obj->html .= '<option value="'.$table.'"'.$select.'>'.$table.'</option>';
		
	}	
				$obj->html .= '</select></td></tr>';
				$obj->html .='<tr class="col_block"></tr>';
				$obj->html .='<tr class="series_block"></tr>';
				$style_variable = '';
				if(isset($chart_details->chart_extra_parms)&& $chart_details->chart_extra_parms!='')
				$style_variable=' style="display:block"';
				else
				$style_variable=' style="display:none"';
				
				if($vchart_type=='Line Chart' || $vchart_type=='Area Chart' || $vchart_type=='Stepped AreaChart' || $vchart_type=='Column Charts' || $vchart_type=='Combo Charts'|| $vchart_type=='Bar Chart')
				{
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_LINE_DETAIL");
				}elseif($vchart_type=='Pie Chart' || $vchart_type=='Slice Pie Chart'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_PIE_DETAIL");
				}elseif($vchart_type=='Timeline Chart'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_TIMELINE_DETAIL");
				}elseif($vchart_type=='Annotation chart'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_ANNOTATION_DETAIL");
				}elseif($vchart_type=='Geo Charts'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_GEO_DETAIL");
				}elseif($vchart_type=='Maps'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_MAPS_DETAIL");
				}elseif($vchart_type=='Candlestick Charts'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_CANDLESTICK_DETAIL");
				}elseif($vchart_type=='Table'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_TABLE_DETAIL");
				}elseif($vchart_type=='Scatter Chart'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_SCATTER_DETAIL");
				}elseif($vchart_type=='Gauge'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_GAUGE_DETAIL");
				}elseif($vchart_type=='Bubble Chart'){
				$query_write_detail_desc = JText::_("COM_VCHART_WRIGHT_SQL_QUERY_BUBBLE_DETAIL");
				}
				
				$obj->html .='<tr><td><label class="hasTip wright_sql_query btn btn-small btn-success" id="chart_extra_parms-lbl" for="chart_extra_parms"><strong>'.JText::_("COM_VCHART_WRIGHT_SQL_QUERY").'</strong></label><br><span class="chart_extra_parms"'.$style_variable.'>'.JText::_($query_write_detail_desc).'</span></td><td><table class="chart_extra_parms"'.$style_variable.'><tr><td><span class="chart_extra_parms"><textarea name="chart_extra_parms" id="chart_extra_parms" class="chart_extra_parms" rows="5" cols="5" onchange="wright_sql_query_result(this);">';
				if(isset($chart_details->chart_extra_parms)&& $chart_details->chart_extra_parms!='')
				$obj->html .= $chart_details->chart_extra_parms;
				$obj->html .= '</textarea></span></td><td><span class="chart_extra_parms">'.JText::_("COM_VCHART_DYNAMIC_VARIABLE_TEXT").'</span></td></tr></table></td></tr><tr class="extra_condition_html"></tr><tr class="limit_value_html"></tr><tr class="ordering_value_html"></tr><tr class="ordering_column_html"></tr><tr class="grouping"></tr>';
	                 //new changes
	            $obj->result = 'success';
		
		return $obj;
	  
	  }
    function value_from_existing_database_sql_query(){ 
				$sql_query = JRequest::getVar('sql_query', '');
				$chart_type = JRequest::getVar('vchart_type', '');
				$database_type = JRequest::getVar('database_type', '');
				$driver = JRequest::getVar('driver', '');
				$host = JRequest::getVar('host', '');
				$user = JRequest::getVar('user', '');
				$password = JRequest::getVar('password', '');
				$database = JRequest::getVar('database', '');
				$prefix = JRequest::getVar('prefix', '');
				if($database_type == 'chart_data_from_other_database'){
				$option = array();
				try
				{
				$option['driver']   = $driver;            
				$option['host']     = $host;  
				$option['user']     = $user;  
				$option['password'] = $password; 
				$option['database'] = $database; 
				$option['prefix']   = $prefix;  
				
				$db = JDatabaseDriver::getInstance( $option );
				 $db->connect(); 
				}
				catch (RuntimeException $e)
					{                   
					$obj->error = $e->getMessage();
					return $obj;
					
					}
				}
				else
				$db = JFactory::getDbo();
				
				$obj = new stdClass();
				$obj->result = 'error';
				$series_val = $axis_val = array();
		
				if($sql_query != '')
				{
						try
						{
						
						$regex = '/{(.*?)}/i';
				        $regex_userid = '/{loggedinuserid}/i';
		   
		                preg_match_all($regex, $sql_query, $matches, PREG_SET_ORDER);
						if($matches)
						{
						$obj->axis = '';
			            $obj->extra_token = 1;
		                $obj->result = 'success';
						return $obj;
						}
						
						$query = $sql_query;
						$db->setQuery($query);
						
						$axis_v = $db->loadObjectList();
						}
						catch (RuntimeException $e)
						{                   
						$obj->error = $e->getMessage();
						return $obj;
						
						}
					$first=$second=$third=$fourth=$fiveth=array();
						for($i=0;$i<count($axis_v);$i++)
						{
						 $item = $axis_v[$i];
						 
						 if($chart_type=='Line Chart' || $chart_type=='Area Chart'|| $chart_type=='Column Charts'|| $chart_type=='Stepped AreaChart'|| $chart_type=='Combo Charts'|| $chart_type=='Bar Chart'|| $chart_type=='Scatter Chart'){$s=1;}
					elseif($chart_type=='Candlestick Charts'){$s=4;}
					elseif($chart_type=='Timeline Chart'){if(count(get_object_vars($item))==3)$s=2;elseif(count(get_object_vars($item))==4)$s=3;elseif(count(get_object_vars($item))==5)$s=4;}
					elseif($chart_type=='Bubble Chart'){if(count(get_object_vars($item))==3)$s=2;elseif(count(get_object_vars($item))==4)$s=3;elseif(count(get_object_vars($item))==5)$s=4;}
					elseif($chart_type=='Annotation chart'){}
					elseif($chart_type=='Donut Pie Chart' || $chart_type=='Pie Chart'|| $chart_type=='Slice Pie Chart'){}
						   $f=0;
							foreach ($item as $key => $value)
							{
							if($chart_type=='Line Chart' || $chart_type=='Area Chart'|| $chart_type=='Column Charts'|| $chart_type=='Stepped AreaChart'|| $chart_type=='Combo Charts'|| $chart_type=='Bar Chart'|| $chart_type=='Scatter Chart'){
							$axis_val[$i] = $value;
							break;}
							elseif($chart_type=='Candlestick Charts'){
								if($f>$s) break;
								
								if($f == 0){
								$first[$i] = $value;}
								elseif($f==1){
								$second[$i] = $value;}
								elseif($f==2){
								$third[$i] = $value;}
								elseif($f==3){
								$fourth[$i] = $value;}
								elseif($f==4){
								$fiveth[$i] = $value;}
								    }
							elseif($chart_type=='Annotation chart'){
								$axis_val[$i] = $value;
							break;
								    }
							elseif($chart_type=='Timeline Chart'){
								$axis_val[$i] = $value;
							     break;
								    }
							elseif($chart_type=='Bubble Chart'){
								if($f>4) break;
								
								if($f == 0){
								$first[$i] = $value;}
								elseif($f == 1){
								$second[$i] = $value;}
								elseif($f == 2){
								$third[$i] = $value;}
								elseif($f == 3){
								$fourth[$i] = $value;}
								elseif($f == 4){
								$fiveth[$i] = $value;}
								    }		
							elseif($chart_type=='Donut Pie Chart' || $chart_type=='Pie Chart'|| $chart_type=='Slice Pie Chart'){
								if($f>1) break;
								if($f == 0){
								$first[$i] = $value;}
								elseif($f == 1){
								$second[$i] = $value;}
								    }
								$f++;	
							}
							
						}
					if($chart_type=='Line Chart' || $chart_type=='Area Chart'|| $chart_type=='Column Charts'|| $chart_type=='Stepped AreaChart'|| $chart_type=='Combo Charts'|| $chart_type=='Bar Chart'|| $chart_type=='Scatter Chart'){
					$obj->axis = implode(',',$axis_val); }
					elseif($chart_type=='Timeline Chart'){ 
					$obj->axis = implode(',',$axis_val);
					}
					elseif($chart_type=='Candlestick Charts'){ 
					$obj->axis0 = implode(',',$first);
					$obj->axis1 = implode(',',$second);
					$obj->axis2 = implode(',',$third);
					$obj->axis3 = implode(',',$fourth);
					$obj->axis4 = implode(',',$fiveth);
					}
					elseif($chart_type=='Bubble Chart'){ 
					$obj->axis0 = implode(',',$first);
					$obj->axis1 = implode(',',$second);
					$obj->axis2 = implode(',',$third);
					$obj->axis3 = implode(',',$fourth);
					$obj->axis4 = implode(',',$fiveth);
					}
					elseif($chart_type=='Donut Pie Chart' || $chart_type=='Pie Chart'|| $chart_type=='Slice Pie Chart'){ 
					$obj->axis1 = implode(',',$first);
					$obj->axis2 = implode(',',$second);
					
					}
					elseif($chart_type=='Annotation chart'){ 
					$obj->axis = implode(',',$axis_val);
					
					}
		       }
		else{
			$obj->axis = '';
			}
		
		
		
		$obj->result = 'success';
		$obj->extra_token = 0;
		return $obj;
	  
	  
	  }
  function publish()
	{
	
		JRequest::checkToken() or jexit( JText::_('Invalid Token') );
		
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		
		$row =& $this->getTable('vcharts', 'VchartTable');
		
		if (!$row->publish($cid, $publish))	{
			$this->setError($row->getError());
			return false;
		}
		else
			return true;
	
	}
	function delete_backgroun_image(){
				$cid		= JRequest::getInt( 'chart_id', 0);
				$image_name		= JRequest::getVar( 'image_name', 'post', '' );
				$obj = new stdClass();
		        $obj->result = 'error';
				$Query = 'SELECT chart_title_option FROM #__vchart where id='.(int)$cid;
				$this->_db->setQuery($Query);
				$item = $this->_db->loadObject();
	  
				$chart_title_detail =  json_decode($item->chart_title_option);
				
				$img = JPATH_SITE.'/components/com_vchart/images/background/'.$chart_title_detail->bacground_image; 
				
				if(!empty($chart_title_detail->bacground_image) and is_file($img)){
				unlink($img);
				$chart_title_detail->bacground_image='';
				$chart_title_detail = json_encode($chart_title_detail);
				$Query = 'update  #__vchart set chart_title_option='.$this->_db->quote($chart_title_detail).' where id='.(int)$cid;
				$this->_db->setQuery($Query);
				$this->_db->query();
				$obj->html = $cid;
				$obj->result = 'success';
				}
	   
	   return $obj; 
	   
	   }
   function getChart($id){
	   $Query = 'SELECT * FROM #__vchart where id='.(int)$id;
	   $this->_db->setQuery($Query);
	   $item = $this->_db->loadObject();
	   
	   return $item;
	   
	   }
}

