<?php 
/*------------------------------------------------------------------------
# com_vChart - Virtual Google Chart
# ------------------------------------------------------------------------
# author    Zaheer Abbas
# copyright Copyright (C) 2013 wwww.wdmtech.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.wdmtech..com
# Technical Support:  Forum - http://www.wdmtech..com/support-forum
-----------------------------------------------------------------------*/
// No direct access
defined('_JEXEC') or die('Restricted Access');


class livechart
{

var $chart_script = '';			// the chart script to be returned
var $chart_data = null;			// the chart data definition structure
var $datasets = array();		// the dataset arrays
var $total_rows = 0;			// total number of rows from all queries
var $chart_title = '';
var $font_style='';


//-------------------------------------------------------------------------------
// Constructor
//
function vchart()

{
	
	    $this->chart_types = array(
		//JText::_('Annotation Charts') =>JText::_('Annotation Charts'), 
		JText::_('CHART_TYPE_LINE')        => JText::_('CHART_TYPE_LINE'),
		JText::_('CHART_TYPE_AREA')        => JText::_('CHART_TYPE_AREA'),
		JText::_('Stepped AreaChart') => JText::_('Stepped Area Chart'),
		JText::_('Timeline Chart')=>JText::_('Timeline Chart'),
		JText::_('Column Charts')=>JText::_('Column Charts'), 
		JText::_('Combo Charts')=>JText::_('Combo Charts'), 
		JText::_('Annotation chart') =>JText::_('Annotation chart'),
	    JText::_('Geo Charts')=>JText::_('Geo Charts'), 
		JText::_('Maps')=>JText::_('Maps'), 
		 JText::_('Candlestick Charts')=>JText::_('Candlestick Charts'), 
		JText::_('CHART_TYPE_PL_TABLE')    => JText::_('CHART_TYPE_PL_TABLE'),
		JText::_('CHART_TYPE_SCATTER')     => JText::_('CHART_TYPE_SCATTER'),
		JText::_('CHART_TYPE_GAUGE')       => JText::_('CHART_TYPE_GAUGE'),
		JText::_('Bubble Chart')    =>JText::_('Bubble Chart'), 
		JText::_('OPTGROUP_START_1')     => JText::_('CHART_TYPE_BAR'), 
		JText::_('CHART_TYPE_BAR') => JText::_('CHART_TYPE_BAR'),
	     JText::_('OPTGROUP_END_1')     => '',
		JText::_('OPTGROUP_START_2')    => JText::_('CHART_TYPE_PIE'), 
		JText::_('CHART_TYPE_PIE_2D')      => JText::_('CHART_TYPE_PIE_2D'),
		JText::_('CHART_TYPE_PIE_SLICE')   => JText::_('CHART_TYPE_PIE_SLICE'),
		JText::_('OPTGROUP_END_2')       => '',
		);
		
	$this->chart_categories = array(
		JText::_('CHART_TYPE_ANY')         => JText::_('CHART_TYPE_ANY'),
		JText::_('CHART_TYPE_SINGLE_ITEM') => JText::_('CHART_TYPE_SINGLE_ITEM'),
		JText::_('CHART_CATEGORY_TABLE')   => JText::_('CHART_TYPE_TABLE'),
		JText::_('CHART_TYPE_LINE')        => JText::_('CHART_TYPE_LINE'),
		JText::_('CHART_TYPE_AREA')        => JText::_('CHART_TYPE_AREA'),
		JText::_('CHART_TYPE_SCATTER')     => JText::_('CHART_TYPE_SCATTER'),
		JText::_('CHART_CATEGORY_BAR')    => JText::_('CHART_TYPE_BAR'),
		JText::_('CHART_CATEGORY_PIE')     => JText::_('CHART_TYPE_PIE'),
		);
     $this->legendTypes = array(
		JText::_('LEGEND_NONE') 	=> JText::_('NONE'),
		JText::_('LEGEND_LEFT') 	=> JText::_('LEGEND_LEFT'),
		JText::_('LEGEND_RIGHT') 	=> JText::_('LEGEND_RIGHT'),
		JText::_('LEGEND_TOP') 		=> JText::_('LEGEND_TOP'),
		JText::_('LEGEND_BOTTOM') 	=> JText::_('LEGEND_BOTTOM'));
	$this->pieTextTypes = array(
		JText::_('PIE_TEXT_NONE') 	 => JText::_('PIE_TEXT_NONE'),
		JText::_('PIE_TEXT_PERCENT') => JText::_('PIE_TEXT_PERCENT'),
		JText::_('PIE_TEXT_VALUE') 	 => JText::_('PIE_TEXT_VALUE'),
		JText::_('PIE_TEXT_LABEL')   => JText::_('PIE_TEXT_LABEL'));
   
   
   
   $this->xDataFormats = array(
		JText::_('FORMAT_NONE')      =>  JText::_('NONE'), 
		JText::_('FORMAT_NUM_UK_0')  =>  "99,999",
		JText::_('FORMAT_NUM_UK_1')  =>  "99,999.9",
		JText::_('FORMAT_NUM_UK_2')  =>  "99,999.99",
		JText::_('FORMAT_DATE_DMY')  =>  JText::_('FORMAT_DATE_DMY'), 
		JText::_('FORMAT_DATE_MDY')  =>  JText::_('FORMAT_DATE_MDY'),
		JText::_('FORMAT_DATE_DMONY')=>  JText::_('FORMAT_DATE_DMONY'),
		JText::_('FORMAT_DATE_DM')   =>  JText::_('FORMAT_DATE_DM'), 
		JText::_('FORMAT_DATE_MD')   =>  JText::_('FORMAT_DATE_MD'),
		JText::_('FORMAT_DATE_MY')   =>  JText::_('FORMAT_DATE_MY'),
		JText::_('FORMAT_DATE_MONY') =>  JText::_('FORMAT_DATE_MONY'),
		JText::_('FORMAT_DATE_Y')    =>  JText::_('FORMAT_DATE_Y'),
		JText::_('FORMAT_DATE_M')    =>  JText::_('FORMAT_DATE_M'),
		JText::_('FORMAT_DATE_MON')  =>  JText::_('FORMAT_DATE_MON'),
		JText::_('FORMAT_DATE_MONTH') => JText::_('FORMAT_DATE_MONTH'),
		JText::_('FORMAT_DATE_D')    =>  JText::_('FORMAT_DATE_D'), 
		JText::_('FORMAT_DATE_DAY')  =>  JText::_('FORMAT_DATE_DAY'),
		JText::_('FORMAT_TIME_HHMM') =>  JText::_('FORMAT_TIME_HHMM'),
		JText::_('FORMAT_TIME_HHMMSS') => JText::_('FORMAT_TIME_HHMMSS'),
		JText::_('FORMAT_TIME_HH')   =>  JText::_('FORMAT_TIME_HH'),
		JText::_('FORMAT_TIME_MM')   =>  JText::_('FORMAT_TIME_MM'),
		JText::_('FORMAT_PERCENT_0') =>  JText::_('FORMAT_PERCENT_0'),
		JText::_('FORMAT_PERCENT_1') =>  JText::_('FORMAT_PERCENT_1'),
		JText::_('FORMAT_PERCENT_2') =>  JText::_('FORMAT_PERCENT_2'));
		
	$this->yDataFormats = array(
		JText::_('FORMAT_NONE')      =>  JText::_('NONE'), 
		JText::_('FORMAT_NUM_UK_0')  =>  "99,999",
		JText::_('FORMAT_NUM_UK_1')  =>  "99,999.9",
		JText::_('FORMAT_NUM_UK_2')  =>  "99,999.99",
		JText::_('FORMAT_NUM_FR_0')  =>  "99 999",
		JText::_('FORMAT_NUM_FR_1')  =>  "99 999,9",
		JText::_('FORMAT_NUM_FR_2')  =>  "99 999,99",
		JText::_('FORMAT_PERCENT_0') =>  JText::_('FORMAT_PERCENT_0'),
		JText::_('FORMAT_PERCENT_1') =>  JText::_('FORMAT_PERCENT_1'),
		JText::_('FORMAT_PERCENT_2') =>  JText::_('FORMAT_PERCENT_2'));
   }
public static function get($path){
		list($group, $class) = explode('.', $path);
		//include_once($class.'.php');
		include_once(JPATH_ADMINISTRATOR.'/components/com_vchart/helper/'.$class.'.php');
		$className = ucfirst($class).ucfirst($group);
		if(!class_exists($className)) return null;
		return new $className();
	}

  public static function csv_data_field($vchart_type){
	  
	  $db = JFactory::getDbo();
		
		$file = JPATH_ADMINISTRATOR.'/components/com_vchart/uploads/data.csv';
		if(!is_file($file))	{
			throw new Exception(JText::_('Please Select File'));
			return false;
		}
	
		if(filesize($file) == 0)	{
			throw new Exception(JText::_('PLZ_UPLOAD_VALID_CSV_FILE'));
			return false;
		}
		
		$fp = fopen($file, "r");
		$insert = array();
		$header = fgetcsv($fp, 100000, ",");
		
         
		while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	{
		
		
			$inserts[] = $data;

	
		}
	
		fclose($fp);
	
		unlink($file);
		
		return true;
	  
	  }


 public static  function data_csv($vchart_type)
	  {$db = JFactory::getDbo();
		$infomode = JRequest::getVar('infomode','');
		$remote_url = JRequest::getVar('remote_url','');
		$data_limit = JRequest::getVar('data_limit','');
		$data_ordering = JRequest::getVar('data_ordering','');
		$obj = new stdClass();
		$obj->result = 'error';
		$required ='';
		$insert = array();
		if($remote_url!='')
		{
			//$content = file_get_contents($remote_url);
			$required = ' required';
			if ($fp = fopen($remote_url, 'r')) {
				//$fp = fopen($remote_url, 'r'); 
				$header = fgetcsv($fp, 100000, ",");
				
				} else {
					$obj->msg = JText::_('Please give correct file url');
				
				return $obj;
			}	
		}
		else {
		$file = JPATH_ADMINISTRATOR.'/components/com_vchart/uploads/data.csv';
		
		
	   if(!is_file($file))	{
			$obj->msg = JText::_('Please Select File');
				
			return $obj;
			
		}
	
		if(filesize($file) == 0)	{
			$obj->msg = JText::_('Please upload csv file');
				
			return $obj;
			
		}
		
	    $fp = fopen($file, "r");
		$header = fgetcsv($fp, 100000, ",");
		}
		
		
		$obj->headers =$header;
		 $flag = 1;
		while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	{
		
			if (array_filter($data)) { 

			$insert[] = $data;
			}
		  
		
			
			}
	     
		fclose($fp);
		
		$chart_id = JRequest::getVar('id','');
		$chart_data  = '';
		if($chart_id)
		    {
			$db = JFactory::getDbo();
			$query = 'select database_type, chart_data, chart_option from #__vchart where id='.(int)$chart_id;
			$db->setQuery($query);
			$chart_data = $db->loadObject();
			
			}
	   if(isset($chart_data->chart_option))
	   $chart_data_option = json_decode($chart_data->chart_option);
	  
		//unlink($file);
		 $obj->html = '<table class="admintable table">';
		 switch ($vchart_type)
		{
		case JText::_('CHART_TYPE_AREA'):
		case JText::_('Combo Charts'):
		case JText::_('Stepped AreaChart'):
		case JText::_('CHART_TYPE_LINE'):
		         $obj->html .= '<ul>';
				for($j=0;$j<count($header);$j++){
				$obj->html .= '<li>';
				
				if($j ==0 ){
					$obj->html .= '<label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_SELECET_COLUMNCHART_COLUMN_HORIZONTAL").'</span><select name="options[column'.$j.']" id ="column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
					}
				else{
					$obj->html .= '<label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_SELECET_COLUMNCHART_COLUMN_FOR_SERIES").$j.'</label><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
					
					}
		
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = 'selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
				
				 $obj->html .='</ul>';
		       
		     break;
			 case JText::_('Stock Chart'): // new changes
		         $obj->html .= '<ul>';
				for($j=0;$j<count($header);$j++){
				$obj->html .= '<li>';
				
				if($j ==0 ){
					$obj->html .= '<label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_SELECET_COLUMNCHART_COLUMN_HORIZONTAL").'</label><select name="options[column'.$j.']" id ="column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
					}
				else{
					$obj->html .= '<label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_SELECET_COLUMNCHART_COLUMN_FOR_SERIES").$j.'</label><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
					
					}
		
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = 'selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
				
				 $obj->html .='</ul>';
		       
		     break;
			case JText::_('Bar Chart'):
			case JText::_('Column Charts'):
		       // $obj->html = '<tr>';
				for($j=0;$j<count($header);$j++){
				$obj->html .= '<tr><td>';
				if($j ==0 ){
					$obj->html .= '<label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_SELECET_COLUMNCHART_COLUMN_HORIZONTAL").'</label></td><td><select name="options[column'.$j.']" id ="column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
					}
				else{
					$obj->html .= '<label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_SELECET_COLUMNCHART_COLUMN_FOR_SERIES").$j.'</label></td><td><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
					
					}
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</td></tr>';}
				
				 //$obj->html .='</tr>';
		       
		     break;
			case 'Annotation chart':
			
			    $obj->html = '<div class="annotation_remote_csv_details">'.JText::_("VCHART_ANNOTATION_FIRST_COLUMN").'</div>';
				$obj->html .= '<ul>';
				for($k=0;$k<3;$k++){
				if($k==0)
				$obj->html .= '<li class="annotation_remote_csv"><label id="series_column0-lbl" for="series_column0">'.JText::_("Select Column for Series Value").'</label>';
				if($k==1)
				$obj->html .= '<li class="annotation_remote_csv"><label>'.JText::_("Select Column for Title").'</label>';
				if($k==2)
				$obj->html .= '<li class="annotation_remote_csv"><label>'.JText::_("Select Column for Text").'</label>';
				
				$obj->html .= '<ul>';
				for($j=0;$j<count($header);$j++){
				
				$obj->html .= '<li>';
				if($k==0){
				$required = $j==0?' required':'';	
				$obj->html .= '<select name="options[series_column'.$j.']" id ="series_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';}
				if($k==1)
				$obj->html .= '<select name="options[title_column'.$j.']" id ="title_column'.$j.'" onchange="update_datafield(this.value)" >';
				if($k==2)
				$obj->html .= '<select name="options[text_column'.$j.']" id ="text_column'.$j.'" onchange="update_datafield(this.value)" >';
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
				     $selected = '';$series_column = 'series_column'.$j;$title_column = 'title_column'.$j;$text_column = 'text_column'.$j;
					if($k==0 && isset($chart_data_option->$series_column) && $header[$i] == $chart_data_option->$series_column)
					$selected = ' selected="selected"';
					if($k==1 && isset($chart_data_option->$title_column) && $header[$i] == $chart_data_option->$title_column)
					$selected = ' selected="selected"';
					if($k==2 && isset($chart_data_option->$text_column) && $header[$i] == $chart_data_option->$text_column)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
				$obj->html .='</ul>'; 
				}
				 $obj->html .='</ul>';
			break;
		   case 'Bubble Chart':
		  $series_column = 'series_column0';
		   $x_column = 'x_column1';
		    $y_column = 'y_column2';
			 $region_column = 'region_column3';
			  $valuet_column = 'valuet_column4';
			$obj->html .= '<ul>';
				for($j=0;$j<5;$j++){
				
				$obj->html .= '<li>'; 
				if($j==0){
				$obj->html .= '<span><label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("Select Column for Label Value").'</label>';
				$obj->html .= '<select name="options[series_column'.$j.']" id ="series_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';}
				if($j==1){
				$obj->html .= '<span ><label id="x_column'.$j.'-lbl" for="x_column'.$j.'" style="display: inline-block;">'.JText::_("Select Column for X value").'</label>';
				$obj->html .= '<select name="options[x_column'.$j.']" id ="x_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';}
				if($j==2){
				$obj->html .= '<span ><label id="y_column'.$j.'-lbl" for="y_column'.$j.'" style="display: inline-block;">'.JText::_("Select Column for Y value").'</label>';
				$obj->html .= '<select name="options[y_column'.$j.']" id ="y_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';}
				if($j==3){
				$obj->html .= '<span ><label id="region_column'.$j.'-lbl" for="region_column'.$j.'" style="display: inline-block;">'.JText::_("Select Column for Legend value").'</label>';
				$obj->html .= '<select name="options[region_column'.$j.']" id ="region_column'.$j.'" onchange="update_datafield(this.value)" >';}
				if($j==4){
				$obj->html .= '<span ><label id="valuet_column'.$j.'-lbl" for="valuet_column'.$j.'" style="display: inline-block;">'.JText::_("Select Column for Value").'</label>';
				$obj->html .= '<select name="options[valuet_column'.$j.']" id ="valuet_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';}
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					
					if($j == 0 && isset($chart_data_option->$series_column) && $header[$i] == $chart_data_option->$series_column)
					$selected = ' selected="selected"';
					if($j == 1 && isset($chart_data_option->$x_column) && $header[$i] == $chart_data_option->$x_column)
					$selected = ' selected="selected"';
					if($j == 2 && isset($chart_data_option->$y_column) && $header[$i] == $chart_data_option->$y_column)
					$selected = ' selected="selected"';
					if($j == 3 && isset($chart_data_option->$region_column) && $header[$i] == $chart_data_option->$region_column)
					$selected = ' selected="selected"';
					if($j == 4 && isset($chart_data_option->$valuet_column) && $header[$i] == $chart_data_option->$valuet_column)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</span></li>';}
				
				 $obj->html .='</ul>';
			break;
            case 'Geo Charts':
		     $obj->html = '<ul>';
			for($j=0;$j<4;$j++){
				$obj->html .= '<li>';
				if($j==0)
				$obj->html .= '<label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_GEOCHART_FIRST_COLUMN_ADDRESS").'</label><select name="options[column'.$j.']" id ="column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
				if($j==1)
				$obj->html .= '<label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_GEOCHART_FIRST_COLUMN_VALUE").'</label><select name="options[column'.$j.']" id ="column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
				if($j==2)
				$obj->html .= '<label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_GEOCHART_SECOND_COLUMN_VALUE").'</label><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==3)
				$obj->html .= '<label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_GEOCHART_URL_COLUMN_VALUE").'</label><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
			   
				
			$obj->html .='</ul>';
		break;
		    case 'Gauge':
		    $obj->html = '<ul>';
			for($j=0;$j<2;$j++){
				if($j==0)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_GAUGE_COLUMN_LABLE").'</label><select name="options[column'.$j.']" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==1)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_GAUGE_COLUMN_VALUE").'</label><select name="options[column'.$j.']" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
			   
			
				
			$obj->html .='</ul>';
		break;
			case 'Candlestick Charts':
		    $obj->html = '<ul>';
			for($j=0;$j<5;$j++){
				if($j==0)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_CANDLESTICK_COLUMN_SERIES").'</label><select name="options[column'.$j.']" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==1)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_CANDLESTICK_COLUMN_MIN").'</label><select name="options[column'.$j.']" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==2)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_CANDLESTICK_COLUMN_OPEN").'</label><select name="options[column'.$j.']" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==3)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_CANDLESTICK_COLUMN_CLOSE").'</label><select name="options[column'.$j.']" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==4)
				$obj->html .= '<li><label id ="column'.$j.'-lbl" for="column'.$j.'" style="display: inline-block;">'.JText::_("VCHART_CANDLESTICK_COLUMN_MAX").'</label><select name="options[column'.$j.']" class="'.$required.'" class="'.$required.'" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
			   
			$obj->html .='</ul>';
		break;
		 case 'Pie Chart':
		    $obj->html = '<ul>';
			for($j=0;$j<2;$j++){
				$obj->html .= '<li>';
				if($j==0)
				$obj->html .= '<span >'.JText::_("Select Column For Label").'</span><select name="options[label_column'.$j.']" class="'.$required.'" id ="label_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
				if($j==1)
				$obj->html .= '<span >'.JText::_("Select Column For Value").'</span><select name="options[value_column'.$j.']" class="'.$required.'" id ="value_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				
				
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'label_column'.$j; $column_value = 'value_column'.$j;
					if($j == 0 && isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
					if($j == 1 && isset($chart_data_option->$column_value) && $header[$i] == $chart_data_option->$column_value)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
			   
			
				
			$obj->html .='</ul>';
		break;
		case 'Scatter Chart':
		
		 $obj->html = '<ul>';
			for($j=0;$j<count($header);$j++){
				if($j==0)
				$obj->html .= '<li><span >'.JText::_("VCHART_SCATTER_COLUMN_X_AXIS").'</span><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j==1)
				$obj->html .= '<li><span >'.JText::_("VCHART_SCATTER_COLUMN_Y_AXIS").'</span><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
				if($j>1)
				$obj->html .= '<li><span >'.JText::_("VCHART_SCATTER_COLUMN_EXTRA_TOOLTIP_INFO").'</span><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';
				 }
			   
			    $obj->html .='</ul>';
				break;
		case 'Table':
		    $obj->html = '<ul>';
			for($j=0;$j<count($header);$j++){
				$obj->html .= '<li>
				<span >'.JText::_("Select Column For Series ".$j).'</span><select name="options[column'.$j.']" id ="column'.$j.'" onchange="update_datafield(this.value)" >';
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					$selected = '';$column_name = 'column'.$j;
					if(isset($chart_data_option->$column_name) && $header[$i] == $chart_data_option->$column_name)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
			   
			
				
			$obj->html .='</ul>';
		break;
		 case 'Timeline Chart':
		
		    $obj->html = '<ul>';
			for($j=0;$j<4;$j++){
				$obj->html .= '<li>';
				if($j==0){
				$obj->html .= '<span >'.JText::_("Label Column ").'</span>';
				$obj->html .= '<select name="options[series_column'.$j.']" id ="series_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';	
					}
				if($j==1){
				$obj->html .= '<span >'.JText::_("Column For Start Date").'</span>';
				$obj->html .= '<select name="options[start_column'.$j.']" id ="start_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';
				}
				if($j==2){
				$obj->html .= '<span >'.JText::_("Column For End Date").'</span>';
				$obj->html .= '<select name="options[end_column'.$j.']" id ="end_column'.$j.'" class="'.$required.'" onchange="update_datafield(this.value)" >';}
				if($j==3){
				$obj->html .= '<span >'.JText::_("Column For Section").'</span>';
				$obj->html .= '<select name="options[section_column'.$j.']" id ="section_column'.$j.'" onchange="update_datafield(this.value)" >';}
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
				  $selected = '';$series_column = 'series_column'.$j;$start_column = 'start_column'.$j;$end_column = 'end_column'.$j;
				  $section_column = 'section_column'.$j;
					if(isset($chart_data_option->$series_column) && $header[$i] == $chart_data_option->$series_column)
					$selected = ' selected="selected"';
				   if(isset($chart_data_option->$start_column) && $header[$i] == $chart_data_option->$start_column)
					$selected = ' selected="selected"';	
					if(isset($chart_data_option->$end_column) && $header[$i] == $chart_data_option->$end_column)
					$selected = ' selected="selected"';	
					if(isset($chart_data_option->$section_column) && $header[$i] == $chart_data_option->$section_column)
					$selected = ' selected="selected"';	
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
			   
			
				
			$obj->html .='</ul>';
		break;
		    case 'Maps':
			
			  if($infomode=='latlng'){
				    $obj->html = '<ul>';
			for($j=0;$j<3;$j++){
				$obj->html .= '<li>';
				if($j==0){
				$obj->html .= '<span >'.JText::_("Select Column For Latitude").'</span>';
				$obj->html .= '<select name="options[latitude_column]" id ="latitude_column" class="'.$required.'" onchange="update_datafield(this.value)" >';	
					}
				if($j==1){
				$obj->html .= '<span >'.JText::_("Select Column For Longitude").'</span>';
				$obj->html .= '<select name="options[longitude_column]" id ="longitude_column" onchange="update_datafield(this.value)" class="'.$required.'" >';
				}
				if($j==2){
				$obj->html .= '<span >'.JText::_("Column For Information").'</span>';
				$obj->html .= '<select name="options[column_value]" id ="column_value" onchange="update_datafield(this.value)" class="'.$required.'" >';}
				
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
				 $selected = '';$latitude_column = 'latitude_column';$longitude_column = 'longitude_column';$column_value = 'column_value';
				 if($j==0 && isset($chart_data_option->$latitude_column) && $header[$i] == $chart_data_option->$latitude_column)
					$selected = ' selected="selected"';
					if($j==1 && isset($chart_data_option->$longitude_column) && $header[$i] == $chart_data_option->$longitude_column)
					$selected = ' selected="selected"';
					if($j==2 && isset($chart_data_option->$column_value) && $header[$i] == $chart_data_option->$column_value)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
				  
				  }
			  if($infomode=='region'){
				    $obj->html = '<ul>';
			for($j=0;$j<2;$j++){
				$obj->html .= '<li>';
				if($j==0){
				$obj->html .= '<span >'.JText::_("Select Column For Region").'</span>';
				$obj->html .= '<select name="options[series_region]" class="'.$required.'" id ="series_region'.$j.'" onchange="update_datafield(this.value)" >';	
					}
				if($j==1){
				$obj->html .= '<span >'.JText::_("Column For Information").'</span>';
				$obj->html .= '<select name="options[column_value]" class="'.$required.'" id ="column_value" onchange="update_datafield(this.value)" >';
				}
				
				
		        $obj->html .= '<option value=""';
			    $obj->html .= '>'.JText::_("Select Column").'</option>';
				for($i=0;$i<count($header);$i++)	{
					 $selected = '';$series_region = 'series_region';$column_value = 'column_value';
					 if($j==0 &&  isset($chart_data_option->$series_region) && $header[$i] == $chart_data_option->$series_region)
					$selected = ' selected="selected"';
					if($j==1 && isset($chart_data_option->$column_value) && $header[$i] == $chart_data_option->$column_value)
					$selected = ' selected="selected"';
			    $obj->html .= '<option value="'.$header[$i].'"'.$selected;
			    $obj->html .= '>'.$header[$i].'</option>';
		         }
				 $obj->html .= '</select>';
				 $obj->html .='</li>';}
				  
				  }
			  
			break;
		case 'CHART_TYPE_SINGLE_ITEM':
		     break;
		default:
		}
		$obj->html .='</table>';
		$obj->result = 'success';
		$insert = $data_ordering!=''&& $data_ordering=='top_bottom'?$insert:array_reverse($insert);
		
		$insert = $data_limit!=''&& $data_limit>0?array_slice($insert,0,$data_limit):$insert;
		$obj->data = $insert;
		//$obj->data = array_reverse($insert);
		 
		return $obj;
		
	}
   public static  function chart_font($value,$label,$name){
	
	$html='';
	$html .='<input placeholder="Font Size" class="fontsize_main" type="text" name="'.$name.'" id ="chart_font"  value="'.$value.'">';
	
	  
	  return $html; 
	}
	
	public static  function chart_fonts($name, $current_value, &$items, $first = 0, $extra='',$text)
    {
	$html ='<span >'.JText::_($text).'</span><select name="'.$name.'" id="'.$name.'" class="inputbox choosen" size="1" '.$extra.'>';
	if ($items == null)
		return '';
	for($i=0;$i<50;$i++)
		{
		
	  $selected = '';
				if ($current_value == $i){
					$selected = ' selected="selected"';
					}
		$html .= "\n".'<option value="'.$i.'"'.$selected.'>'.$i.'</option>';
		}
	$html .= '</select>';
	return $html;
}



  public static  function chart_color($title_color_value, $color, $title,$extra){
	$html='';
	$html .= '<input type="text" class="'.$color.' inputfieldsize" placeholder="'.JText::_("COM_VCHART_FILLCOLOR").'" name="'.$extra.'[chart_backgroud_color]" id="chart_title_colour" value="';
	$html .=isset($title_color_value->chart_backgroud_color)?$title_color_value->chart_backgroud_color:'';
	$html .= '" />';

	$html .= '<input type="text" class="'.$color.' inputfieldsize" placeholder="'.JText::_("COM_VCHART_STROKECOLOR").'" name="'.$extra.'[chart_backgroud_strokecolor]" id="chart_title_colour" value="';
	$html .=isset($title_color_value->chart_backgroud_strokecolor)?$title_color_value->chart_backgroud_strokecolor:'';
	$html .= '" /><input type="text" class="inputfieldsize fontsize" placeholder="'.JText::_("COM_VCHART_STROKEWIDTH").'" name="'.$extra.'[chart_backgroud_strokewidth]" id="chart_title_colour" value="';
																																				$html .= isset($title_color_value->chart_backgroud_strokewidth)?$title_color_value->chart_backgroud_strokewidth:'';
																																				$html .='" />';										
	return $html;
	}
  public static  function chart_font_style($font_styles,$chart_type){
	$font_style = array(
			JText::_("Abadi MT Condensed Light") => JText::_("Abadi MT Condensed Light"),
			JText::_("Albertus Extra Bold") => JText::_("Albertus Extra Bold"),
			JText::_("Albertus Medium") => JText::_("Albertus Medium"),
			JText::_("Allegro") => JText::_("Allegro"),
			JText::_("Amazone BT") => JText::_("Amazone BT"),
			JText::_("AmerType Md BT") => JText::_("AmerType Md BT"),
			JText::_("Antique Olive") => JText::_("Antique Olive"),
			JText::_("Arial") => JText::_("Arial"),
			JText::_("Arial Black") => JText::_("Arial Black"),
			JText::_("Arial MT") => JText::_("Arial MT"),
			JText::_("Arial Narrow") => JText::_("Arial Narrow"),
			JText::_("Arrus BT") => JText::_("Arrus BT"),
			JText::_("Aurora Cn BT") => JText::_("Aurora Cn BT"),
			JText::_("AvantGarde Bk BT") => JText::_("AvantGarde Bk BT"),
			JText::_("AvantGarde Md BT") => JText::_("AvantGarde Md BT"),
			JText::_("Bazooka") => JText::_("Bazooka"),
			JText::_("BankGothic Md BT") => JText::_("BankGothic Md BT"),
			JText::_("Benguiat Bk BT") => JText::_("Benguiat Bk BT"),
			JText::_("BernhardFashion BT") => JText::_("BernhardFashion BT"),
			JText::_("BernhardMod BT") => JText::_("BernhardMod BT"),
			JText::_("BinnerD") => JText::_("BinnerD"),
			JText::_("Bremen Bd BT") => JText::_("Bremen Bd BT"),
			JText::_("Book Antiqua") => JText::_("Book Antiqua"),
			JText::_("Bookman Old Style") => JText::_("Bookman Old Style"),
			JText::_("Boulder") => JText::_("Boulder"),
			JText::_("Calisto MT") => JText::_("Calisto MT"),
			JText::_("Calligrapher") => JText::_("Calligrapher"),
			JText::_("CaslonOpnface BT") => JText::_("CaslonOpnface BT"),
			JText::_("Century Gothic") => JText::_("Century Gothic"),
			JText::_("Century Schoolbook") => JText::_("Century Schoolbook"),
			JText::_("Cezanne") => JText::_("Cezanne"),
			JText::_("CG Omega") => JText::_("CG Omega"),
			JText::_("CG Times") => JText::_("CG Times"),
			JText::_("Charlesworth") => JText::_("Charlesworth"),
			JText::_("Chaucer") => JText::_("Chaucer"),
			JText::_("Charter Bd BT") => JText::_("Charter Bd BT"),
			JText::_("Charter BT") => JText::_("Charter BT"),
			JText::_("ChelthmITC Bk BT") => JText::_("ChelthmITC Bk BT"),
			JText::_("Clarendon Condensed") => JText::_("Clarendon Condensed"),
			JText::_("CloisterBlack BT") => JText::_("CloisterBlack BT"),
			JText::_("Comic Sans MS") => JText::_("Comic Sans MS"),
			JText::_("CopperplGoth Bd BT") => JText::_("CopperplGoth Bd BT"),
			JText::_("Copperplate Gothic Bold") => JText::_("Copperplate Gothic Bold"),
			JText::_("Copperplate Gothic Light") => JText::_("Copperplate Gothic Light"),
			JText::_("Cornerstone") => JText::_("Cornerstone"),
			JText::_("Coronet") => JText::_("Coronet"),
			JText::_("Courier") => JText::_("Courier"),
			JText::_("Courier New") => JText::_("Courier New"),
			JText::_("Cuckoo") => JText::_("Cuckoo"),
			JText::_("Dauphin") => JText::_("Dauphin"),
			JText::_("Denmark") => JText::_("Denmark"),
			JText::_("English 111 Vivace BT") => JText::_("English 111 Vivace BT"),
			JText::_("EngraversGothic BT") => JText::_("EngraversGothic BT"),
			JText::_("Exotc350 Bd BT") => JText::_("Exotc350 Bd BT"),
			JText::_("Fransiscan") => JText::_("Fransiscan"),
			JText::_("Freefrm721 Blk BT") => JText::_("Freefrm721 Blk BT"),
			JText::_("FrnkGothITC Bk BT") => JText::_("FrnkGothITC Bk BT"),
			JText::_("Futura Bk BT") => JText::_("Futura Bk BT"),
			JText::_("Futura Lt BT") => JText::_("Futura Lt BT"),
			JText::_("Futura Md BT") => JText::_("Futura Md BT"),
			JText::_("Futura ZBlk BT") => JText::_("Futura ZBlk BT"),
			JText::_("FuturaBlack BT") => JText::_("FuturaBlack BT"),
			JText::_("Galliard BT") => JText::_("Galliard BT"),
			JText::_("Garamond") => JText::_("Garamond"),
			JText::_("Geneva") => JText::_("Geneva"),
			JText::_("Geometr231 BT") => JText::_("Geometr231 BT"),
			JText::_("Geometr231 Hv BT") => JText::_("Geometr231 Hv BT"),
			JText::_("Geometr231 Lt BT") => JText::_("Geometr231 Lt BT"),
			JText::_("GeoSlab 703 Lt BT") => JText::_("GeoSlab 703 Lt BT"),
			JText::_("GeoSlab 703 XBd BT") => JText::_("GeoSlab 703 XBd BT"),
			JText::_("GoudyHandtooled BT") => JText::_("GoudyHandtooled BT"),
			JText::_("GoudyOLSt BT") => JText::_("GoudyOLSt BT"),
			JText::_("Haettenschweiler") => JText::_("Haettenschweiler"),
			JText::_("Heather") => JText::_("Heather"),
			JText::_("Helvetica") => JText::_("Helvetica"),
			JText::_("Herald") => JText::_("Herald"),
			JText::_("Humanst521 BT") => JText::_("Humanst521 BT"),
			JText::_("Humanst 521 Cn BT") => JText::_("Humanst 521 Cn BT"),
			JText::_("Humanst521 Lt BT") => JText::_("Humanst521 Lt BT"),
			JText::_("Impact") => JText::_("Impact"),
			JText::_("Incised901 Bd BT") => JText::_("Incised901 Bd BT"),
			JText::_("Incised901 BT") => JText::_("Incised901 BT"),
			JText::_("Incised901 Lt BT") => JText::_("Incised901 Lt BT"),
			JText::_("Informal011 BT") => JText::_("Informal011 BT"),
			JText::_("Jester") => JText::_("Jester"),
			JText::_("Kabel Bk BT") => JText::_("Kabel Bk BT"),
			JText::_("Kabel Ult BT") => JText::_("Kabel Ult BT"),
			JText::_("Kaufmann Bd BT") => JText::_("Kaufmann Bd BT"),
			JText::_("Kaufmann BT") => JText::_("Kaufmann BT"),
			JText::_("Korinna BT") => JText::_("Korinna BT"),
			JText::_("Letter Gothic") => JText::_("Letter Gothic"),
			JText::_("Lithograph") => JText::_("Lithograph"),
			JText::_("Lithograph Light") => JText::_("Lithograph Light"),
			JText::_("Long Island") => JText::_("Long Island") ,
			JText::_("Lucida Console") => JText::_("Lucida Console"),
			JText::_("Lucida Handwriting") => JText::_("Lucida Handwriting"),
			JText::_("Lucida Sans") => JText::_("Lucida Sans"),
			JText::_("Lucida Sans Unicode") => JText::_("Lucida Sans Unicode"),
			JText::_("Lydian BT") => JText::_("Lydian BT"),
			JText::_("Marigold") => JText::_("Marigold"),
			JText::_("Market") => JText::_("Market"),
			JText::_("Matisse ITC") => JText::_("Matisse ITC"),
			JText::_("Monotype Corsiva") => JText::_("Monotype Corsiva"),
			JText::_("MS LineDraw") => JText::_("MS LineDraw"),
			JText::_("NewsGoth BT") => JText::_("NewsGoth BT"),
			JText::_("News GothicMT") => JText::_("News GothicMT"),
			JText::_("OCR A Extended") => JText::_("OCR A Extended"),
			JText::_("Old Century") => JText::_("Old Century"),
			JText::_("Onyx BT") => JText::_("Onyx BT"),
			JText::_("OzHandicraft BT") => JText::_("OzHandicraft BT"),
			JText::_("Pegasus") => JText::_("Pegasus"),
			JText::_("Pickwick") => JText::_("Pickwick"),
			JText::_("Poster") => JText::_("Poster"),
			JText::_("PosterBodoni BT") => JText::_("PosterBodoni BT"),
			JText::_("PTBarnum BT") => JText::_("PTBarnum BT"),
			JText::_("Pythagoras") => JText::_("Pythagoras"),
			JText::_("Ribbon131 Bd BT") => JText::_("Ribbon131 Bd BT"),
			JText::_("Sceptre") => JText::_("Sceptre"),
			JText::_("Serifa BT") => JText::_("Serifa BT"),
			JText::_("Serifa Th BT") => JText::_("Serifa Th BT"),
			JText::_("ShelleyVolante BT") => JText::_("ShelleyVolante BT"),
			JText::_("Sherwood") => JText::_("Sherwood"),
			JText::_("Signboard") => JText::_("Signboard"),
			JText::_("Socket") => JText::_("Socket"),
			JText::_("Souvenir Lt BT") => JText::_("Souvenir Lt BT"),
			JText::_("Steamer") => JText::_("Steamer"),
			JText::_("Staccato222 BT") => JText::_("Staccato222 BT"),
			JText::_("Storybook") => JText::_("Storybook"),
			JText::_("Subway") => JText::_("Subway"),
			JText::_("Swis721 BlkEx BT") => JText::_("Swis721 BlkEx BT"),
			JText::_("Swiss911 XCm BT") => JText::_("Swiss911 XCm BT"),
			JText::_("Tahoma") => JText::_("Tahoma"),
			JText::_("Technical") => JText::_("Technical"),
			JText::_("Teletype") => JText::_("Teletype"),
			JText::_("Tempus Sans ITC") => JText::_("Tempus Sans ITC"),
			JText::_("Times") => JText::_("Times"),
			JText::_("Times-Roman") => JText::_("Times-Roman"),
			JText::_("Times New Roman PS") => JText::_("Times New Roman PS"),
			JText::_("Trebuchet MS") => JText::_("Trebuchet MS"),
			JText::_("Tristan") => JText::_("Tristan"),
			JText::_("Tubular") => JText::_("Tubular"),
			JText::_("TypoUpright BT") => JText::_("TypoUpright BT"),
			JText::_("Unicorn") => JText::_("Unicorn"),
			JText::_("Univers") => JText::_("Univers"),
			JText::_("Univers Condensed") => JText::_("Univers Condensed"), 
			JText::_("Vagabond") => JText::_("Vagabond"),
			JText::_("Verdana") => JText::_("Verdana"),
			JText::_("Westminster") => JText::_("Westminster"),
			JText::_("ZapfEllipt BT") => JText::_("ZapfEllipt BT"),
			JText::_("ZapfHumnst BT") => JText::_("ZapfHumnst BT"),
			JText::_("ZapfHumnst Dm BT") => JText::_("ZapfHumnst Dm BT"),
			JText::_("Zurich BlkEx BT") => JText::_("Zurich BlkEx BT"),
			JText::_("Zurich Ex BT") =>JText::_("Zurich Ex BT"));
	        $html='';
	        $html .=JHtml::_ ( 'select.genericlist', $font_style, 'chart_title_option[fontstyle]', $font_styles, 'value', 'text', $font_styles );
	
			return $html;
			}
 public static   function chart_position($chart_postion)
        {
	       $html='';
	    }
public static  function draw_view_stockchart($chart_data)
       {
		   
		   
	   }
 public static  function draw_view_chart($chart_data,$current_limit)
       {
			$obj = new stdClass();
			
			$uniqid 			= $chart_data->id;
			
			$chart_title		= $chart_data->chart_name ;
			$width				= $chart_data->chart_width ;
			$height				= $chart_data->chart_height ;
			$legpos		= $chart_data->legend_position ;
			$chart_type = $chart_type_exist	= $chart_data->vchart_type ;
			//$chartparams		= $chart_data->chart_name $params->get ('chartparams');
			$chart_title_option = json_decode($chart_data->chart_title_option);
			$chart_option = json_decode($chart_data->chart_option);
			
			
			
			
			$chart_data->chart_data = json_decode($chart_data->chart_data);
			
    $options = array();
	if($chart_type=='Line Chart')
	$chart_type='LineChart';
	if($chart_type=='Stepped AreaChart')
	$chart_type='SteppedAreaChart';
	if($chart_type=='Combo Charts')
	$chart_type='ComboChart';
   if($chart_type=='Stock Chart')
	$chart_type='Stock Chart';
	if($chart_type=='Area Chart')
	$chart_type='AreaChart';
	if($chart_type=='Bar Chart')
	$chart_type='BarChart';
	if($chart_type=='Column Charts')
	$chart_type='ColumnChart';
	
	if($chart_type=='Pie Chart')
	$chart_type='PieChart';
	if($chart_type=='Slice Pie Chart')
	$chart_type='PieChart';
	if($chart_type=='Candlestick Charts')
	$chart_type='CandlestickChart';
	if($chart_type=='Geo Charts')
	$chart_type='GeoChart';
	if($chart_type=='Map Charts')
	$chart_type='Map';
	if($chart_type=='Timeline Chart')
	$chart_type='Timeline';
	if($chart_type=='Map Charts')
	$chart_type='Map';
	if($chart_type=='Annotation chart')
	$chart_type='AnnotationChart';
	if($chart_type=='Gauge')
	$chart_type='Gauge';
	
					if(isset($chart_title_option->show_title) && $chart_title_option->show_title!=0)
					{
					array_push($options, 'title: "'.$chart_title.'"');
					$option =   array();
					if(isset($chart_title_option->titlecolor) && $chart_title_option->titlecolor!='')
					array_push($option, 'color: "'.$chart_title_option->titlecolor.'"'); 
					
					if($chart_title_option->fontstyle)
					array_push($option, 'fontName: "'.$chart_title_option->fontstyle.'"');
					
					if(isset($chart_title_option->titlefont))
					array_push($option, 'fontSize: "'.$chart_title_option->titlefont.'"');
					
					if(isset($chart_title_option->titletextstyle->bolds))
					array_push($option, 'bold: 1');
					
					if(isset($chart_title_option->titletextstyle->italic))
					array_push($option, 'italic: 1');
					
					if(count($option)>0)	
					array_push($options, 'titleTextStyle: {'.implode(',',$option).'}');
					
					
					}
				//if(isset($chart_title_option->backgroundColor))
			    //array_push($options, 'backgroundColor:{fill:"'.$chart_title_option->backgroundColor.'",stroke:"#666",strokeWidth:"10px"}'); 
				 $option =  $opt =  $opt1 = $grid = array();
					if(isset($chart_option->x_axis) && $chart_option->x_axis!='')
					{ 
					
					if(isset($chart_option->x_axis_checkedtextstyle->color) && $chart_option->x_axis_checkedtextstyle->color!='')
					array_push($option, 'color: "'.$chart_option->x_axis_checkedtextstyle->color.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->fontsizes) && $chart_option->x_axis_checkedtextstyle->fontsizes!='')
					array_push($option, 'fontSize: "'.$chart_option->x_axis_checkedtextstyle->fontsizes.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->fontstyle) && $chart_option->x_axis_checkedtextstyle->fontstyle!='')
					array_push($option, 'fontName: "'.$chart_option->x_axis_checkedtextstyle->fontstyle.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->bolds) && $chart_option->x_axis_checkedtextstyle->bolds)
					array_push($option, 'bold: "'.$chart_option->x_axis_checkedtextstyle->bolds.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->italic) && $chart_option->x_axis_checkedtextstyle->italic)
					array_push($option, 'italic: "'.$chart_option->x_axis_checkedtextstyle->italic.'"');
					}
					if(isset($chart_option->x_axis_start) && $chart_option->x_axis_start!=''){
						if($chart_option->x_axis_header_type=='string' || $chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
					array_push($opt, 'min:'.$chart_option->x_axis_start);
					    elseif($chart_option->x_axis_header_type=='number'){
							$axis_values = explode(',', $chart_data->chart_data->axis_value);
						array_push($opt, 'min:'.$axis_values[$chart_option->x_axis_start]); }
						   elseif($chart_option->x_axis_header_type=='date' ||  $chart_option->x_axis_header_type=='datetime'){
							   $axis_values = explode(',', $chart_data->chart_data->axis_value);
							   $date_type = strlen(trim($axis_values[$chart_option->x_axis_start]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[$chart_option->x_axis_start]))),'Y').'"';}else{$date_value = date_format(new DateTime($axis_values[$chart_option->x_axis_start]), $date_type);}
						array_push($opt, 'min:new Date('.$date_value.')');
							   }
							 
					}   
					if(isset($chart_option->x_axis_end) && $chart_option->x_axis_end!=''){
				
					if($chart_option->x_axis_header_type=='string' || $chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
					array_push($opt, 'max:'.$chart_option->x_axis_end);
					    elseif($chart_option->x_axis_header_type=='number'){
							$axis_values = explode(',', $chart_data->chart_data->axis_value);
						array_push($opt, 'max:'.$axis_values[$chart_option->x_axis_end]); }
						   elseif($chart_option->x_axis_header_type=='date' ||  $chart_option->x_axis_header_type=='datetime'){
							   $axis_values = explode(',', $chart_data->chart_data->axis_value);
							   $date_type = strlen(trim($axis_values[$chart_option->x_axis_end]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[$chart_option->x_axis_end]))),'Y').'"';}else{$date_value = date_format(new DateTime($axis_values[$chart_option->x_axis_end]), $date_type);}
						array_push($opt, 'max:new Date('.$date_value.')');
							   }
							  
					
					
					}
					if(count($opt)>0)
					array_push($opt1, 'viewWindow:{'.implode(',',$opt).'}');
					
					if(isset($chart_option->x_axis_grid_color_trans) && $chart_option->x_axis_grid_color_trans!='')
					array_push($grid, 'color: "transparent"');
					elseif(isset($chart_option->x_axis_grid_color) && $chart_option->x_axis_grid_color!='')
					array_push($grid, 'color: "'.$chart_option->x_axis_grid_color.'"');
					if(isset($chart_option->x_axis_grid_number) && $chart_option->x_axis_grid_number!='')
					array_push($grid, 'count:'.$chart_option->x_axis_grid_number);
					
					if(count($grid)>0)
					array_push($opt1, 'gridlines:{'.implode(',',$grid).'}');
					
					if(isset($chart_option->slantedTextAngle) && $chart_option->slantedTextAngle!='')
					array_push($opt1, 'slantedText:true');
					if(isset($chart_option->x_axis_minimum) && $chart_option->x_axis_minimum!='')
					array_push($opt1, 'minValue:'.$chart_option->x_axis_minimum);
					if(isset($chart_option->x_axis_maximum) && $chart_option->x_axis_maximum!='')
					array_push($opt1, 'maxValue:'.$chart_option->x_axis_maximum);
					if(isset($chart_option->x_axis) && $chart_option->x_axis!='')
					array_push($opt1, 'title: "'.$chart_option->x_axis.'"');
					if(count($option)>0)
					array_push($opt1, 'titleTextStyle: {'.implode(',',$option).'}');
				  if(isset($chart_option->data_flow_direction) && $chart_option->data_flow_direction==-1)
				    array_push($opt1, 'direction: -1');
				
					if (isset($chart_option->horizontal_type) && $chart_option->horizontal_type!=''){


					$prefix = isset($chart_option->x_axis_prefix)&&$chart_option->x_axis_prefix!=''?$chart_option->x_axis_prefix:'';
					$suffix = isset($chart_option->x_axis_suffix)&&$chart_option->x_axis_suffix!=''?$chart_option->x_axis_suffix:'';
					array_push($opt1, 'format: "'.$prefix.''.$chart_option->horizontal_type.''.$suffix.'"');
					}
					if(count($opt1)>0)
					array_push($options, 'hAxis: {'.implode(',',$opt1).'}');
					if(isset($chart_option->crosshair) && $chart_option->crosshair!='')
			          array_push($options, 'crosshair:{trigger:"'.$chart_option->crosshair.'"}');
					 $option =  $opt =  $opt1 = $grid = array();
					
					if (isset($chart_option->y_axis) && $chart_option->y_axis!='')
					{ 
					if(isset($chart_option->y_axis_checkedtextstyle->color)&& $chart_option->y_axis_checkedtextstyle->color!='')
					array_push($option, 'color: "'.$chart_option->y_axis_checkedtextstyle->color.'"');
					if(isset($chart_option->y_axis_checkedtextstyle->fontsizes)&& $chart_option->y_axis_checkedtextstyle->fontsizes!='')
					array_push($option, 'fontSize: '.$chart_option->y_axis_checkedtextstyle->fontsizes);
					if(isset($chart_option->y_axis_checkedtextstyle->fontstyle) && $chart_option->y_axis_checkedtextstyle->fontstyle!='')
					array_push($option, 'fontName: "'.$chart_option->y_axis_checkedtextstyle->fontstyle.'"');
					if(isset($chart_option->y_axis_checkedtextstyle->bolds) && $chart_option->y_axis_checkedtextstyle->bolds)
					array_push($option, 'bold: 1');
					if(isset($chart_option->y_axis_checkedtextstyle->italic) && $chart_option->y_axis_checkedtextstyle->italic)
					array_push($option, 'italic: 1');
					}
					if(isset($chart_option->y_axis_start) && $chart_option->y_axis_start!='')
					array_push($opt, 'min: '.$chart_option->y_axis_start);
					if(isset($chart_option->y_axis_end) && $chart_option->y_axis_end!='')
					array_push($opt, 'max:'.$chart_option->y_axis_end);
					if(count($opt)>0)
					array_push($opt1, 'viewWindow:{'.implode(',',$opt).'}');
					if(isset($chart_option->y_axis_grid_color_trans) && $chart_option->y_axis_grid_color_trans!='')
					array_push($grid, 'color: "transparent"');
					elseif(isset($chart_option->y_axis_grid_color) && $chart_option->y_axis_grid_color!='')
					array_push($grid, 'color: "'.$chart_option->y_axis_grid_color.'"');
					if(isset($chart_option->y_axis_grid_number) && $chart_option->y_axis_grid_number!='')
					array_push($grid, 'count:'.$chart_option->y_axis_grid_number);
					
					if(count($grid)>0)
					array_push($opt1, 'gridlines:{'.implode(',',$grid).'}');
					//array_push($opt1, 'slantedText:true');
					if(isset($chart_option->y_axis_minimum) && $chart_option->y_axis_minimum!='')
					array_push($opt1, 'minValue: '.$chart_option->y_axis_minimum);
					if(isset($chart_option->y_axis_maximum) && $chart_option->y_axis_maximum!='')
					array_push($opt1, 'maxValue:'.$chart_option->y_axis_maximum);
					if (isset($chart_option->y_axis) && $chart_option->y_axis!='')
					array_push($opt1, 'title: "'.$chart_option->y_axis.'"');
					if(count($option)>0)
					array_push($opt1, 'titleTextStyle: {'.implode(',',$option).'}');
					
					if (isset($chart_option->y_axis_formate) && $chart_option->y_axis_formate!=''){
					$prefix = isset($chart_option->y_axis_prefix)&&$chart_option->y_axis_prefix!=''?$chart_option->y_axis_prefix:'';
					$suffix = isset($chart_option->y_axis_suffix)&&$chart_option->y_axis_suffix!=''?$chart_option->y_axis_suffix:'';
					
					array_push($opt1, 'format: "'.$prefix.''.$chart_option->y_axis_formate.''.$suffix.'"');}
					if(count($opt1)>0)
					array_push($options, 'vAxis: {'.implode(',',$opt1).'}');
				
				         $option = array();
						if(isset($chart_option->legend)&& $chart_option->legend!=''){
							
							if($chart_type=='Bubble Chart'){
								  if($chart_option->legend!='left')
								    array_push($option, 'position:"'.$chart_option->legend.'"');
								}
							else
							array_push($option, 'position:"'.$chart_option->legend.'"');
							
							}
						
						
						
						if(isset($chart_option->legendtextstyle)){
						$opt = array();
						if(isset($chart_option->legendtextstyle->color) && $chart_option->legendtextstyle->color!='')
						array_push($opt, 'color: "'.$chart_option->legendtextstyle->color.'"'); 
						
						if($chart_option->legendtextstyle->fontstyle)
						array_push($opt, 'fontName: "'.$chart_option->legendtextstyle->fontstyle.'"');
						
						if(isset($chart_option->legendtextstyle->fontsizes) && $chart_option->legendtextstyle->fontsizes!='')
						array_push($opt, 'fontSize: "'.$chart_option->legendtextstyle->fontsizes.'"');
						
						if(isset($chart_option->legendtextstyle->bolds))
						array_push($opt, 'bold: 1');
						
						if(isset($chart_option->legendtextstyle->italic))
						array_push($opt, 'italic: 1');
						
						// array_push($option, 'alignment:"end"');
						if(count($opt)>0)
						array_push($option, 'textStyle: {'.implode(',',$opt).'}');
						}
					if(count($option)>0)
					array_push($options, 'legend: {'.implode(',',$option).'}');
		$c_y = ''; $color_array =array();
		if(isset($chart_data->chart_data->series_column_color)&&$chart_data->chart_data->series_column_color!=''){
		
		$c_y = explode(',',trim($chart_data->chart_data->series_column_color));
		
		if(count($c_y)>0)
		array_push($options, 'colors: ["'.implode('","',$c_y).'"]');
		}
		   if(isset($chart_option->x_axis_start)&&$chart_option->x_axis_start!='' && isset($chart_option->x_axis_end)&&$chart_option->x_axis_end!='')
		     array_push($options, ' animation:{duration: 1000, easing: \'in\' }');
			 if(isset($chart_option->selection_mode_value) && $chart_option->selection_mode_value!='')
			 array_push($options, 'selectionMode:"'.$chart_option->selection_mode_value.'"');
    $new_live_chart_data ='';
	switch($chart_type)	{
	
	case 'AreaChart':
	case 'LineChart':
	case 'ComboChart':
	$package = 'corechart';

			if(isset($chart_option->chart_churve) && $chart_option->chart_churve!='')
			array_push($options, ' curveType: "function"');
			
			//array_push($options, ' animation:{duration:3500,easing:"inAndOut"}');
			if(isset($chart_option->pointshape) && $chart_option->pointshape!='')
			array_push($options, ' pointShape: "'.$chart_option->pointshape.'"');
			
			if(isset($chart_option->linewidth) && $chart_option->linewidth!='')
			array_push($options, ' lineWidth: '.$chart_option->linewidth);
			$line_width_array = array();
			
			if(isset($chart_option->series_linewidth) && count($chart_option->series_linewidth)>0){
			for($i=0;$i<count($chart_option->series_linewidth);$i++){
			if(isset($chart_option->series_linewidth[$i]) && $chart_option->series_linewidth[$i]!='')
			array_push($line_width_array, ' {lineWidth: '.$chart_option->series_linewidth[$i].'}');
			}
			if(count($line_width_array)>0)
			array_push($options, ' series: ['.implode(',',$line_width_array).']');
			}

 
			if(isset($chart_option->pointsize) && $chart_option->pointsize!='')
			array_push($options, ' pointSize: '.$chart_option->pointsize);
			
			if(isset($chart_option->isStacked) && $chart_option->isStacked!='')
			array_push($options, ' isStacked: true');
			if(isset($chart_option->connectSteps) && $chart_option->connectSteps!='')
			array_push($options, ' connectSteps: true');
			
			
			if(isset($chart_option->orientation) && $chart_option->orientation!='')
			array_push($options, ' orientation: "'.$chart_option->orientation.'"');
			
			if(isset($chart_data->chart_data->chartparams))
			{
				array_push($options, 'seriesType: "bars"'); 
				$series_type = array();
				for($z=0;$z<count($chart_data->chart_data->chartparams->stype);$z++){
				
				array_push($series_type, $z.' : {type: "'.$chart_data->chart_data->chartparams->stype[$z].'"}');
				}
				array_push($options, 'series: {'.implode(',',$series_type).'}'); 
			}
			$items = array();
		
		//if($chart_type=='LineChart'){
			
			$label = isset($chart_option->x_axis)?$chart_option->x_axis:'ID';
			if(isset($chart_option->x_axis_header_type))
			$item = '[{type:"'.$chart_option->x_axis_header_type.'", label:"'.$label.'"}, "'.implode('", "', explode(',', $chart_data->chart_data->series)).'"]';
			else
			$item = '[{type:"string", label:"'.$label.'"}, "'.implode('", "', explode(',', $chart_data->chart_data->series)).'"]';
			
			array_push($items, $item);
			$item='';
			$axis_values = explode(',', $chart_data->chart_data->axis_value);
			$series = explode(',', $chart_data->chart_data->series);
		//echo $chart_data->database_type.' zaheer'; jexit();
		
		if($chart_data->database_type=='chart_data_manually'){
		
		for($i=0;$i<count($axis_values);$i++)	{
			
			$item = '[';
			if(isset($chart_option->x_axis_header_type)){
			     if($chart_option->x_axis_header_type=='date'||$chart_option->x_axis_header_type=='datetime'){
					 $date_type = strlen(trim($axis_values[$i]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[$i]))),'Y').'"';}else{ 
			if(strpos($axis_values[$i], ':')!== false && strpos($axis_values[$i], ':')<11){
					$axis_values[$i] = str_replace(':', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 
					}
					if(strpos($axis_values[$i], '/')!== false){
					$axis_values[$i] = str_replace('/', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 	
					}
					
				 $date_value = date_format(new DateTime($axis_values[$i]), $date_type);
			     $update_date = explode(',', $date_value);
                 $date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
				 }
				  $item .= 'new Date('.$date_value.')';}
			       elseif($chart_option->x_axis_header_type=='number')
				    $item .= trim($axis_values[$i]);
				     else
			          $item .= '"'.trim($axis_values[$i]).'"';}
					  else
					  $item .= '"'.trim($axis_values[$i]).'"';
			// 
			   for($j=0;$j<count($series);$j++)	{
			   
				$item .= ', '.(float)$chart_data->chart_data->data[$j][$i];
				
			
			  }
			$item .= ']';
			
			
			array_push($items, $item);
		}	
		$data = implode(',', $items); 
		}
		elseif($chart_data->database_type=='chart_data_from_csv'){
			$chart_title_options = json_decode($chart_data->chart_title_option);
			$remote_url = $chart_title_options->remote_csv_url;
			
			$insert = array();
		try
		{
			//$content = file_get_contents($remote_url);
			
			if ($fp = fopen($remote_url, 'r')) {
				//$fp = fopen($remote_url, 'r'); 
				$header = fgetcsv($fp, 100000, ",");
				while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
				{
				if (array_filter($data)) { 

			      $insert[] = $data;
			     }
				
				
				}
				
				fclose($fp);
				
				
				} 
			
		$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
		$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
		$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
		
		for($i=0;$i<count($insert);$i++)	{
			$column_name_for_value = 'column0';
			 $horzontal_value_index = array_search($chart_option->$column_name_for_value, $header);
			
			$item = '[';
			if(isset($chart_option->x_axis_header_type)){
			     if($chart_option->x_axis_header_type=='date'||$chart_option->x_axis_header_type=='datetime'){
					 $date_type = strlen(trim($insert[$i][$horzontal_value_index]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$insert[$i][$horzontal_value_index]))),'Y').'"';}else{
				
				if(strpos($axis_values[$i], ':')!== false && strpos($axis_values[$i], ':')<11){
					$axis_values[$i] = str_replace(':', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 
					}
					if(strpos($axis_values[$i], '/')!== false){
					$axis_values[$i] = str_replace('/', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 	
					}
					
				 $date_value = date_format(new DateTime($axis_values[$i]), $date_type);
			     $update_date = explode(',', $date_value);
                 $date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
				
				}
				  $item .= 'new Date('.$date_value.')';}
			       elseif($chart_option->x_axis_header_type=='number')
				    $item .= trim($insert[$i][$horzontal_value_index]);
				     else
			          $item .= '"'.trim($insert[$i][$horzontal_value_index]).'"';}
					  else
					  $item .= '"'.trim($insert[$i][$horzontal_value_index]).'"';
			// 
			   for($j=0;$j<count($series);$j++)	{
			    $series_value_index = array_search($series[$j], $header);
				$item .= ', '.(float)$insert[$i][$series_value_index];
				
			
			  }
			$item .= ']';
			
			
			array_push($items, $item);
		}	
		$data = implode(',', $items); 
		
		}
		catch (RuntimeException $e)
				{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
				
				}
		
			
			}
		elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
		    
		     $series_column_detail = explode(',', $chart_data->chart_data->series_column_name);
			
			 $item = self::data_from_existing_database($chart_data,$axis_values,$series_column_detail,$chart_option,$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
		if($item->result=='error')
		{return $item;}
	  
		$data = $item->data;
		$new_live_chart_data = $item->data;
		$new_data_live = $item->data;
		}
      
	break;
	
	case 'SteppedAreaChart':
	$package = 'corechart';
			  
						//array_push($options, 'hAxis: {title: "'.$chart_data->chart_option->x_axis.'",');
					
		   
		   if(isset($chart_option->isStacked)&& $chart_option->isStacked!='' )
           array_push($options, ' isStacked: true');
		   if(isset($chart_option->enableInteractivity)&& $chart_option->enableInteractivity!='' )
           array_push($options, ' enableInteractivity: true');
		   
		    if(isset($chart_option->connectSteps)&& $chart_option->connectSteps!='' )
           array_push($options, ' connectSteps: true');
		  
		    
		   
		   if(isset($chart_option->orientation)&& $chart_option->orientation!='')
		   array_push($options, ' orientation: "'.$chart_option->orientation.'"');
		   
	
	
	
	$items = array();
	$series = explode(',', $chart_data->chart_data->series);
	
	
		
	//$item = '["Date",';
			  
	
	if($chart_data->database_type=='chart_data_manually'){
		$data_loop = count($chart_data->chart_data->data);
			$item = '["ID","'.implode('","',$series).'"]';
	
	array_push($items, $item);
		$axis_values = explode(',', $chart_data->chart_data->axis_value);
		for($i=0;$i<count($axis_values);$i++){
			$item ='["'.$axis_values[$i].'",';
			for($j=0;$j<count($series);$j++){
					
					if($j==0)
					{
					
					$item .= $chart_data->chart_data->data[$j][$i].',';
					}
					else
					{																			 
					
						if($j==(count($axis_values)-1))
						$item .= isset($chart_data->chart_data->data[$j][$i])?$chart_data->chart_data->data[$j][$i].',':',';
						else
						$item .= isset($chart_data->chart_data->data[$j][$i])?$chart_data->chart_data->data[$j][$i].',':',';
					}
					
						
						}
						$item .= ']';
		
			
		
		array_push($items, $item);

		}
		$data = implode(',', $items);
		}
		elseif($chart_data->database_type=='chart_data_from_csv'){
			$chart_title_options = json_decode($chart_data->chart_title_option);
			$remote_url = $chart_title_options->remote_csv_url;
			
			$insert = array();
		try
		{
			
			$item = '["ID","'.implode('","',$series).'"]';
	
	    array_push($items, $item);
		
			
			if ($fp = fopen($remote_url, 'r')) {
				//$fp = fopen($remote_url, 'r'); 
				$header = fgetcsv($fp, 100000, ",");
				while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
				{
				
				if (array_filter($data)) { 

			      $insert[] = $data;
			     }
				
				}
				
				fclose($fp);
				
				
				} 
		$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
		$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
		$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
		for($i=0;$i<count($insert);$i++)	{
			$column_name_for_value = 'column0';
			 $horzontal_value_index = array_search($chart_option->$column_name_for_value, $header);
			
			$item = '[';
			
			    $item .= '"'.trim($insert[$i][$horzontal_value_index]).'"';
		
			   for($j=0;$j<count($series);$j++)	{
			    $series_value_index = array_search($series[$j], $header);
				$item .= ', '.(float)$insert[$i][$series_value_index];
				
			
			  }
			$item .= ']';
			
			
			array_push($items, $item);
		}	
		$data = implode(',', $items); 
		
		}
		catch (RuntimeException $e)
				{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
				
				}
		
			
			}
		elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
			$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
			if($items->result=='error')
		{return $items;}
		
		$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
		
	
	break;
	case 'ColumnChart':
	case 'BarChart':
			
				$package = 'corechart';
				
				
				
				if(isset($chart_option->bargroupwidth)&& $chart_option->bargroupwidth!='')
				array_push($options, 'bar: {groupWidth:"'.$chart_option->bargroupwidth.'%"}');
				
				if(isset($chart_option->isStacked)&& $chart_option->isStacked!='')
				array_push($options, 'isStacked: true');
				if(isset($chart_option->show_3d)&& $chart_option->show_3d!=''&& $chart_option->show_3d==1){
				array_push($options, 'is3D: true');$package = 'columnchart';
				}
				$title_option = json_decode($chart_data->chart_title_option);
				
               
				if(isset($chart_option->orientation)&& $chart_option->orientation!=''){
					if(isset($chart_option->x_axis_start) && $chart_option->x_axis_start!='' && isset($chart_option->x_axis_end) && $chart_option->x_axis_end!='')
					{            
					array_push($options, ' orientation: "horizontal"');
					}
				  else
				  array_push($options, ' orientation: "'.$chart_option->orientation.'"');
				}
				
				$items = array();
			
				if(isset($chart_data->chart_data->row_styles) || isset($chart_data->chart_data->range))
				{   $animation =0;
                   $option_series = array();
                    $data_series = explode(',', $chart_data->chart_data->series);
                    $k = count($data_series);
                    for($i=0;$i<$k;$i++){
                    $b_data = $data_series[$i];
					
					 
				   
					
                    if((isset($chart_data->chart_data->rolestyle[$i])||(isset($chart_data->chart_data->range) && count($data_series)<2))&& $chart_option->show_3d!=1){
						
	                 if(isset($chart_data->chart_data->rolestyle[$i]->animation) &&$chart_data->chart_data->rolestyle[$i]->animation!='' ){
                    $b_data = '"'.$b_data.'", {role:"style"}, {role:"annotation"}';$animation=1;}
					  else
					  $b_data = '"'.$b_data.'", {role:"style"}';}
                    else
                    $b_data = '"'.$b_data.'"';
                    array_push($option_series,$b_data);
                    
                    }
					
					$x_axis_label = isset($chart_option->x_axis)&&$chart_option->x_axis!=''? $chart_option->x_axis:'';
                    $x_axis_header_type = isset($chart_option->x_axis_header_type)&& $chart_option->x_axis_header_type!=''? '{type:"'.$chart_option->x_axis_header_type.'",label:"'.$x_axis_label.'"}':'"label"';
                    $item = '['.$x_axis_header_type.', '.implode(', ', $option_series).']';
				}
				
				
				else
				
				{
				$x_axis_label = isset($chart_option->x_axis)&&$chart_option->x_axis!=''? $chart_option->x_axis:'';
                    $x_axis_header_type = isset($chart_option->x_axis_header_type)&& $chart_option->x_axis_header_type!=''? '{type:"'.$chart_option->x_axis_header_type.'",label:"'.$x_axis_label.'"}':'"label"';
				$item = '['.$x_axis_header_type.', "'.implode('", "', explode(',', $chart_data->chart_data->series)).'"]';
				}
				
				array_push($items, $item);
				if($chart_data->database_type=='chart_data_manually'){
				$axis_values = explode(',', $chart_data->chart_data->axis_value);
				$series = explode(',', $chart_data->chart_data->series);$legend_color = array();
				
				for($i=0;$i<count($axis_values);$i++)	{
			   
			$item = '[';
			if(isset($chart_option->x_axis_header_type)){
			     
				 if($chart_option->x_axis_header_type=='date'||$chart_option->x_axis_header_type=='datetime'){
					  $date_type = strlen($axis_values[$i])>4?'Y,m,d,H,i,s':'Y';
				if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[$i]))),'Y').'"';
				}else
				{
					if(strpos($axis_values[$i], ':')!== false && strpos($axis_values[$i], ':')<11){
					$axis_values[$i] = str_replace(':', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 
					}
					if(strpos($axis_values[$i], '/')!== false){
					$axis_values[$i] = str_replace('/', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 	
					}
					
					$date_value = date_format(new DateTime($axis_values[$i]), $date_type);
					$update_date = explode(',', $date_value);
					$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
					}
				  $item .= 'new Date('.$date_value.')';}
			       elseif($chart_option->x_axis_header_type=='number')
				    $item .= trim($axis_values[$i]);
				     else
			          $item .= '"'.trim($axis_values[$i]).'"';}
					  else
					  $item .= '"'.trim($axis_values[$i]).'"';
				
				
				for($j=0;$j<count($series);$j++)	{
				
				$item .= ', '.(float)$chart_data->chart_data->data[$j][$i];
				
				
				$option = array();
				if(isset($chart_data->chart_data->rolestyle[$j])&& $chart_data->chart_data->rolestyle[$j]!='')
				$rols_style_data = $chart_data->chart_data->rolestyle[$j];
				if(isset($rols_style_data->stroke_color)&& $rols_style_data->stroke_color!='')
				array_push($option,'stroke-color:'.str_replace("'","",$rols_style_data->stroke_color));
				if(isset($rols_style_data->stroke_opacity)&& $rols_style_data->stroke_opacity!='')
				array_push($option,'stroke-opacity:'.$rols_style_data->stroke_opacity);
				if(isset($rols_style_data->stroke_width)&& $rols_style_data->stroke_width!='')
				array_push($option,'stroke-width:'.$rols_style_data->stroke_width);
				$fill_colors =2;
				if(isset($chart_data->chart_data->range)){
				
				for($k=0;$k<count($chart_data->chart_data->range->value);$k++){
				$fill_color = '';$fill_colors =3;
				   $value = $chart_data->chart_data->range->value[$k];
					if($chart_data->chart_data->data[$j][$i]<=$value){
					$fill_color = $chart_data->chart_data->range->color[$k]; 
					break;
					}
				}
				}
		      if($fill_colors!=2 && count($series)<2){
				
				array_push($option,'fill-color:'.$fill_color);
				array_push($color_array,$fill_color);
				  
				}
			  elseif(isset($rols_style_data->fill_color)&& $rols_style_data->fill_color!=''){
				array_push($option,'fill-color:'.$rols_style_data->fill_color);
				
				}
				
				if(isset($rols_style_data->fill_opacity)&& $rols_style_data->fill_opacity!='')
				array_push($option,'fill-opacity:'.$rols_style_data->fill_opacity);
				
				if(count($option)>0&& $chart_option->show_3d!=1)
				$item .= ", '".implode('; ' ,  $option)."'";
			    $option_n = array();
				if(isset($rols_style_data->animation) && $rols_style_data->animation!='' && $animation==1 && $chart_option->show_3d!=1)
				array_push($option_n, $rols_style_data->animation);
				/*elseif(count($option)>0 && $chart_option->show_3d!=1)
				array_push($option_n, '');*/
				if(count($option_n)>0&& $chart_option->show_3d!=1)
				$item .= ", '".implode(", " ,  $option_n)."'";
				
				}
				
				$item .= ']';
				
				array_push($items, $item);
				
				}
				$data = implode(',', $items);
				}
				elseif($chart_data->database_type=='chart_data_from_csv')
				{
					$items = array();
					 $axis_values = explode(',', $chart_data->chart_data->axis_value);
				     $series = explode(',', $chart_data->chart_data->series);
					 $legend_color = array();
					
					 if(isset($chart_data->chart_data->range) && count($series)==1){
					 $item = '["ID","'.implode('","',$series).'", {role:"style"}]';
					
                    }
					else
					 $item = '["ID","'.implode('","',$series).'"]';
					
					array_push($items, $item);
					$chart_title_options = json_decode($chart_data->chart_title_option);
			        $remote_url = $chart_title_options->remote_csv_url;
			
			         $insert = array();
					try
					{
									
					
						
						if ($fp = fopen($remote_url, 'r')) {
							//$fp = fopen($remote_url, 'r'); 
							$header = fgetcsv($fp, 100000, ",");
							while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
							{
							
							if (array_filter($data)) { 

			               $insert[] = $data;
			                 }
							
							}
							
							fclose($fp);
							
							
							} 
					
				$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
				$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
				$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;	
		 for($i=0;$i<count($insert);$i++)	{
		
		
			$column_name_for_value = 'column0';
			$horzontal_value_index = array_search($chart_option->$column_name_for_value, $header);
			
			
			$item = '[';
			
			if(isset($chart_option->x_axis_header_type)){
			     
				 if($chart_option->x_axis_header_type=='date'||$chart_option->x_axis_header_type=='datetime'){
					  $date_type = strlen($insert[$i][$horzontal_value_index])>4?'Y,m,d,H,i,s':'Y';
				if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$insert[$i][$horzontal_value_index]))),'Y').'"';}else{
				if(strpos($axis_values[$i], ':')!== false && strpos($axis_values[$i], ':')<11){
					$axis_values[$i] = str_replace(':', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 
					}
					if(strpos($axis_values[$i], '/')!== false){
					$axis_values[$i] = str_replace('/', '-', $axis_values[$i]);
					//$axis_values[$i] = date('Y-m-d', strtotime($date)); 	
					}
					
				 $date_value = date_format(new DateTime($axis_values[$i]), $date_type);
			     $update_date = explode(',', $date_value);
                 $date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
				}
				  $item .= 'new Date('.$date_value.')';}
			       elseif($chart_option->x_axis_header_type=='number')
				    $item .= trim($insert[$i][$horzontal_value_index]);
				     else
			          $item .= '"'.trim($insert[$i][$horzontal_value_index]).'"';}
					  else
					  $item .= '"'.trim($insert[$i][$horzontal_value_index]).'"';
				
				
				for($j=0;$j<count($series);$j++)	{
				  $series_value_index = array_search($series[$j], $header);
				  $item .= ', '.(float)$insert[$i][$series_value_index];
				
				
			
				   $fill_color = '';
						
						if(isset($chart_data->chart_data->range) && count($series) == 1)
						{
							for($k=0;$k<count($chart_data->chart_data->range);$k++)
							{
							$fill_color = '';$fill_colors = 3;
							       $value = $chart_data->chart_data->range->value[$k];
								   
								    if($insert[$i][$series_value_index]<=$value){
										 
									$fill_color = $chart_data->chart_data->range->color[$k]; 
									break;
									}
							   }
						}
		     
				 if($fill_color!='' && count($series)==1)
				   {
					$item .= ", 'fill-color:".$fill_color."'";
					
					}
			 
				
				}
				
				$item .= ']';
				
				array_push($items, $item);
				
				}
				$data = implode(',', $items);
              
				}
				catch (RuntimeException $e)
						{                   
							$obj->result = 'error';
							$obj->error = $e->getMessage(); 
							return $obj;
						
						}
			
					}
				elseif($chart_data->database_type=='chart_data_from_existing'||$chart_data->database_type=='chart_data_from_other_database'){$items=self::data_from_existing_database($chart_data,'','',$chart_option,$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);if($items->result=='error')
				{return $items;}
				$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
				
				}
				
				break;
	    case 'Gauge':
				if(isset($chart_option->majorTicks)&& $chart_option->majorTicks!='')
				array_push($options, ' majorTicks: ["'. implode('", "', explode(',',$chart_option->majorTicks)).'"]');
				if(isset($chart_option->minorTicks)&& $chart_option->minorTicks!='')
				array_push($options, ' minorTicks: '.$chart_option->minorTicks);
				if(isset($chart_option->gauge_red)&& $chart_option->gauge_red!='')
				array_push($options, ' redColor: "'.$chart_option->gauge_red.'"');
				if(isset($chart_option->gauge_green)&& $chart_option->gauge_green!='')
				array_push($options, ' greenColor: "'.$chart_option->gauge_green.'"');
				if(isset($chart_option->gauge_yellow)&& $chart_option->gauge_yellow!='')
				array_push($options, ' yellowColor: "'.$chart_option->gauge_yellow.'"');
				
				if(isset($chart_option->greenfrom)&& $chart_option->greenfrom!='')
				array_push($options, ' greenFrom: '.$chart_option->greenfrom);
				if(isset($chart_option->greento)&& $chart_option->greento!='')
				array_push($options, ' greenTo: '.$chart_option->greento);
				
				if(isset($chart_option->yellowfrom)&& $chart_option->yellowfrom!='')
				array_push($options, ' yellowFrom: '.$chart_option->yellowfrom);
				if(isset($chart_option->yellowto)&& $chart_option->yellowto!='')
				array_push($options, ' yellowTo: '.$chart_option->yellowto);
				
				if(isset($chart_option->redfrom)&& $chart_option->redfrom!='')
				array_push($options, ' redFrom: '.$chart_option->redfrom);
				if(isset($chart_option->redto)&& $chart_option->redto!='')
				array_push($options, ' redTo: '.$chart_option->redto);
			
			if(isset($chart_option->gauge_minimum)&& $chart_option->gauge_minimum!='')
				array_push($options, ' min: '.$chart_option->gauge_minimum);
			if(isset($chart_option->gauge_maximum)&& $chart_option->gauge_maximum!='')
				array_push($options, ' max: '.$chart_option->gauge_maximum);
				
				array_push($options, ' animation:{duration: 1000, easing: "inAndOut" }');
		$items = array();
		
		
		
		  
		 if($chart_data->database_type=='chart_data_manually'){
			 $series = explode(',', $chart_data->chart_data->series);
			 $item = '[';
			
		$item .= isset($chart_option->label_title) && $chart_option->label_title!=''?'"'.$chart_option->label_title.'",':'"Label",';
		$item .= isset($chart_option->value_title) && $chart_option->value_title!=''?'"'.$chart_option->value_title.'"':'"value"';
		$item .= ']';
		
		array_push($items, $item);
		for($i=0;$i<count($series);$i++)
		{
			
			$item = '["'.trim($series[$i]).'", '.(float)$chart_data->chart_data->data[$i].']';
		
			array_push($items, $item);
		
		}
		$data = implode(',', $items);
		}
		elseif($chart_data->database_type=='chart_data_from_csv'){
			$series = explode(',', $chart_data->chart_data->series);
			        $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
					try
					{
					$item = '[';
			
					$item .= isset($chart_option->label_title) && $chart_option->label_title!=''?'"'.$chart_option->label_title.'",':'"Label",';
					$item .= isset($chart_option->value_title) && $chart_option->value_title!=''?'"'.$chart_option->value_title.'"':'"value"';
					$item .= ']';
					
					array_push($items, $item);
					
					
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data)) { 

			          $insert[] = $data;
			         }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					$label_column = 'column0';$value_column = 'column1';
					$label_column = array_search($chart_option->$label_column, $header);
					$value_column = array_search($chart_option->$value_column, $header);
					
					for($i=0;$i<count($insert);$i++)	{
					
					
					$item = '[';
					
					$item .= '"'.trim($insert[$i][$label_column]).'"';
					
					$item .= ', '.(float)$insert[$i][$value_column];
					
				
					$item .= ']';
					
					
					array_push($items, $item);
					}	
					$data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
			}
		elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
				$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
				
				if($items->result=='error')
				{return $items;}
				
				$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
		
		 
		$package = 'gauge';  
	break;
	case 'PieChart':
	
					$package = 'corechart';
					//echo 'colors: ["'. implode('", "', explode(',', $chart_data->chart_data->series_column_name)).'"]';
					if(isset($chart_option->pie_3d))
					array_push($options, ' is3D: true');
					
					if(isset($chart_data->chart_data->series_column_color)&& $chart_data->chart_data->series_column_color!='')
					array_push($options, ' colors: ["'. implode('", "', explode(',', $chart_data->chart_data->series_column_color)).'"]');
					
					/*if(isset($chart_option->pie_3d))
					array_push($options, ' is3D: true');*/
					if(isset($chart_option->piehole)&&$chart_option->piehole!='')
					array_push($options, ' pieHole: '.$chart_option->piehole);
					
					if(isset($chart_option->pieslice_label))
					array_push($options, ' pieSliceText: "'.$chart_option->pieslice_label.'"');
					$slice_value = $slice_offset_value = array();
					if(isset($chart_option->slice_value))
					$slice_value = explode(',',$chart_option->slice_value);
					if(isset($chart_option->slice_offset_value))
					$slice_offset_value = explode(',',$chart_option->slice_offset_value);
					if(isset($chart_option->slice_offset_value) && isset($chart_option->slice_value)){
					$option = array(); 
					for($i=0;$i<count($slice_value);$i++){
					array_push($option, $slice_value[$i].': { offset:'.$slice_offset_value[$i].'}');
					
					}
					array_push($options, 'slices:{'.implode(',', $option).'}');
					}

		
		      $items = array();
		
		$series = explode(',', $chart_data->chart_data->series);
		
		
		
		if($chart_data->database_type=='chart_data_manually'){
			$item = '[';
			
		$item .= isset($chart_data->chart_data->label_title) && $chart_data->chart_data->label_title!=''?'"'.$chart_data->chart_data->label_title.'",':'"Label",';
		$item .= isset($chart_data->chart_data->value_title) && $chart_data->chart_data->value_title!=''?'"'.$chart_data->chart_data->value_title.'"':'"value"';
		$item .= ']';
			array_push($items, $item);
		for($i=0;$i<count($series);$i++)
		{
			
			$item = '["'.trim($series[$i]).'", '.(float)$chart_data->chart_data->data[$i].']';
		
			array_push($items, $item);
		
		}

		$data = implode(',', $items);
		}
		elseif($chart_data->database_type=='chart_data_from_csv')
				
				{
					
					
					$chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
					try
					{
					$item = '[';
			
					$item .= isset($chart_data->chart_data->label_title) && $chart_data->chart_data->label_title!=''?'"'.$chart_data->chart_data->label_title.'",':'"Label",';
					$item .= isset($chart_data->chart_data->value_title) && $chart_data->chart_data->value_title!=''?'"'.$chart_data->chart_data->value_title.'"':'"value"';
					$item .= ']';
					
					array_push($items, $item);
					
					
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					$label_column = 'label_column0';$value_column = 'value_column1';
					$label_column = array_search($chart_option->$label_column, $header);
					$value_column = array_search($chart_option->$value_column, $header);
					
					for($i=0;$i<count($insert);$i++)	{
					
					
					$item = '[';
					
					$item .= '"'.trim($insert[$i][$label_column]).'"';
					
					$item .= ', '.(float)$insert[$i][$value_column];
					
				
					$item .= ']';
					
					
					array_push($items, $item);
					}	
					$data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
				}
		elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
			$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
			if($items->result=='error')
				{return $items;}
				
				$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
		
		
		
	break;
	case 'Donut Pie Chart':
	
		$package = 'corechart';
		
		
		 if(isset($chart_option->piehole))
		 array_push($options, ' pieHole: '.$chart_option->piehole);
		 if(isset($chart_option->pieslice_label))
		   array_push($options, ' pieSliceText: "'.$chart_option->pieslice_label.'"');
		
		$items = array();
		
		$series = explode(',', $chart_data->chart_data->series);
		$item = '[';
				  $item .= isset($chart_data->chart_data->label_title)&&$chart_data->chart_data->label_title!=''? '"'.$chart_data->chart_data->label_title.'",':'"Label"';
				  $item .= isset($chart_data->chart_data->value_title)&&$chart_data->chart_data->value_title!=''? '"'.$chart_data->chart_data->value_title.'"':'"Value"';
				  $item .= ']';
		
		
		array_push($items, $item);
		
		for($i=0;$i<count($series);$i++)	{
			
			$item = '["'.$series[$i].'", '.(float)$chart_data->chart_data->data[$i].']';
		
			array_push($items, $item);
		
		}
		
			$data = implode(',', $items);
			$chart_type = 'PieChart';
			break;
			
		case 'Bubble Chart':
				$package = 'corechart';
				$items = array();
				$bubble = array();
				$series = explode(',', $chart_data->chart_data->series);
				if(isset($chart_option->bubble_min_radius) && $chart_option->bubble_min_radius!='')
				array_push($bubble, ' minSize: '.$chart_option->bubble_min_radius);
				if(isset($chart_option->bubble_max_radius) && $chart_option->bubble_max_radius!='')
				array_push($bubble, ' maxSize: '.$chart_option->bubble_max_radius);
				if(count($bubble)>0)
				array_push($options, ' sizeAxis:{ '.implode(',',$bubble).'}');
		  
	          
				
				if($chart_data->database_type=='chart_data_manually'){
					 $item = '';
				$item .= '[';
				$item .= isset($chart_option->header_lable_title) && $chart_option->header_lable_title!='' ?'"'.$chart_option->header_lable_title.'"':'"ID"';
				$item .= isset($chart_option->header_x_axis_title) && $chart_option->header_x_axis_title!='' ?',"'.$chart_option->header_x_axis_title.'"':',"X Axis Value"';
				$item .= isset($chart_option->header_y_axis_title) && $chart_option->header_y_axis_title!='' ?',"'.$chart_option->header_y_axis_title.'"':',"Y Axis Value"';
				if(isset($chart_option->header_region_title) && $chart_option->header_region_title!='')
				$item .= ',"'.$chart_option->header_region_title.'"';
				
				$item .= isset($chart_option->header_value_title) && $chart_option->header_value_title!='' ?',"'.$chart_option->header_value_title.'"':',"Value"';
				$item .= ']';
				array_push($items, $item);
					
					
					$s = 0;$r = 1;$t=2;$u=3;$v=4;
					
					for($i=0;$i<count($series);$i++){
						$new_data = $chart_data->chart_data->data[$i];
						$item = '["'.$new_data[0].'",';
						$item .= (float)$new_data[1].',';
						$item .= (float)$new_data[2];
						if(isset($chart_option->header_region_title) && $chart_option->header_region_title!=''){
						$item .= ',"'.$new_data[3].'"';}
						$item .= ','.(float)$new_data[4];
						$item .= ']';
						
						
						
						array_push($items, $item);
					}
					$data = implode(',', $items);
				}
				elseif($chart_data->database_type=='chart_data_from_csv')
				
				{
					$chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
					try
					{
					
					$item = '';
					$item .= '[';
					$item .= isset($chart_option->header_lable_title) && $chart_option->header_lable_title!='' ?'"'.$chart_option->header_lable_title.'"':'"ID"';
					$item .= isset($chart_option->header_x_axis_title) && $chart_option->header_x_axis_title!='' ?',"'.$chart_option->header_x_axis_title.'"':',"X Axis Value"';
					$item .= isset($chart_option->header_y_axis_title) && $chart_option->header_y_axis_title!='' ?',"'.$chart_option->header_y_axis_title.'"':',"Y Axis Value"';
					if(isset($chart_option->header_region_title) && $chart_option->header_region_title!='')
					$item .= ',"'.$chart_option->header_region_title.'"';
					
					$item .= isset($chart_option->header_value_title) && $chart_option->header_value_title!='' ?',"'.$chart_option->header_value_title.'"':',"Value"';
					$item .= ']';
					array_push($items, $item);
					
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					
					$series_column = 'series_column0';$x_column1 = 'x_column1';$y_column2 = 'y_column2';$region_column3 = 'region_column3';$valuet_column4 = 'valuet_column4';
					$series_column = array_search($chart_option->$series_column, $header);
					$x_column1 = array_search($chart_option->$x_column1, $header);
					$y_column2 = array_search($chart_option->$y_column2, $header);
					$region_column3 = array_search($chart_option->$region_column3, $header); 
					$valuet_column4 = array_search($chart_option->$valuet_column4, $header);
					for($i=0;$i<count($insert);$i++)	{
					
					
					$item = '[';
					
					$item .= '"'.trim($insert[$i][$series_column]).'"';
					
					$item .= ', '.(float)$insert[$i][$x_column1];
					$item .= ', '.(float)$insert[$i][$y_column2];
					if($region_column3)
					$item .= ', "'.trim($insert[$i][$region_column3]).'"';
					$item .= ', '.(float)$insert[$i][$valuet_column4];
					
					
				
					$item .= ']';
					
					
					array_push($items, $item);
					}	
					$data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
				}
				elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
				
				$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
				if($items->result=='error')
				{return $items;}
				
				$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
				}
			
			$chart_type = 'BubbleChart';
			break;
	
	case 'AnnotationChart':
	  $package = 'annotationchart';
	 if(isset($chart_option->allowHtml)&& $chart_option->allowHtml!='' )
	array_push($options, 'allowHtml:true');
	if(isset($chart_option->allValuesSuffix)&& $chart_option->allValuesSuffix!='' )
	array_push($options, 'allValuesSuffix:"'.$chart_option->allValuesSuffix.'"');
	 if(isset($chart_option->annotationsWidth)&& $chart_option->annotationsWidth!='')
	array_push($options, 'annotationsWidth:'.$chart_option->annotationsWidth);
	 if(isset($chart_option->displayAnnotations)&& $chart_option->displayAnnotations!='' )
	array_push($options, 'displayAnnotations:true'); 
	else
	array_push($options, 'displayAnnotations:false'); 
	if(isset($chart_option->displayAnnotationsFilter)&& $chart_option->displayAnnotationsFilter!='' )
	array_push($options, 'displayAnnotationsFilter:true');
	else
	array_push($options, 'displayAnnotationsFilter:false');
	 if(isset($chart_option->displayDateBarSeparator)&& $chart_option->displayDateBarSeparator!='' )
	array_push($options, 'displayDateBarSeparator:true');
	else
	array_push($options, 'displayDateBarSeparator:false');
	 if(isset($chart_option->displayLegendDots)&& $chart_option->displayLegendDots!='' )
	array_push($options, 'displayLegendDots:true');
	else
	array_push($options, 'displayLegendDots:false');
	 if(isset($chart_option->displayLegendValues)&& $chart_option->displayLegendValues!='' )
	array_push($options, 'displayLegendValues:true');
	else
	array_push($options, 'displayLegendValues:false');
	 if(isset($chart_option->displayRangeSelector)&& $chart_option->displayRangeSelector!='' )
	array_push($options, 'displayRangeSelector:true');
	else
	array_push($options, 'displayRangeSelector:false');
	 if(isset($chart_option->displayZoomButtons)&& $chart_option->displayZoomButtons!='' )
	array_push($options, 'displayZoomButtons:true');
	else
	array_push($options, 'displayZoomButtons:false');
	 if(isset($chart_option->maximum_value)&& $chart_option->maximum_value!='' )
	array_push($options, 'maximum_value:'.$chart_option->maximum_value);
	if(isset($chart_option->minimum_value)&& $chart_option->minimum_value!='' )
	array_push($options, 'minimum_value:'.$chart_option->minimum_value);
	if(isset($chart_option->thickness)&& $chart_option->thickness!='' )
	array_push($options, 'thickness:'.$chart_option->thickness);
	
	
	if(isset($chart_option->zoomEndTime)&& $chart_option->zoomEndTime!='' )
	array_push($options, 'zoomEndTime:new Date('.date_format(new DateTime($chart_option->zoomEndTime), 'Y,m,d,H,i,s').')');
	
	if(isset($chart_option->zoomStartTime)&& $chart_option->zoomStartTime!='' )
	array_push($options, 'zoomStartTime:new Date('.date_format(new DateTime($chart_option->zoomStartTime), 'Y,m,d,H,i,s').')');
	 
	 
	 if(isset($chart_data->chart_data->series_column_color)){
			
			$c_y = explode(',',$chart_data->chart_data->series_column_color);
		
			if(count($c_y)>0)
			array_push($options, 'colors: ["'.implode('","',$c_y).'"]');
			}
	         $items = array();
	         $series = explode(',', $chart_data->chart_data->series);
	
	if($chart_data->database_type=='chart_data_manually'){
		$item = '["Date",';
			  for($s=0;$s<count($chart_data->chart_data->s_header);$s++){
				  
					$item .= isset($chart_data->chart_data->s_header[$s]->header)?'"'.$chart_data->chart_data->s_header[$s]->header.'",':',';
					if($s==count($chart_data->chart_data->s_header)-1){
						$item .= isset($chart_data->chart_data->s_header[$s]->title)?'"'.$chart_data->chart_data->s_header[$s]->title.'",':',';
					    $item .= isset($chart_data->chart_data->s_header[$s]->text)?'"'.$chart_data->chart_data->s_header[$s]->text.'"':'';
						
						}
					else{
					$item .= isset($chart_data->chart_data->s_header[$s]->title)?'"'.$chart_data->chart_data->s_header[$s]->title.'",':',';
					$item .= isset($chart_data->chart_data->s_header[$s]->text)?'"'.$chart_data->chart_data->s_header[$s]->text.'",':',';}
				  }
			  $item .= ']';
					
	     array_push($items, $item);
	     $data_loop = ((count($series)*3)+1);
		
		for($i=0;$i<count($chart_data->chart_data->data);$i++){
			$item ='[';
			for($j=0;$j<$data_loop;$j++){
	         	if($j==0){
						if(strpos($chart_data->chart_data->data[$i][$j], ':')!== false && strpos($chart_data->chart_data->data[$i][$j], ':')<11){
						$chart_data->chart_data->data[$i][$j] = str_replace(':', '-', $chart_data->chart_data->data[$i][$j]);

						}
						elseif(strpos($chart_data->chart_data->data[$i][$j], '/')!== false){
						$chart_data->chart_data->data[$i][$j] = str_replace('/', '-', $chart_data->chart_data->data[$i][$j]);

						}
					$date_value = date_format(new DateTime($chart_data->chart_data->data[$i][$j]), 'Y,m,d,H,i,s');
				    $update_date = explode(',', $date_value);
					 $date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
				$item .= 'new Date('.$date_value.')';	
				//$item .=self::return_type_date($chart_data->chart_data->data[$i][$j],'date').',';}
			}
				else{																			 
				   if($j%3==1){$item .= ', '.(float)$chart_data->chart_data->data[$i][$j];}
				   
				   else{
					   if($j==($data_loop-1))
					   $item .= isset($chart_data->chart_data->data[$i][$j])?', "'.$chart_data->chart_data->data[$i][$j].'"':',';
					   else
					    $item .= isset($chart_data->chart_data->data[$i][$j])?', "'.$chart_data->chart_data->data[$i][$j].'"':',';
					   }
				
						}
						}
						$item .= ']';
		
			
		
			array_push($items, $item);
			}
			
			$data = implode(',', $items);
			}
			elseif($chart_data->database_type=='chart_data_from_csv'){
				
				   $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
					try
					{
					 $series = explode(',', $chart_data->chart_data->series);
					 $item = '["Date",';
			  for($s=0;$s<count($series);$s++){
				  
					$item .= isset($chart_data->chart_data->s_header[$s]->header)?'"'.$chart_data->chart_data->s_header[$s]->header.'",':',';
					if($s==count($chart_data->chart_data->s_header)-1){
						$item .= isset($chart_data->chart_data->s_header[$s]->title)&&$chart_data->chart_data->s_header[$s]->title!=''?'"'.$chart_data->chart_data->s_header[$s]->title.'",':'"",';
					    $item .= isset($chart_data->chart_data->s_header[$s]->text)&& $chart_data->chart_data->s_header[$s]->text!=''?'"'.$chart_data->chart_data->s_header[$s]->text.'"':'""';
						
						}
					else
					{
					$item .= isset($chart_data->chart_data->s_header[$s]->title)&& $chart_data->chart_data->s_header[$s]->title!=''?'"'.$chart_data->chart_data->s_header[$s]->title.'",':'"",';
					$item .= isset($chart_data->chart_data->s_header[$s]->text)&& $chart_data->chart_data->s_header[$s]->text!=''?'"'.$chart_data->chart_data->s_header[$s]->text.'",':'"",';}
				    }
			        $item .= ']';
					
					array_push($items, $item);
					
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp); 
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					
					for($i=0;$i<count($insert);$i++)	{
					
					
					$item = '[';
					if(strpos($insert[$i][0], ':')!== false && strpos($insert[$i][0], ':')<11){
					$insert[$i][0] = str_replace(':', '-', $insert[$i][0]);
					//$insert[$i][0] = date('Y-m-d', strtotime($date)); 
					}
					if(strpos($insert[$i][0], '/')!== false){
					$insert[$i][0] = str_replace('/', '-', $insert[$i][0]);
					//$insert[$i][0] = date('Y-m-d', strtotime($date)); 	
					}
					
				 $date_value = date_format(new DateTime($insert[$i][0]), $date_type);
			     $update_date = explode(',', $date_value);
                 $date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
				
					/* $date_value = date_format(new DateTime($insert[$i][0]),  'Y,m,d,H,i,s');
				    $date_value = explode(',', $date_value);
                    $date_value = $date_value[0].','.($date_value[1]-1).','.$date_value[2].','.$date_value[3].','.$date_value[4].','.$date_value[5]; */
				     
					 
					 
					 $item .= 'new Date('.$date_value.')';	
			       
					for($j=0;$j<count($header);$j++){
					$series_column = 'series_column'.$j;
					$title_column = 'title_column'.$j;
					$text_column = 'text_column'.$j;
					$flag =0;
					if(isset($chart_option->$series_column) && $chart_option->$series_column!=''){
					$flag=1;
					$series_column = array_search($chart_option->$series_column, $header);
					$item .= ', '.(float)$insert[$i][$series_column];
					}
					
					if(isset($chart_option->$title_column) && $chart_option->$title_column!=''){
					$title_column = array_search($chart_option->$title_column, $header);
					$item .= ', "'.$insert[$i][$title_column].'"';
					}
					elseif(isset($chart_option->$title_column) &&$chart_option->$title_column==''&& $flag==1)
					$item .= ',""';
					
					if(isset($chart_option->$text_column) && $chart_option->$text_column!=''){
					$text_column = array_search($chart_option->$text_column, $header);
					$item .= ', "'.$insert[$i][$text_column].'"';
					}
					elseif(isset($chart_option->$text_column) &&$chart_option->$text_column==''&& $flag==1)
					$item .= ',""';
					
					
					}
				
					$item .= ']';
					
					
					array_push($items, $item);
					}	
					$data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
				
				
				}
			elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
			$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
			if($items->result=='error')
			{return $items;}
			
			$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
			
			
			$chart_type = 'AnnotationChart';
	break;
	case 'Table':
	$package = 'table';
	if(isset($chart_data->chart_data->series_column_color)&&$chart_data->chart_data->series_column_color!=''){
			
			$c_y = explode(',',$chart_data->chart_data->series_column_color);
		
			if(count($c_y)>0)
			array_push($options, 'colors: ["'.implode('","',$c_y).'"]');
			}
	if(isset($chart_option->allowHtml)&& $chart_option->allowHtml!='' )
	array_push($options, 'allowHtml:true');
	if(isset($chart_option->alternatingRowStyle)&& $chart_option->alternatingRowStyle!='' )
	array_push($options, 'alternatingRowStyle:true');
	if(isset($chart_option->paging)&& $chart_option->paging!='' )
	array_push($options, 'page:"'.$chart_option->paging.'"');
	if(isset($chart_option->pageSize)&& $chart_option->pageSize!='' )
	array_push($options, 'pageSize:'.$chart_option->pageSize);
	if(isset($chart_option->firstRowNumber)&& $chart_option->firstRowNumber!='' )
	array_push($options, 'firstRowNumber:true');
	if(isset($chart_option->showRowNumber)&& $chart_option->showRowNumber!='' )
	array_push($options, 'showRowNumber:true');
	if(isset($chart_option->sortAscending)&& $chart_option->sortAscending!='' )
	array_push($options, 'sortAscending:true');
	
	
	
	$items = array();
	$series = explode(',', $chart_data->chart_data->series);
	
				
	
	if($chart_data->database_type=='chart_data_manually'){
		$item = '[';
			  for($s=0;$s<count($chart_data->chart_data->s_header);$s++){
				   if($s==count($chart_data->chart_data->s_header)-1) {
					
					    if(isset($chart_data->chart_data->s_header[$s]->type))
						$item .= isset($chart_data->chart_data->s_header[$s]->title)?'{type:"'.$chart_data->chart_data->s_header[$s]->type.'", label:"'.$chart_data->chart_data->s_header[$s]->title.'"}':'';
						else
						$item .= isset($chart_data->chart_data->s_header[$s]->title)?'"'.$chart_data->chart_data->s_header[$s]->title.'"':'';
						
				
						}
					else{
					 if(isset($chart_data->chart_data->s_header[$s]->type))
					 $item .= isset($chart_data->chart_data->s_header[$s]->title)?'{type:"'.$chart_data->chart_data->s_header[$s]->type.'", label:"'.$chart_data->chart_data->s_header[$s]->title.'"},':',';
	                else
					$item .= isset($chart_data->chart_data->s_header[$s]->title)?'"'.$chart_data->chart_data->s_header[$s]->title.'",':',';
					    }
				  }
				$item .= ']';
				array_push($items, $item);
				$data_loop = count($chart_data->chart_data->data);
				
				for($i=0;$i<$data_loop;$i++){
				 $item ='[';
			      for($j=0;$j<count($series);$j++){
					if($j==count($series)-1)
					{
					$item .= isset($chart_data->chart_data->data[$i][$j])?self::return_type_date($chart_data->chart_data->data[$i][$j],$chart_data->chart_data->s_header[$j]->type):'';
					}
					else
					{																			 
					//echo $chart_data->chart_data->data[$i][$j].'  '.$chart_data->chart_data->s_header[$j]->type;
					$item .= isset($chart_data->chart_data->data[$i][$j])?self::return_type_date($chart_data->chart_data->data[$i][$j],$chart_data->chart_data->s_header[$j]->type).',':',';
					
					}
					
						}
						$item .= ']';
		
		array_push($items, $item);
		}
		$data = implode(',', $items);
		}
		elseif($chart_data->database_type=='chart_data_from_csv'){
			        $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
					try
					{
					$item = '[';
			    $series = explode(',', $chart_data->chart_data->series);
				for($s=0;$s<count($chart_option->table_column_format);$s++){
				   if($s==count($chart_option->table_column_format)-1) {
					
					    if(isset($chart_option->table_column_format[$s]))
						$item .= isset($chart_option->table_column_format[$s])?'{type:"'.$chart_option->table_column_format[$s].'", label:"'. $series[$s].'"}':'';
						else
						$item .= isset($series[$s])?'"'.$series[$s].'"':'';
						
				
						}
					else{
					 if(isset($chart_option->table_column_format[$s]))
					 $item .= isset($chart_option->table_column_format[$s])?'{type:"'.$chart_option->table_column_format[$s].'", label:"'.$series[$s].'"},':',';
	                else
					$item .= isset($series[$s])?'"'.$series[$s].'",':',';
					    }
				  }
				$item .= ']';
				array_push($items, $item);
				
					
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					
					for($i=0;$i<count($insert);$i++)	{
					
					
					$item = '[';
					  for($j=0;$j<count($header);$j++){
									$series_column = 'column'.$j;
									
									if($j==0 && isset($chart_option->$series_column) && $chart_option->$series_column!=''){
									$series_column = array_search($chart_option->$series_column, $header);
									$item .= isset($insert[$i][$series_column])?self::return_type_date($insert[$i][$series_column],$chart_option->table_column_format[$j]):',';
									}
									if($j>0 && isset($chart_option->$series_column) && $chart_option->$series_column!=''){
									$series_column = array_search($chart_option->$series_column, $header);
									$item .= ',';
									$item .= isset($insert[$i][$series_column])?self::return_type_date($insert[$i][$series_column],$chart_option->table_column_format[$j]):',';
									
									}
							
							}
				
					$item .= ']';
					
					
					array_push($items, $item);
					}	
					$data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
				
				
			}
		elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
			$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
			if($items->result=='error')
			{return $items;}
			
			$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
		
	
	$chart_type = 'Table';
	break;
	case 'GeoChart':
	$package = 'corechart';
	     $items = array();
		
		
				if(isset($chart_data->chart_data->region_show)&& $chart_data->chart_data->region_show!='' )
				array_push($options, 'region:"'.$chart_data->chart_data->region_show.'"');
				if(isset($chart_data->chart_data->geomode)&& $chart_data->chart_data->geomode!='' )
				array_push($options, 'displayMode:"'.$chart_data->chart_data->geomode.'"');
				
				$color_axis_color = array();
				
				if(isset($chart_option->coloraxis->start)&& $chart_option->coloraxis->start!='' )
				array_push($color_axis_color, $chart_option->coloraxis->start);
				if(isset($chart_option->coloraxis->middle)&& $chart_option->coloraxis->middle!='' )
				array_push($color_axis_color, $chart_option->coloraxis->middle);
				if(isset($chart_option->coloraxis->last)&& $chart_option->coloraxis->last!='' )
				array_push($color_axis_color, $chart_option->coloraxis->last);
				if(count($color_axis_color)>0)
				array_push($options, 'colorAxis:{colors:["'.implode('","',$color_axis_color).'"]}');
				$color_axis_color = array();
				if(isset($chart_option->maximum_size_value)&& $chart_option->maximum_size_value!='' )
				array_push($color_axis_color, 'maxSize:'.$chart_option->maximum_size_value);
				if(isset($chart_option->minimum_size_value)&& $chart_option->minimum_size_value!='' )
				array_push($color_axis_color, 'minSize:'.$chart_option->minimum_size_value);
				if(count($color_axis_color)>0)
				array_push($options, 'sizeAxis:{'.implode(',',$color_axis_color).'}');
				if(isset($chart_option->bubble_opicity)&& $chart_option->bubble_opicity!='' )
				array_push($color_axis_color, 'markerOpacity:'.$chart_option->bubble_opicity);
				
				if(isset($chart_option->coloraxis->datalessRegionColor)&& $chart_option->coloraxis->datalessRegionColor!='' )
				array_push($options, 'datalessRegionColor:"'.$chart_option->coloraxis->datalessRegionColor.'"');
				
				
				
				//$item = '["Task", "'.$chart_data->chart_data->datalegend.'"]';
				
				
				if($chart_data->database_type=='chart_data_manually'){
					$series = explode(',', $chart_data->chart_data->series);
					array_push($items, '["Task", "'.$chart_data->chart_data->datalegend.'"]');
				$url_array = array();
				for($i=0;$i<count($series);$i++)
				{
				if(!empty($series[$i]))
				$item = '["'.$series[$i].'", '.(float)str_replace(',','',$chart_data->chart_data->data[$i]).']';
				
				array_push($items, $item);
				if(isset($chart_data->chart_data->url[$i]) && $chart_data->chart_data->url[$i]!='')
				array_push($url_array,$chart_data->chart_data->url[$i]);
				else
				array_push($url_array,'#');
				
				
				
				}
				$data = implode(',', $items);
				}
				elseif($chart_data->database_type=='chart_data_from_csv'){
					$url_array = array();
					$chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
				   try {	
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					
					for($i=0;$i<count($insert);$i++)
					{
					if($i==0){
									$first_c = 'column1';$second_c = 'column2';
									    $header_section = '["Country"';
										if(isset($chart_option->$first_c) &&$chart_option->$first_c!='')
								        $header_section .= ', "'.$chart_option->$first_c.'"';
										if(isset($chart_option->$second_c) &&$chart_option->$second_c!='')
								        $header_section .= ', "'.$chart_option->$second_c.'"';
										$header_section .= ']';
										array_push($items, $header_section);
								
								}
					$item = '[';
							  for($j=0;$j<3;$j++)
								{
							    $series_column = 'column'.$j;
								
									if($j==0 && isset($chart_option->$series_column) &&$chart_option->$series_column!='')
									  {
											$section_column = array_search($chart_option->$series_column, $header);
										$item .= '"'.$insert[$i][$section_column].'" ';
										}
										elseif($j>0 && isset($chart_option->$series_column) &&$chart_option->$series_column!='')
										{
											$series_column = array_search($chart_option->$series_column, $header);
											$item .= ', '.(float)$insert[$i][$series_column];
										}
									
				       	            }
				
						 $item .= ']';
						
						array_push($items, $item);
						}	
					   $data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
				
					}
				elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
				{
				
				$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
				if($items->result=='error')
				{return $items;}
				
				$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
				}
				
				$chart_type = 'GeoChart';
	break;
	
	
	case 'Timeline':

				$items = array();
				if(isset($chart_data->chart_data->series_column_color)&&$chart_data->chart_data->series_column_color!=''){
				
				$c_y = explode(',',$chart_data->chart_data->series_column_color);
				
				if(count($c_y)>0)
				array_push($options, 'colors: ["'.implode('","',$c_y).'"]');
				}
				
				$bubbles = $bubble = array();
				if(isset($chart_option->showBarLabels)&& $chart_option->showBarLabels!='' )
				array_push($bubble, 'showBarLabels:true');
				if(isset($chart_option->showRowLabels)&& $chart_option->showRowLabels!='' )
				array_push($bubble, 'showRowLabels:true');
				if(isset($chart_option->colorByRowLabel)&& $chart_option->colorByRowLabel!='' )
				array_push($bubble, 'colorByRowLabel:true');
				if(isset($chart_option->singleColor)&& $chart_option->singleColor!='' )
				array_push($bubble, 'singleColor:"'.$chart_option->singleColor.'"');
				if(isset($chart_option->avoidOverlappingGridLines)&& $chart_option->avoidOverlappingGridLines!='' )
				array_push($options, 'avoidOverlappingGridLines:true');
				
				array_push($options, 'enableInteractivity:true');
	
								if(isset($chart_option->barlabelstyle) &&$chart_option->barlabelstyle!=''){	
								if(isset($chart_option->barlabelstyle->color) && $chart_option->barlabelstyle->color!='')
									array_push($bubbles, 'color:"'.$chart_option->barlabelstyle->color.'"');
								
								if(isset($chart_option->barlabelstyle->fontsizes) && $chart_option->barlabelstyle->fontsizes!='')
								array_push($bubbles, 'fontSize: "'.$chart_option->barlabelstyle->fontsizes.'"');
								
								if(isset($chart_option->barlabelstyle->fontstyle) && $chart_option->barlabelstyle->fontstyle!='')
								array_push($bubbles, 'fontName: "'.$chart_option->barlabelstyle->fontstyle.'"');
								
								if(isset($chart_option->barlabelstyle->bolds) && $chart_option->barlabelstyle->bolds)
								array_push($bubbles, 'bold:'.$chart_option->barlabelstyle->bolds);
								if(isset($chart_option->barlabelstyle->italic) && $chart_option->barlabelstyle->italic)
								array_push($bubbles, 'italic: "'.$chart_option->barlabelstyle->italic.'"');
								
								if(count($bubbles)>0)
								array_push($bubble, 'barLabelStyle: {'.implode(',',$bubbles).'}');
								}
								
								if(isset($chart_option->rowlabelstyle) &&$chart_option->rowlabelstyle!=''){	
								if(isset($chart_option->rowlabelstyle->color) && $chart_option->rowlabelstyle->color!='')
									array_push($bubble, 'color:"'.$chart_option->rowlabelstyle->color.'"');
								
								if(isset($chart_option->rowlabelstyle->fontsizes) && $chart_option->rowlabelstyle->fontsizes!='')
								array_push($bubbles, 'fontSize: "'.$chart_option->rowlabelstyle->fontsizes.'"');
								
								if(isset($chart_option->rowlabelstyle->fontstyle) && $chart_option->rowlabelstyle->fontstyle!='')
								array_push($bubbles, 'fontName: "'.$chart_option->rowlabelstyle->fontstyle.'"');
								
								if(isset($chart_option->rowlabelstyle->bolds) && $chart_option->rowlabelstyle->bolds)
								array_push($bubbles, 'bold:'.$chart_option->rowlabelstyle->bolds);
								if(isset($chart_option->rowlabelstyle->italic) && $chart_option->rowlabelstyle->italic)
								array_push($bubbles, 'italic: "'.$chart_option->rowlabelstyle->italic.'"');
								
								if(count($bubbles)>0)
								array_push($bubble, 'rowLabelStyle: {'.implode(',',$bubbles).'}');
								}
								if(count($bubble)>0)
								array_push($options, 'timeline: {'.implode(',',$bubble).'}');
								
								
	/*if(isset($chart_option->colorByRowLabel)&& $chart_option->colorByRowLabel!='' )
	array_push($options, 'colorByRowLabel:true');*/
	
		$package = 'timeline';
		$series = explode(',', $chart_data->chart_data->series);
	
				$item = '[';
			
						$item .= isset($chart_data->chart_data->s_header[0]->section)?'"'.$chart_data->chart_data->s_header[0]->section.'",':'"Section",';
						$item .= isset($chart_data->chart_data->s_header[1]->title)?'"'.$chart_data->chart_data->s_header[1]->title.'",':'"Title",';
						$item .= isset($chart_data->chart_data->s_header[2]->start)?'"'.$chart_data->chart_data->s_header[2]->start.'",':'"Start date",';
						$item .= isset($chart_data->chart_data->s_header[3]->end)?'"'.$chart_data->chart_data->s_header[3]->end.'"':'"End date"';
						
			  $item .= ']';
	
		array_push($items,$item);
		if($chart_data->database_type=='chart_data_manually'){
		if(isset($chart_option->calender_view_format) && $chart_option->calender_view_format!='' && $chart_option->calender_view_format!='date')
		   {
			$date_s_format = 'Y,m,d';
			}
		else 
		   {
			$date_s_format = 'Y,m,d,H,i,s';
			}
					for($i=0;$i<count($series);$i++)
					{   $item = '[';
								for($j=0;$j<4;$j++)
								{
								$new_item = $chart_data->chart_data->data[$i];
								
								if($j==0){
								$item .= '"'.$chart_data->chart_data->data[$i][$j].'", ';
								}
								if($j==1){$item .= '"'.$chart_data->chart_data->data[$i][$j].'", ';}
								
								if($j==2)
								{
									if(strpos($chart_data->chart_data->data[$i][$j], ':')!== false && strpos($chart_data->chart_data->data[$i][$j], ':')<11){
									$chart_data->chart_data->data[$i][$j] = str_replace(':', '-', $chart_data->chart_data->data[$i][$j]);
											
									}
									elseif(strpos($chart_data->chart_data->data[$i][$j], '/')!== false){
									$chart_data->chart_data->data[$i][$j] = str_replace('/', '-', $chart_data->chart_data->data[$i][$j]);
											
									}
										
									$data_value = date_format(new DateTime($chart_data->chart_data->data[$i][$j]), $date_s_format);
									
									$update_date = explode(',', $data_value);
									$data_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
									$item .= 'new Date('.$data_value.'),';
								}
								if($j==3){
									if(strpos($chart_data->chart_data->data[$i][$j], ':')!== false && strpos($chart_data->chart_data->data[$i][$j], ':')<11){
									$chart_data->chart_data->data[$i][$j] = str_replace(':', '-', $chart_data->chart_data->data[$i][$j]);
								   
											
									}
									elseif(strpos($chart_data->chart_data->data[$i][$j], '/')!== false){
									$chart_data->chart_data->data[$i][$j] = str_replace('/', '-', $chart_data->chart_data->data[$i][$j]);
								   	
									}
										
									$data_value = date_format(new DateTime($chart_data->chart_data->data[$i][$j]), $date_s_format);
									$update_date = explode(',', $data_value);
									$data_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
									$item .= 'new Date('.$data_value.'),';
								
								}
								
								
								}
					  $item .= ']';
					array_push($items, $item);
					}
					$data = implode(',', $items);
					}
					elseif($chart_data->database_type=='chart_data_from_csv'){
				    $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
				   try {	
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					$date_s_format = 'Y,m,d,H,i,s';
					
					for($i=0;$i<count($insert);$i++)
					{
					
					
					$item = '[';
					
			                  
							  for($j=0;$j<4;$j++)
								{
								$selected = '';
								$series_column = 'series_column0';$start_column = 'start_column1';$end_column = 'end_column2';	$section_column = 'section_column3';
								
								
									if($j==0 && isset($chart_option->$section_column) &&$chart_option->$section_column!=''){
										$section_column = array_search($chart_option->$section_column, $header);
									$item .= '"'.$insert[$i][$section_column].'", ';
									}
									elseif($j==0)
									{
									$item .= '"'.$i.'", ';	
										}
									if($j==1 && isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
										$series_column = array_search($chart_option->$series_column, $header);
										$item .= '"'.$insert[$i][$series_column].'", ';
									}
								
									if($j==2 && isset($chart_option->$start_column) &&$chart_option->$start_column!='')
									{
										$start_column = array_search($chart_option->$start_column, $header);	
										if(strpos($insert[$i][$start_column], ':')!== false && strpos($insert[$i][$start_column], ':')<11){
										$insert[$i][$start_column] = str_replace(':', '-', $insert[$i][$start_column]);


										}
										elseif(strpos($insert[$i][$start_column], '/')!== false){
										$insert[$i][$start_column] = str_replace('/', '-', $insert[$i][$start_column]);

										}
											
										$data_value = date_format(new DateTime($insert[$i][$start_column]), $date_s_format);
										
										$update_date = explode(',', $data_value);
										$data_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
										$item .= 'new Date('.$data_value.'),';
									}
									if($j==3 && isset($chart_option->$end_column) &&$chart_option->$end_column!='')
									{
										$end_column = array_search($chart_option->$end_column, $header);
										if(strpos($insert[$i][$end_column], ':')!== false && strpos($insert[$i][$end_column], ':')<11){
										$insert[$i][$end_column] = str_replace(':', '-', $insert[$i][$end_column]);

										}
										elseif(strpos($insert[$i][$end_column], '/')!== false){
										$insert[$i][$end_column] = str_replace('/', '-', $insert[$i][$end_column]);

										}
											
										$data_value = date_format(new DateTime($insert[$i][$end_column]), $date_s_format);
										
										$update_date = explode(',', $data_value);
										$data_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
										$item .= 'new Date('.$data_value.'),';
									
								}
								
					
				       	       }
				
						 $item .= ']';
						
						array_push($items, $item);
						}	
					   $data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
						
						
				}
				elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
					
					$items = self::data_from_existing_database($chart_data,'','','','',$chart_type_exist,$chart_option,$current_limit);
					if($items->result=='error')
					{return $items;}
					
					$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
					}
					
		
	$chart_type = 'Timeline';
	break;
	case 'Maps':
	$package = 'map';
	if(isset($chart_option->maptype)&& $chart_option->maptype!='');
	array_push($options, 'mapType:"'.$chart_option->maptype.'"');
	if(isset($chart_option->infowindow)&& $chart_option->infowindow!='')
	array_push($options, 'showTip:'.$chart_option->infowindow);
	if(isset($chart_option->zoominout)&& $chart_option->zoominout!='')
	array_push($options, 'enableScrollWheel:'.$chart_option->zoominout);
	if(isset($chart_option->useMapTypeControl)&& $chart_option->useMapTypeControl!='')
	array_push($options, 'useMapTypeControl:'.$chart_option->useMapTypeControl);
	if(isset($chart_option->zoomlevel)&& $chart_option->zoomlevel!='')
	array_push($options, 'zoomLevel:'.$chart_option->zoomlevel);
	$n = array();
    $db = JFactory::getDbo();
	
	if(isset($chart_option->normal_marker_path))
		array_push($n, 'normal:'.$db->quote(Juri::root().'components/com_vchart/images/markers/normal/'.$chart_option->normal_marker_path));
	if(isset($chart_option->selected_marker_path))	
	array_push($n, 'selected:'.$db->quote(Juri::root().'components/com_vchart/images/markers/selected/'.$chart_option->selected_marker_path));
	
	if(count($n)<1){
	
	array_push($n, 'normal:'.$db->quote(Juri::root().'components/com_vchart/images/markers/normal/6.png'));

	array_push($n, 'selected:'.$db->quote(Juri::root().'components/com_vchart/images/markers/normal/11.png'));
	}
	
	//if(count($n)>0){
		array_push($options, 'icons:{ default:{'.implode(',',$n).'}}');
		
		//}
	
	if($chart_data->database_type=='chart_data_manually'){
		
	
		if($chart_data->chart_data->series_mod_info =='region'){
		$item = "['Region', 'info']";	
			
			}
			else
		$item = "['latitude', 'longitude', 'info']";
		
						$items = array();
						array_push($items, $item);
					
					if($chart_data->chart_data->series_mod_info=='region'){
						for($i=0;$i<count($chart_data->chart_data->data);$i++){
							$t=0;
							$item_details = $chart_data->chart_data->data[$i];
							if($t==0){
								if(empty($item_details[$t]))
								 continue;
							$item = '['.$db->quote($item_details[$t]).', ';$t++;}
							if($t==1){  
								 $item .= $db->quote($item_details[$t]).']';}
							array_push($items, $item);
							}
						}
					
					if($chart_data->chart_data->series_mod_info=='latlng'){
						for($i=0;$i<count($chart_data->chart_data->data);$i++){
							$t=0;
							$item_details = $chart_data->chart_data->data[$i];
							if($t==0){
								if(empty($item_details[$t]))
								 continue;
							$item = '['.$item_details[$t].', ';$t++;}
							if($t==1){ 
							      if(empty($item_details[$t]))
								       continue;
								 $item .= $item_details[$t].', ';$t++;}
								 if($t==2){  
								 $item .= $db->quote($item_details[$t]).']';$t++;}
							array_push($items, $item);
							}
						
						}
					
		$data = implode(',', $items);
		}
		elseif($chart_data->database_type=='chart_data_from_csv'){
				    $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
				   try {	
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					
					if($chart_data->chart_data->series_mod_info =='region'){
					$item = "['Region', 'info']";	
					
					}
					else
					$item = "['latitude', 'longitude', 'info']";
					
					   $items = array();
						array_push($items, $item);
					
			                 if(isset($chart_data->chart_data->series_mod_info) && $chart_data->chart_data->series_mod_info=='region'){
								$series_region = 'series_region';$column_value = 'column_value';
								$series_region = array_search($chart_option->$series_region, $header);
								$column_value = array_search($chart_option->$column_value, $header);
								
								for($i=0;$i<count($insert);$i++)
					             {
									 $item = '[';
									
									$item .= '"'.$insert[$i][$series_region].'"';
									
									$item .= ', '.$db->quote($insert[$i][$column_value]);
									  $item .= ']';
									 array_push($items, $item);
								 }
								
								} 
							 if(isset($chart_data->chart_data->series_mod_info) &&$chart_data->chart_data->series_mod_info=='latlng'){
								 $latitude_column = 'latitude_column';$longitude_column = 'longitude_column';$column_value = 'column_value';
								 $latitude_column = array_search($chart_option->$latitude_column, $header);
								 $longitude_column = array_search($chart_option->$longitude_column, $header);
								 $column_value = array_search($chart_option->$column_value, $header);
							    for($i=0;$i<count($insert);$i++)
					               {
									
									$item = '['.$insert[$i][$latitude_column];
									
									$item .= ' , '.$insert[$i][$longitude_column];
								
									$item .= ', '.$db->quote($insert[$i][$column_value]).']';
									
									  array_push($items, $item);
									}
				       	       }
					   $data = implode(',', $items);
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
						
						
				}
		elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
			$items = self::data_from_existing_database($chart_data,'','','','',$chart_type_exist,$chart_option,$current_limit);
			if($items->result=='error')
					{return $items;}
					
					$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
	
		
	$chart_type = 'Map';
	break;
	case 'Scatter Chart':
	$package = 'corechart';
	  $option =  $opt = array();
					if(isset($chart_option->x_axis) && $chart_option->x_axis!='')
					{ 
					
					if(isset($chart_option->x_axis_checkedtextstyle->color) && $chart_option->x_axis_checkedtextstyle->color!='')
					array_push($option, 'color: "'.$chart_option->x_axis_checkedtextstyle->color.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->fontsizes) && $chart_option->x_axis_checkedtextstyle->fontsizes!='')
					array_push($option, 'fontSize: "'.$chart_option->x_axis_checkedtextstyle->fontsizes.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->fontstyle) && $chart_option->x_axis_checkedtextstyle->fontstyle!='')
					array_push($option, 'fontName: "'.$chart_option->x_axis_checkedtextstyle->fontstyle.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->bolds) && $chart_option->x_axis_checkedtextstyle->bolds)
					array_push($option, 'bold: "'.$chart_option->x_axis_checkedtextstyle->bolds.'"');
					if(isset($chart_option->x_axis_checkedtextstyle->italic) && $chart_option->x_axis_checkedtextstyle->italic)
					array_push($option, 'italic: "'.$chart_option->x_axis_checkedtextstyle->italic.'"');
					}
					if(isset($chart_option->x_axis_start) && $chart_option->x_axis_start!='')
					array_push($opt, 'viewWindow:{min: "'.$chart_option->x_axis_start.'"}');
					if(isset($chart_option->x_axis_end) && $chart_option->x_axis_end!='')
					array_push($opt, 'viewWindow:{max: "'.$chart_option->x_axis_end.'"}');
					
					if(isset($chart_option->x_axis) && $chart_option->x_axis!='')
					array_push($opt, 'title: "'.$chart_option->x_axis.'"');
					if(count($option)>0)
					array_push($opt, 'titleTextStyle: {'.implode(',',$option).'}');
					if(count($opt)>0)
					array_push($options, 'hAxis: {'.implode(',',$opt).'}');
					$option =  $opt = array();
					
					if (isset($chart_option->y_axis) && $chart_option->y_axis!='')
					{ 
					if(isset($chart_option->y_axis_checkedtextstyle->color)&& $chart_option->y_axis_checkedtextstyle->color!='')
					array_push($option, 'color: "'.$chart_option->y_axis_checkedtextstyle->color.'"');
					if(isset($chart_option->y_axis_checkedtextstyle->fontsizes)&& $chart_option->y_axis_checkedtextstyle->fontsizes!='')
					array_push($option, 'fontSize: "'.$chart_option->y_axis_checkedtextstyle->fontsizes.'"');
					if(isset($chart_option->y_axis_checkedtextstyle->fontstyle) && $chart_option->y_axis_checkedtextstyle->fontstyle!='')
					array_push($option, 'fontName: "'.$chart_option->y_axis_checkedtextstyle->fontstyle.'"');
					if(isset($chart_option->y_axis_checkedtextstyle->bolds) && $chart_option->y_axis_checkedtextstyle->bolds)
					array_push($option, 'bold: 1');
					if(isset($chart_option->y_axis_checkedtextstyle->italic) && $chart_option->y_axis_checkedtextstyle->italic)
					array_push($option, 'italic: 1');
					}
					if(isset($chart_option->y_axis_start) && $chart_option->y_axis_start!='')
					array_push($opt, 'viewWindow:{min:"'.$chart_option->y_axis_start.'"}');
					if(isset($chart_option->y_axis_end) && $chart_option->y_axis_end!='')
					array_push($opt, 'viewWindow:{max:"'.$chart_option->y_axis_end.'"}');
					
					if (isset($chart_option->y_axis) && $chart_option->y_axis!='')
					array_push($opt, 'title: "'.$chart_option->y_axis.'"');
					if(count($option)>0)
					array_push($opt, 'titleTextStyle: {'.implode(',',$option).'}');	
					if(count($opt)>0)
					array_push($options, 'vAxis: {'.implode(',',$opt).'}');
						
					if(isset($chart_option->pointshape) && $chart_option->pointshape!='')
					array_push($options, ' pointShape: "'.$chart_option->pointshape.'"');
					if(isset($chart_option->pointsize) && $chart_option->pointsize!='')
					array_push($options, ' pointSize:'.$chart_option->pointsize);
					if(isset($chart_option->pointlinewidth) && $chart_option->pointlinewidth!='')
					array_push($options, ' lineWidth:'.$chart_option->pointlinewidth);
					
					if(isset($chart_data->chart_data->series_column_color)&&$chart_data->chart_data->series_column_color!=''){
					
					$c_y = explode(',',$chart_data->chart_data->series_column_color);
					
					if(count($c_y)>0)
					array_push($options, 'colors: ["'.implode('","',$c_y).'"]');
					}
								
	
	if($chart_data->database_type=='chart_data_manually'){
		                       $items = array();
								$series = explode(',', $chart_data->chart_data->series);
								$data_loop = count($chart_data->chart_data->data);
								
								for($s=0;$s<count($chart_data->chart_data->s_header);$s++){
									if($s==0) 
									$item = '[';
									if($s==count($chart_data->chart_data->s_header)-1)
									{
									$item .= isset($chart_data->chart_data->s_header[$s]->title)?'"'.$chart_data->chart_data->s_header[$s]->title.'",':',';
									}
									else{
									$item .= isset($chart_data->chart_data->s_header[$s]->title)?'"'.$chart_data->chart_data->s_header[$s]->title.'",':',';
									}
								}
								$item  = '["'.implode('","',$series).'"]';
	                          array_push($items, $item);
		
		for($i=0;$i<count($chart_data->chart_data->data);$i++){
			
			for($j=0;$j<count($series);$j++){
					if($j==0)
					{
					
					$item ='['.$chart_data->chart_data->data[$i][$j];
					}
					else
					{	
						
					$item .= isset($chart_data->chart_data->data[$i][$j])?','.$chart_data->chart_data->data[$i][$j]:',';
					}
						}
						$item .= ']';
			array_push($items, $item);
			}
			$data = implode(',', $items);
			}
				elseif($chart_data->database_type=='chart_data_from_csv'){
				    $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					
					$insert = array();
				   try {	
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					
					fclose($fp);
					
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					$items = array();
					$item = '[';
							  for($i=0;$i<count($header);$i++){
								$series_column = 'column'.$i;
								if($i==0 && isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
									$series_column = array_search($chart_option->$series_column, $header);
								 $item .= '"'.$header[$series_column].'"';}
								 elseif(isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
									 $series_column = array_search($chart_option->$series_column, $header);
								  $item .= ', "'.$header[$series_column].'"';}
								 }
								 $item .= ']';
							 
					
					array_push($items, $item);
					
					for($i=0;$i<count($insert);$i++)
					{
					
					
					$item = '[';
					
			                  
							  for($j=0;$j<count($insert);$j++)
								{
								$selected = '';$series_column = 'column'.$j;
								if($j==0 && isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
									$series_column = array_search($chart_option->$series_column, $header);
									$item .= (float)$insert[$i][$series_column];
									}
									elseif($j>0 &&isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
										$series_column = array_search($chart_option->$series_column, $header);
										$item .= ', '.(float)$insert[$i][$series_column];
									}
							
					
				       	       }
				
						 $item .= ']';
						
						array_push($items, $item);
						}	
					   $data = implode(',', $items); 
					
					}
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
			 	}
			elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
			
			$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series,$chart_type_exist,$chart_option,$current_limit);
			if($items->result=='error')
					{return $items;}
					
					$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
			}
			
	$chart_type = 'ScatterChart';
	break;
	case 'CandlestickChart':
					$package = 'corechart';
					$opt =   array();
					if (isset($chart_option->candkestick_falling) && $chart_option->candkestick_falling!='')
					{ 
					$opts =   array();
					if (isset($chart_option->candkestick_falling->stroke) && $chart_option->candkestick_falling->stroke!=''){
					array_push($opts,'stroke :"'.$chart_option->candkestick_falling->stroke.'"');
					} 
					if (isset($chart_option->candkestick_falling->fill) && $chart_option->candkestick_falling->fill!=''){
					array_push($opts,'fill :"'.$chart_option->candkestick_falling->fill.'"');
					} 
					if (isset($chart_option->candkestick_falling->stroke_width) && $chart_option->candkestick_falling->stroke_width!=''){
					array_push($opts,'stroke_width :'.$chart_option->candkestick_falling->stroke_width);
					} 
					if(count($opts))
					array_push($opt,'fallingColor:{'.implode(',',$opts).'}');
					
					}
					if (isset($chart_option->candkestick_rising) && $chart_option->candkestick_rising!='')
					{    
					$opts =   array();
					if (isset($chart_option->candkestick_rising->stroke) && $chart_option->candkestick_rising->stroke!=''){
					array_push($opts,'stroke :"'.$chart_option->candkestick_rising->stroke.'"');
					} 
					if (isset($chart_option->candkestick_rising->fill) && $chart_option->candkestick_rising->fill!=''){
					array_push($opts,'fill :"'.$chart_option->candkestick_rising->fill.'"');
					} 
					if (isset($chart_option->candkestick_rising->stroke_width) && $chart_option->candkestick_rising->stroke_width!=''){
					array_push($opts,'stroke_width :'.$chart_option->candkestick_rising->stroke_width);
					} 
					if(count($opts)>0)
					array_push($opt,'risingColor:{'.implode(',',$opts).'}');
					}
					if(count($opt)>0)
					array_push($options,'candlestick:{'.implode(',',$opt).'}');
					
					if($chart_data->database_type=='chart_data_manually'){
						$item = "['', '".$chart_data->chart_data->series_header."', '', '', '']";
						$items = array();
						array_push($items, $item);
						$series = explode(',', $chart_data->chart_data->series);
						
						for($i=0;$i<count($series);$i++)
						{
							$item = "["; 
						if(isset($chart_option->x_axis_header_type)){ 
										if($chart_option->x_axis_header_type=='date'||$chart_option->x_axis_header_type=='datetime')
										{
										$date_type = strlen(trim($series[$i]))>4?'Y,m,d,H,i,s':'Y';
										if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$series[$i]))),'Y').'"';}else{
												if(strpos($series[$i], ':')!== false && strpos($series[$i], ':')<11){
												$series[$i] =  str_replace(':', '-', $series[$i]);
												//$series[$i] = date('Y-m-d', strtotime($date)); 
												}
												if(strpos($series[$i], '/')!== false){
												$series[$i] =  str_replace('/', '-', $series[$i]);
												//$series[$i] = date('Y-m-d', strtotime($date)); 	
												}

												$date_value = date_format(new DateTime($series[$i]), $date_type);
												$update_date = explode(',', $date_value);
												$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
										
											/* $date_value = date_format(new DateTime($series[$i]), $date_type);
										$date_value = explode(',', $date_value);
										$date_value = $date_value[0].','.($date_value[1]-1).','.$date_value[2].','.$date_value[3].','.$date_value[4].','.$date_value[5]; */ 
										}
										$item .= 'new Date('.$date_value.')';
										}
										elseif($chart_option->x_axis_header_type=='number')
										$item .= trim($series[$i]);
										else
										$item .= '"'.trim($series[$i]).'"';
								    }
									else
									$item .= '"'.trim($series[$i]).'"';
						
						$item .= ", ".(float)$chart_data->chart_data->data[$i][0].", ".(float)$chart_data->chart_data->data[$i][1].", ".(float)$chart_data->chart_data->data[$i][2].", ".(float)$chart_data->chart_data->data[$i][3]."]";
						array_push($items, $item);
						}
						$data = implode(',', $items);
					}
					elseif($chart_data->database_type=='chart_data_from_csv'){
				    $chart_title_options = json_decode($chart_data->chart_title_option);
					$remote_url = $chart_title_options->remote_csv_url;
					$item = "['', '".$chart_data->chart_data->series_header."', '', '', '']";
					$items = array();
					array_push($items, $item);
					$insert = array();
				   try {	
					if ($fp = fopen($remote_url, 'r')) {
					//$fp = fopen($remote_url, 'r'); 
					$header = fgetcsv($fp, 100000, ",");
					while(($data = fgetcsv($fp, 100000, ",")) !== FALSE)	
					{
					
					if (array_filter($data))
						{ 

			            $insert[] = $data;
			          }
					
					}
					fclose($fp);
					
					} 
					$title_section_info = isset($chart_data->chart_title_option)?json_decode($chart_data->chart_title_option):'';
					$insert = isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='top_bottom'?$insert:array_reverse($insert);
					$insert = isset($title_section_info->remote_csv_data_limit)&& $title_section_info->remote_csv_data_limit!=''&& $title_section_info->remote_csv_data_limit>0?isset($title_section_info->remote_csv_data_ordering) && $title_section_info->remote_csv_data_ordering!=''&& $title_section_info->remote_csv_data_ordering=='bottom_top'?array_slice($insert,-(int)$title_section_info->remote_csv_data_limit):array_slice($insert,0,$title_section_info->remote_csv_data_limit):$insert;
					
					for($i=0;$i<count($insert);$i++)
					{
					
					
					$item = '[';
					
			                  
							  for($j=0;$j<5;$j++)
								{
								$selected = '';$series_column = 'column'.$j;
								if($j==0 && isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
									$series_column = array_search($chart_option->$series_column, $header);
									

									if(isset($chart_option->x_axis_header_type)){
										if($chart_option->x_axis_header_type=='date'||$chart_option->x_axis_header_type=='datetime')
										{
										$date_type = strlen(trim($insert[$i][$series_column]))>4?'Y,m,d,H,i,s':'Y';
										if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$insert[$i][$series_column]))),'Y').'"';}else{
										if(strpos($insert[$i][$series_column], ':')!== false && strpos($insert[$i][$series_column], ':')<11){
										$insert[$i][$series_column] = str_replace(':', '-', $insert[$i][$series_column]);
										
										}
										if(strpos($insert[$i][$series_column], '/')!== false){
										$insert[$i][$series_column] = str_replace('/', '-',$insert[$i][$series_column]);
											
										}

										$date_value = date_format(new DateTime($insert[$i][$series_column]), $date_type);
										$update_date = explode(',', $date_value);
										$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
											
											
											
											
										/* 	$date_value = date_format(new DateTime($insert[$i][$series_column]), $date_type);
										$date_value = explode(',', $date_value);
										$date_value = $date_value[0].','.($date_value[1]-1).','.$date_value[2].','.$date_value[3].','.$date_value[4].','.$date_value[5]; */ 
										}
										$item .= 'new Date('.$date_value.')';
										}
										elseif($chart_option->x_axis_header_type=='number')
										$item .= trim($insert[$i][$series_column]);
										else
										$item .= '"'.trim($insert[$i][$series_column]).'"';
								    }
									else
									$item .= '"'.trim($insert[$i][$series_column]).'"';
									
									}
									elseif($j>0  && isset($chart_option->$series_column) &&$chart_option->$series_column!=''){
										$series_column = array_search($chart_option->$series_column, $header);
										$item .= ', '.(float)$insert[$i][$series_column];
									}
																
					
				       	       }
				
						 $item .= ']';
						
						array_push($items, $item);
						}	
					   $data = implode(',', $items); 
					
					}  
					catch (RuntimeException $e)
					{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
					
					}
					
			 	} 
				elseif($chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database'){
					
						$items = self::data_from_existing_database($chart_data,'','','',$chart_data->chart_data->series_value,$chart_type_exist,$chart_option,$current_limit);
						if($items->result=='error')
					{return $items;}
					
					$data = $items->data;
		$new_live_chart_data = $items->data;
		$new_data_live = $items->data;
					}
					
					$chart_type = 'CandlestickChart';
	break;
}				

                        $lang = JFactory::getLanguage();
						$language = explode('-',$lang->getTag());
                        $option_new = array();
						
						if(isset($chart_title_option->chart_backgroud_color) && $chart_title_option->chart_backgroud_color!='' )	{
						
						array_push($option_new, 'fill: "'.$chart_title_option->chart_backgroud_color.'"');
						}
						if(isset($chart_title_option->chart_backgroud_strokecolor) && $chart_title_option->chart_backgroud_strokecolor!='' )	{
						
						array_push($option_new, 'stroke: "'.$chart_title_option->chart_backgroud_strokecolor.'"');
						}
						if(isset($chart_title_option->chart_backgroud_strokewidth) && $chart_title_option->chart_backgroud_strokewidth!='' )	{
						
						array_push($option_new, 'strokeWidth: "'.$chart_title_option->chart_backgroud_strokewidth.'"');
						}
						if(isset($chart_title_option->background_color_transparent) && $chart_title_option->background_color_transparent!='' )	{
							array_push($options, 'backgroundColor: \'transparent\'');
							}
						elseif(count($option_new)>0 && $chart_type!='AnnotationChart')
						array_push($options, 'backgroundColor: {'.implode(',', $option_new).'}');
					    $option = array();
					    if(isset($chart_option->chartarea_left)&& $chart_option->chartarea_left!='') 
						array_push($option, 'left: '.$chart_option->chartarea_left);
						if(isset($chart_option->chartarea_top) && $chart_option->chartarea_top!='')
						array_push($option, 'top: '.$chart_option->chartarea_top);
						if(isset($chart_option->chartarea_width)&& $chart_option->chartarea_width!='')
						array_push($option, 'width: "'.$chart_option->chartarea_width.'%"');
						if(isset($chart_option->chartarea_height) && $chart_option->chartarea_height!='')
						array_push($option, 'height:"'.$chart_option->chartarea_height.'%"');
						$chart_area_back = array();
						if(isset($chart_option->chartarea_color) && $chart_option->chartarea_color!='')
						array_push($chart_area_back, 'fill:"'.$chart_option->chartarea_color.'"');

						if(isset($chart_option->chartarea_strokecolor) && $chart_option->chartarea_strokecolor!='')
						array_push($chart_area_back, 'stroke:"'.$chart_option->chartarea_strokecolor.'"');
						if(isset($chart_option->chartarea_strokewidth) && $chart_option->chartarea_strokewidth!='')
						array_push($chart_area_back, 'strokeWidth:"'.$chart_option->chartarea_strokewidth.'"');
						
						if(isset($chart_option->chartarea_color_transparent) && $chart_option->chartarea_color_transparent!='' )	{
							array_push($option, 'backgroundColor: \'transparent\'');
							}
						elseif(count($chart_area_back)>0)
						array_push($option, 'backgroundColor: {'.implode(',', $chart_area_back).'}');
						
						/*if(isset($chart_option->chartarea_color)&& $chart_option->chartarea_color!=''&& $chart_type!='AnnotationChart') 
						array_push($option, 'backgroundColor: "'.$chart_option->chartarea_color.'"');*/
						
						if(count($option)>0)
						array_push($options, 'chartArea: {'.implode(',', $option).'}');
						
						if(isset($chart_option->pixel_percent)){
	                        if($chart_option->pixel_percent=='px'){
							 array_push($options, 'width:'.$width);
							// array_push($options, 'height:'.$height);
							}
							else{
								array_push($options, 'width:"'.$width.''.$chart_option->pixel_percent.'"');
								 //array_push($options, 'height:"'.$height.''.$chart_option->pixel_percent.'"');
								}
								
						}
						if(isset($chart_option->pixel_percent_height)){
	                        if($chart_option->pixel_percent_height=='px'){
							
							 array_push($options, 'height:'.$height);
							}
							else{
								
								 array_push($options, 'height:"'.$height.''.$chart_option->pixel_percent_height.'"');
								}
								
						}
						
						if(isset($chart_option->focusTarget) && $chart_option->focusTarget!=''){
							if($chart_option->focusTarget=='single')
						array_push($options, 'focusTarget:"datum"');
						if($chart_option->focusTarget=='group')
						array_push($options, 'focusTarget:"category"');
						} 
						if(isset($chart_option->tooltip)){
						$option =  $opt = array();
						if(isset($chart_option->tooltiptextstyle->color) && $chart_option->tooltiptextstyle->color!=''){
						array_push($option, 'color: "'.$chart_option->tooltiptextstyle->color.'"');}
						if(isset($chart_option->tooltiptextstyle->fontsizes) && $chart_option->tooltiptextstyle->fontsizes!='')
						array_push($option, 'fontSize: "'.$chart_option->tooltiptextstyle->fontsizes.'"');
						if(isset($chart_option->tooltiptextstyle->fontstyle) && $chart_option->tooltiptextstyle->fontstyle!='')
						array_push($option, 'fontName: "'.$chart_option->tooltiptextstyle->fontstyle.'"');
						if(isset($chart_option->tooltiptextstyle->bolds) && $chart_option->tooltiptextstyle->bolds)
						array_push($option, 'bold: "'.$chart_option->tooltiptextstyle->bolds.'"');
						if(isset($chart_option->tooltiptextstyle->italic) && $chart_option->tooltiptextstyle->italic)
						array_push($option, 'italic: "'.$chart_option->tooltiptextstyle->italic.'"');
						
						if(isset($chart_option->tooltip)&&$chart_option->tooltip!='')
						array_push($opt, 'trigger: "'.$chart_option->tooltip.'"');
						if(isset($chart_option->tooltip_html))
						array_push($opt, 'isHtml: true');
						if(isset($chart_option->showcolorcode))
						array_push($opt, 'showColorCode:true');
						if(count($option)>0)
						array_push($opt, 'textStyle: {'.implode(',',$option).'}');
						if(isset($chart_option->selection_mode)&&$chart_option->selection_mode!='')
						array_push($options, 'selectionMode: "'.$chart_option->selection_mode.'"');
						if(count($opt)>0)
						array_push($options, 'tooltip: {'.implode(',',$opt).'}');
						
						}
            if(isset($chart_option->filter_section)){
				if($chart_type=='PieChart' || $chart_type=='Slice Pie Chart'){
				 $f_type = isset($chart_option->filterType)?'"'.$chart_option->filterType.'"':'"NumberRangeFilter"';
				 $t_type = isset($chart_option->filterTypeTable)?'"'.$chart_option->filterTypeTable.'"':'"CategoryFilter"';
				 $c_type = isset($chart_option->filterTypeChart)?'"'.$chart_option->filterTypeChart.'"':'"PieChart"';
				 $l_type =isset($chart_option->legend)&& $chart_option->legend!=''?$chart_option->legend:'none';
				$scripts = '';
				$label = isset($chart_data->chart_data->value_title) && $chart_data->chart_data->value_title!=''?'"'.$chart_data->chart_data->value_title.'"':'"value"';
				$scripts .= ' if(typeof google !== "undefined")
				google.load("visualization", "1.0", {"packages":["'. $package.'", "controls"],"language": "'.$language[0].'"});

				google.setOnLoadCallback(drawDashboard'.$uniqid.');
				function drawDashboard'.$uniqid.'() {
				
				var dashboard'.$uniqid.'  =  new google.visualization.Dashboard(document.getElementById("dashboard_'.$uniqid.'"));
				var donutRangeSlider'.$uniqid.' = new google.visualization.ControlWrapper({
				"controlType": "NumberRangeFilter",
				"containerId": "filter_'.$uniqid.'",
				"options": {
				"filterColumnLabel":'.$label.'
				
				}
				});';
				if(isset($chart_option->filterTypeChart)&&$chart_option->filterTypeChart!=''){
				$scripts .= ' var filter_chart'.$uniqid.' = new google.visualization.ChartWrapper({
				"chartType": '.$c_type.',
				"containerId": "pie_div_'.$uniqid.'",
				"options": {
				"width": 300,
				"height": 300,
				"legend": "'.$l_type.'",
				"chartArea": {"left": 15, "top": 15, "right": 0, "bottom": 0}
				},
				"view": {"columns": [0, 1]}
				});';	 
					 
				 }
				$scripts .= ' var pieChart'.$uniqid.' = new google.visualization.ChartWrapper({
				"chartType": "'.$chart_type.'",
				"containerId": "chart_'.$uniqid.'",
				"options": {'.implode(',', $options).'}
				});
				var data'.$uniqid.' = google.visualization.arrayToDataTable(['.$data.']);';
				if(isset($chart_option->filterTypeChart)&&$chart_option->filterTypeChart!=''){
				$scripts .= ' dashboard'.$uniqid.'.bind([donutRangeSlider'.$uniqid.'], [filter_chart'.$uniqid.',pieChart'.$uniqid.']);';
				}
				else
				$scripts .= ' dashboard'.$uniqid.'.bind(donutRangeSlider'.$uniqid.', pieChart'.$uniqid.');';
				
				$scripts .= ' dashboard'.$uniqid.'.draw(data'.$uniqid.');
				google.visualization.events.addListener(dashboard'.$uniqid.', "error", function () {
				alert("You have given wrong data");
				});
				';
	  }
	 elseif($chart_type=='Table'){
		    
		        $ser = explode(',', $chart_data->chart_data->series); 
		        $f_type = isset($chart_option->filterType)?'"'.$chart_option->filterType.'"':'"NumberRangeFilter"';
				$t_type = isset($chart_option->filterTypeTable)?'"'.$chart_option->filterTypeTable.'"':'"CategoryFilter"';
				$c_type = isset($chart_option->filterTypeChart)?'"'.$chart_option->filterTypeChart.'"':'"PieChart"';
				$l_type =isset($chart_option->legend)&& $chart_option->legend!=''?$chart_option->legend:'none';
		        $scripts ='';
				$scripts .= 'if(typeof google !== "undefined") google.load("visualization", "1.0", {"packages":["'. $package.'", "controls"],"language": "'.$language[0].'"});
				google.setOnLoadCallback(drawDashboard'.$uniqid.');
				function drawDashboard'.$uniqid.'() {
				
				var dashboard'.$uniqid.'  =  new google.visualization.Dashboard(document.getElementById("dashboard_'.$uniqid.'"));';
				if(isset($chart_option->filterColumnIndex) &&$chart_option->filterColumnIndex!='' ) {
				$scripts .= '
				var donutRangeSlider'.$uniqid.' = new google.visualization.ControlWrapper({
				"controlType": '.$f_type.'
				,"containerId": "filter_'.$uniqid.'"
				,"options": {
				"filterColumnIndex": "'.$chart_option->filterColumnIndex.'"
				  ,"ui": {
                  "label": "'.$chart_option->filterColumnIndex.' Selection:"}';
				if(isset($chart_option->minimum_value)&& $chart_option->minimum_value!='')
				$scripts .= ',"minValue":'.$chart_option->minimum_value;
				if(isset($chart_option->maximum_value)&& $chart_option->maximum_value!='')
				$scripts .= ' ,"maxValue": '.$chart_option->maximum_value;
				$scripts .= '}
				});';}
				if(isset($chart_option->filterColumnIndexTable) &&$chart_option->filterColumnIndexTable!='' ) {
				  $scripts .= 'var categoryPicker'.$uniqid.' = new google.visualization.ControlWrapper({
                "controlType": '.$t_type.'
                ,"containerId": "categoryPicker_div_'.$uniqid.'"
               ,"options": {
               "filterColumnIndex": "'.$chart_option->filterColumnIndexTable.'"
              
			  ,"ui": {
          "labelStacking": "vertical"
         , "label": "'.$ser[$chart_option->filterColumnIndexTable].' Selection:"
         , "allowTyping": false
         , "allowMultiple": false
        }
      }
    });';}
				 if(isset($chart_option->filterTypeChart)){
				$scripts .= ' var filter_chart'.$uniqid.' = new google.visualization.ChartWrapper({
				"chartType": '.$c_type.'
				,"containerId": "pie_div_'.$uniqid.'"
				,"options": {
				"width": "100%"';
				if(count($color_array)>0)
				$scripts .= ',"colors":["'.implode('","',$color_array).'"]';
				$scripts .= ',"legend": "'.$l_type.'"
				,"chartArea": {"left": 5, "top": 5, "right": 0, "bottom": 0, "width":"100%","height":"100%"}';
				
				if($c_type=='"PieChart"'){
				$scripts .= ' ,"pieSliceText": "label"
				,"is3D": "true"';}
				
				$scripts .= '
				},
				"view": {"columns": [0, '.(count(explode(',', $chart_data->chart_data->series))-1).']}
				});';	 
					 
				 }
				$scripts .= 'var pieChart'.$uniqid.' = new google.visualization.ChartWrapper({
				"chartType": "'.$chart_type.'",
				"containerId": "chart_'.$uniqid.'",
				"options": {'.implode(',', $options).'}
				});
				var data'.$uniqid.' = google.visualization.arrayToDataTable(['.$data.']);';
				
				if(isset($chart_option->filterTypeChart) && $chart_option->filterTypeChart!='' && isset($chart_option->filterColumnIndexTable) &&$chart_option->filterColumnIndexTable!=''&& isset($chart_option->filterColumnIndex) &&$chart_option->filterColumnIndex!=''){
				$scripts .= 'dashboard'.$uniqid.'.bind([donutRangeSlider'.$uniqid.', categoryPicker'.$uniqid.'], [filter_chart'.$uniqid.',pieChart'.$uniqid.']);';
				}
				else if(isset($chart_option->filterTypeChart) && $chart_option->filterTypeChart!='' && isset($chart_option->filterColumnIndexTable) &&$chart_option->filterColumnIndexTable!='')
				$scripts .= 'dashboard'.$uniqid.'.bind([categoryPicker'.$uniqid.'],[filter_chart'.$uniqid.',pieChart'.$uniqid.']);';
				else if(isset($chart_option->filterTypeChart) && $chart_option->filterTypeChart!='' && isset($chart_option->filterColumnIndex) &&$chart_option->filterColumnIndex!='' )
				$scripts .= 'dashboard'.$uniqid.'.bind([donutRangeSlider'.$uniqid.'],[filter_chart'.$uniqid.',pieChart'.$uniqid.']);';
				else if(isset($chart_option->filterColumnIndexTable) &&$chart_option->filterColumnIndexTable!='')
				$scripts .= 'dashboard'.$uniqid.'.bind(categoryPicker'.$uniqid.', pieChart'.$uniqid.');';
				else if(isset($chart_option->filterTypeChart) && $chart_option->filterTypeChart!='' && isset($chart_option->filterColumnIndex) &&$chart_option->filterColumnIndex!='' )
				$scripts .= 'dashboard'.$uniqid.'.bind(donutRangeSlider'.$uniqid.', pieChart'.$uniqid.');';
if(isset($chart_title_option->bacground_image) && !empty($chart_title_option->bacground_image))	{
$img = JPATH_SITE.'/components/com_vchart/images/background/'.$chart_title_option->bacground_image; 
$scripts .= ' 
google.visualization.events.addListener(chart'.$uniqid.', "ready", function(){ 
jQuery("#vchart_' . $uniqid . '").css("background", "url('.Juri::root().'components/com_vchart/images/background/'.$chart_title_option->bacground_image.') no-repeat scroll 0 0 rgba(0, 0, 0, 0)");';
if(isset($chart_title_option->background_image_chart_div) && $chart_title_option->background_image_chart_div!='' && $chart_title_option->background_image_chart_div =='background_image_chart_div' )	{

$scripts .= ' var boundingBox'.$uniqid.' = chart'.$uniqid.'.getChartLayoutInterface().getBoundingBox("chartarea");

jQuery("#vchart_' . $uniqid . '").css(\'background-position\', "0 px " + "0 px ").css(\'background-size\', (boundingBox'.$uniqid.'.width+2*boundingBox'.$uniqid.'.left) + "px " + (boundingBox'.$uniqid.'.height+2*boundingBox'.$uniqid.'.top) + "px");';}
else
{

$scripts .= ' var boundingBox'.$uniqid.' = chart'.$uniqid.'.getChartLayoutInterface().getChartAreaBoundingBox();
jQuery("#vchart_' . $uniqid . '").css(\'background-position\', "0 px " + "0 px ").css(\'background-size\', (boundingBox'.$uniqid.'.width+2*boundingBox'.$uniqid.'.left) + "px " + (boundingBox'.$uniqid.'.height+2*boundingBox'.$uniqid.'.top) + "px");';	

}
$scripts .= ' });
';}
				$scripts .= 'dashboard'.$uniqid.'.draw(data'.$uniqid.');
				google.visualization.events.addListener(dashboard'.$uniqid.', "error", function () {
				alert("You have given wrong data");
				});
				';
		 
		 }
	 elseif($chart_type=='ColumnChart' || $chart_type=='BarChart'|| $chart_type=='LineChart'|| $chart_type=='SteppedAreaChart'|| $chart_type=='ComboChart'|| $chart_type=='AreaChart'){
				$f_type = isset($chart_option->filterType)?'"'.$chart_option->filterType.'"':'"NumberRangeFilter"';
				$c_type = isset($chart_option->filterTypeChart)?'"'.$chart_option->filterTypeChart.'"':'"PieChart"';
				$l_type =isset($chart_option->legend)&& $chart_option->legend!=''?$chart_option->legend:'none';
				$scripts ='';
				$scripts .= 'if(typeof google !== "undefined") google.load("visualization", "1.0", {"packages":["'. $package.'", "controls"],"language": "'.$language[0].'"});
				google.setOnLoadCallback(drawDashboard'.$uniqid.');
				function drawDashboard'.$uniqid.'() {
				
				var dashboard'.$uniqid.'  =  new google.visualization.Dashboard(document.getElementById("dashboard_'.$uniqid.'"));
				var donutRangeSlider'.$uniqid.' = new google.visualization.ControlWrapper({
				"controlType": '.$f_type.'
				,"containerId": "filter_'.$uniqid.'"
				,"options": {';
				
				if(isset($chart_option->filterColumnIndex) && $chart_option->filterColumnIndex == 0 && $chart_option->filterColumnIndex=='X axis Value'){
				$scripts .= '"filterColumnIndex": "0"';	
				$label_filter_index = isset($chart_option->x_axis) && $chart_option->x_axis!=''?$chart_option->x_axis:'X axis Value';
				
				}
				elseif(isset($chart_option->filterColumnIndex) && $chart_option->filterColumnIndex != '' &&(int)$chart_option->filterColumnIndex){
				
				$series = explode(',', $chart_data->chart_data->series);
				$index = array_search($series[$chart_option->filterColumnIndex-1], $series);
				$scripts .= '"filterColumnIndex": "'.($index+1).'"';
				$label_filter_index = $series[$chart_option->filterColumnIndex-1];
				}
				
				elseif(isset($chart_option->filterColumnIndex) && $chart_option->filterColumnIndex != ''){
				$series = explode(',', $chart_data->chart_data->series);
				$index = array_search($chart_option->filterColumnIndex, $series);
				$label_filter_index = $chart_option->filterColumnIndex;
				$scripts .= '"filterColumnIndex": "'.($index+1).'"';	
					}
				
                  if($chart_option->x_axis_header_type=='date'|| $chart_option->x_axis_header_type=='datetime')
			     {
					
					$pattern = isset($chart_option->horizontal_type) && $chart_option->horizontal_type!=''?$chart_option->horizontal_type:'yyyy';
					
				 }
				
					
				if($f_type == '"DateRangeFilter"'){
				$scripts .= ',"filterColumnLabel": "Year"
				,"ui": { "format": { "pattern": "'.$pattern.'" } 
				,"label": "'.$label_filter_index.' Selection:"
				}';
				}
				else{
					$scripts .= ',"ui": {
				"label": "'.$label_filter_index.' Selection:"}';
				}
				 
				if(isset($chart_option->minimum_value)&& $chart_option->minimum_value!='')
				$scripts .= ',"minValue":'.$chart_option->minimum_value;
				if(isset($chart_option->maximum_value)&& $chart_option->maximum_value!='')
				$scripts .= ' ,"maxValue": '.$chart_option->maximum_value;
				$scripts .= '}
				});';
				 if(isset($chart_option->filterTypeChart)&& $chart_option->filterTypeChart!=''){
				$scripts .= ' var filter_chart'.$uniqid.' = new google.visualization.ChartWrapper({
				"chartType": '.$c_type.'
				,"containerId": "pie_div_'.$uniqid.'"
				,"options": {
				"width": "100%"';
				if(count($color_array)>0)
				$scripts .= ',"colors":["'.implode('","',$color_array).'"]';
				$scripts .= ',"legend": "'.$l_type.'"
				,"chartArea": {"left": 5, "top": 5, "right": 0, "bottom": 0, "width":"100%","height":"100%"}';
				
				if($c_type=='"PieChart"'){
				$scripts .= ' ,"pieSliceText": "label"
				,"is3D": "true"';}
				
				$scripts .= '
				},
				"view": {"columns": [0, '.count(explode(',', $chart_data->chart_data->series)).']}
				});';	 
					 
				 }
				$scripts .= 'var pieChart'.$uniqid.' = new google.visualization.ChartWrapper({
				"chartType": "'.$chart_type.'",
				"containerId": "chart_'.$uniqid.'",
				"options": {'.implode(',', $options).'}
				});
				var data'.$uniqid.' = google.visualization.arrayToDataTable(['.$data.']);';
				
				if(isset($chart_option->filterTypeChart)){
				  $filter_type = isset($chart_option->filterTypeChart)&& $chart_option->filterTypeChart!=''?'filter_chart'.$uniqid.',':'';
				$scripts .= 'dashboard'.$uniqid.'.bind([donutRangeSlider'.$uniqid.'], ['.$filter_type.'pieChart'.$uniqid.']);';
				}
				else
				$scripts .= 'dashboard'.$uniqid.'.bind(donutRangeSlider'.$uniqid.', pieChart'.$uniqid.');';
				
					if(isset($chart_title_option->bacground_image) && !empty($chart_title_option->bacground_image))	{
					$img = JPATH_SITE.'/components/com_vchart/images/background/'.$chart_title_option->bacground_image; 
					$scripts .= ' 
					google.visualization.events.addListener(chart'.$uniqid.', "ready", function(){ 
					jQuery("#vchart_' . $uniqid . '").css("background", "url('.Juri::root().'components/com_vchart/images/background/'.$chart_title_option->bacground_image.') no-repeat scroll 0 0 rgba(0, 0, 0, 0)");';
					if(isset($chart_title_option->background_image_chart_div) && $chart_title_option->background_image_chart_div!='' && $chart_title_option->background_image_chart_div =='background_image_chart_div' )	{

					$scripts .= ' var boundingBox'.$uniqid.' = chart'.$uniqid.'.getChartLayoutInterface().getBoundingBox("chartarea");

					jQuery("#vchart_' . $uniqid . '").css(\'background-position\', "0 px " + "0 px ").css(\'background-size\', (boundingBox'.$uniqid.'.width+2*boundingBox'.$uniqid.'.left) + "px " + (boundingBox'.$uniqid.'.height+2*boundingBox'.$uniqid.'.top) + "px");';}
					else
					{

					$scripts .= ' var boundingBox'.$uniqid.' = chart'.$uniqid.'.getChartLayoutInterface().getChartAreaBoundingBox();
					jQuery("#vchart_' . $uniqid . '").css(\'background-position\', "0 px " + "0 px ").css(\'background-size\', (boundingBox'.$uniqid.'.width+2*boundingBox'.$uniqid.'.left) + "px " + (boundingBox'.$uniqid.'.height+2*boundingBox'.$uniqid.'.top) + "px");';	

					}
					$scripts .= ' });
					';}
				 if($chart_option->x_axis_header_type=='date'|| $chart_option->x_axis_header_type=='datetime')
			     {
					if (isset($chart_option->horizontal_type) && $chart_option->horizontal_type!='')
					{
					
					$scripts .= 'var formatter'.$uniqid.' = new google.visualization.DateFormat({
					pattern: "'.$chart_option->horizontal_type.'"';
					if(isset($chart_option->y_axis_prefix)&&$chart_option->y_axis_prefix!='')
					 $scripts .= ',prefix: "'.$chart_option->y_axis_prefix.'"';
				   if(isset($chart_option->y_axis_suffix)&&$chart_option->y_axis_suffix!='')
					 $scripts .= ',suffix: "'.$chart_option->y_axis_suffix.'"';
					 $scripts .= '});';
                     $scripts .= 'formatter'.$uniqid.'.format(data'.$uniqid.', 0);';	
										
					}
				 }
				 
				 
				 
				 $scripts .= 'dashboard'.$uniqid.'.draw(data'.$uniqid.');
				google.visualization.events.addListener(dashboard'.$uniqid.', "error", function () {
				alert("You have given wrong data");
				});
				';
	        }
		  }
		  elseif(isset($chart_option->x_axis_start)&&$chart_option->x_axis_start!='' && isset($chart_option->x_axis_end)&&$chart_option->x_axis_end!='' && isset($chart_option->window_view_button_show) && $chart_option->window_view_button_show!='')
		  {$axis_values = explode(',', $chart_data->chart_data->axis_value);
			if($chart_option->x_axis_header_type=='string' || $chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
					$minimum_value = $chart_option->x_axis_start;
					     elseif($chart_option->x_axis_header_type=='number'){
							$axis_values = explode(',', $chart_data->chart_data->axis_value);
							$minimum_value = $axis_values[$chart_option->x_axis_start];}
                         elseif($chart_option->x_axis_header_type=='date' ||  $chart_option->x_axis_header_type=='datetime'){
							   $axis_values = explode(',', $chart_data->chart_data->axis_value);
							   $date_type = strlen(trim($axis_values[$chart_option->x_axis_start]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[$chart_option->x_axis_start]))),'Y').'"';}else{$date_value = date_format(new DateTime($axis_values[$chart_option->x_axis_start]), $date_type);}
			                $minimum_value = 'new Date('.$date_value.')'; }
							
							if($chart_option->x_axis_header_type=='string' || $chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
					       $maximum_value = $chart_option->x_axis_end;
					     elseif($chart_option->x_axis_header_type=='number'){
							$axis_values = explode(',', $chart_data->chart_data->axis_value);
							$maximum_value = $axis_values[$chart_option->x_axis_end];
							 $maximum_axis_value = $axis_values[count($axis_values)-1];
							}
                         elseif($chart_option->x_axis_header_type=='date' ||  $chart_option->x_axis_header_type=='datetime'){
							   $axis_values = explode(',', $chart_data->chart_data->axis_value);
							   $date_type = strlen(trim($axis_values[$chart_option->x_axis_end]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[$chart_option->x_axis_end]))),'Y').'"';}else{$date_value = date_format(new DateTime($axis_values[$chart_option->x_axis_end]), $date_type);}
			                $maximum_value = 'new Date('.$date_value.')'; 
							$date_type = strlen(trim($axis_values[count($axis_values)-1]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$axis_values[count($axis_values)-1]))),'Y').'"';}else{$date_value = date_format(new DateTime($axis_values[count($axis_values)-1]), $date_type);}
							$maximum_axis_value = 'new Date('.$date_value.')'; 
							}
			if($chart_option->x_axis_header_type=='string' || $chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
					$view_min_value = 0;
					     elseif($chart_option->x_axis_header_type=='number'){
							$axis_values = explode(',', $chart_data->chart_data->axis_value);
							$view_min_value = $axis_values[0];}
							elseif($chart_option->x_axis_header_type=='date' ||  $chart_option->x_axis_header_type=='datetime'){
			                 $axis_values = explode(',', $chart_data->chart_data->axis_value);
							   $date_type = strlen(trim($axis_values[0]))>4?'Y,m,d,H,i,s':'Y';
			if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1, $axis_values[0]))),'Y').'"';}else{$date_value = date_format(new DateTime($axis_values[0]), $date_type);}
			                $view_min_value = 'new Date('.$date_value.')'; 
							 }
			$scripts = ' if(typeof google !== "undefined") google.load("visualization", "1.1", {"packages":["'. $package.'", "controls"],"language": "'.$language[0].'"});	
				google.setOnLoadCallback(drawChart' . $uniqid . ');
				function drawChart' . $uniqid . '() {
				var data'.$uniqid.' = google.visualization.arrayToDataTable(['.$data.']);
				
				var options'.$uniqid.' = {'.implode(',', $options).'};
				var chart'.$uniqid.' =  new google.visualization.'.$chart_type.'(document.getElementById("vchart_' . $uniqid . '"));
				';
					$minimum_index = isset($chart_option->x_axis_start)&& $chart_option->x_axis_start!=''?$chart_option->x_axis_start:$chart_option->x_axis_end;
					$maximum_index = isset($chart_option->x_axis_end)&& $chart_option->x_axis_end!=''?$chart_option->x_axis_end:$chart_option_start;
					if($chart_option->x_axis_header_type=='string' || $chart_data->database_type=='chart_data_from_existing' || $chart_data->database_type=='chart_data_from_other_database')
					$scripts .= '  var MAX'.$uniqid.' = data'.$uniqid.'.getNumberOfRows();';
				elseif($chart_option->x_axis_header_type=='number' || $chart_option->x_axis_header_type=='date' || $chart_option->x_axis_header_type=='datetime')                     $scripts .= '  var MAX'.$uniqid.' ='.$maximum_axis_value.';';
				$scripts .= ' var prevButton'.$uniqid.' = document.getElementById("example5-b1'.$uniqid.'");
				var minimum_index= '.$minimum_index.';
				var maximum_index= '.$maximum_index.';
var nextButton'.$uniqid.' = document.getElementById("example5-b2'.$uniqid.'");
var changeZoomButton'.$uniqid.' = document.getElementById("example5-b3'.$uniqid.'");
function drawCharts() {

prevButton'.$uniqid.'.disabled = true;
nextButton'.$uniqid.'.disabled = true;
changeZoomButton'.$uniqid.'.disabled = true;
google.visualization.events.addListener(chart' . $uniqid . ', "ready",
function() {';
if($chart_option->x_axis_header_type=='string'||($chart_option->x_axis_header_type!='date' && $chart_option->x_axis_header_type!='datetime'&& $chart_option->x_axis_header_type!='number')){
$scripts .= ' 
prevButton'.$uniqid.'.disabled = options' . $uniqid . '.hAxis.viewWindow.min <= 0;
 nextButton'.$uniqid.'.disabled = options' . $uniqid . '.hAxis.viewWindow.max >= MAX'.$uniqid.';
changeZoomButton'.$uniqid.'.disabled = false;
});';
 if($chart_option->x_axis_header_type=='date'|| $chart_option->x_axis_header_type=='datetime')
			     {
					if (isset($chart_option->horizontal_type) && $chart_option->horizontal_type!='')
					{
					
					$scripts .= 'var formatter'.$uniqid.' = new google.visualization.DateFormat({
					pattern: "'.$chart_option->horizontal_type.'"';
					if(isset($chart_option->y_axis_prefix)&&$chart_option->y_axis_prefix!='')
					 $scripts .= ',prefix: "'.$chart_option->y_axis_prefix.'"';
				   if(isset($chart_option->y_axis_suffix)&&$chart_option->y_axis_suffix!='')
					 $scripts .= ',suffix: "'.$chart_option->y_axis_suffix.'"';
					 $scripts .= '});';
                     $scripts .= 'formatter'.$uniqid.'.format(data'.$uniqid.', 0);';	
										
					}
				 }


$scripts .= ' chart' . $uniqid . '.draw(data' . $uniqid . ', options' . $uniqid . ');
}

prevButton'.$uniqid.'.onclick = function() {
	
options' . $uniqid . '.hAxis.viewWindow.min -= 1;
options' . $uniqid . '.hAxis.viewWindow.max -= 1;
drawCharts();
}
nextButton'.$uniqid.'.onclick = function() {
	
options' . $uniqid . '.hAxis.viewWindow.min += 1;
options' . $uniqid . '.hAxis.viewWindow.max += 1;
drawCharts();
};
var zoomed'.$uniqid.' = false;
changeZoomButton'.$uniqid.'.onclick = function() {
	if (zoomed'.$uniqid.') {
options' . $uniqid . '.hAxis.viewWindow.min = '.$chart_option->x_axis_start.';
options' . $uniqid . '.hAxis.viewWindow.max = '.$chart_option->x_axis_end.';
jQuery(this).val("'.JText::_("VCHART_COM_ZOOM_OUT").'");
} else {
options' . $uniqid . '.hAxis.viewWindow.min = 0;
options' . $uniqid . '.hAxis.viewWindow.max = MAX'.$uniqid.';
jQuery(this).val("'.JText::_("VCHART_COM_ZOOM_IN").'");
}
zoomed'.$uniqid.' = !zoomed'.$uniqid.';
drawCharts();
}
drawCharts();
';
}
if($chart_option->x_axis_header_type=='date' || $chart_option->x_axis_header_type=='datetime'|| $chart_option->x_axis_header_type=='number'){
	 $scripts .= ' prevButton'.$uniqid.'.disabled = options' . $uniqid . '.hAxis.viewWindow.min <= data'.$uniqid.'.getValue(0,0);
 nextButton'.$uniqid.'.disabled = options' . $uniqid . '.hAxis.viewWindow.max >= data'.$uniqid.'.getValue(data'.$uniqid.'.getNumberOfRows()-1,0);
changeZoomButton'.$uniqid.'.disabled = false;
});';

if(isset($chart_title_option->bacground_image) && !empty($chart_title_option->bacground_image))	{
	  $img = JPATH_SITE.'/components/com_vchart/images/background/'.$chart_title_option->bacground_image; 
   $scripts .= ' 
   google.visualization.events.addListener(chart'.$uniqid.', "ready", function(){ 
  jQuery("#vchart_' . $uniqid . '").css("background", "url('.Juri::root().'components/com_vchart/images/background/'.$chart_title_option->bacground_image.') no-repeat scroll 0 0 rgba(0, 0, 0, 0)");';
	 if(isset($chart_title_option->background_image_chart_div) && $chart_title_option->background_image_chart_div!='' && $chart_title_option->background_image_chart_div =='background_image_chart_div' )	{
		 
	$scripts .= ' var boundingBox'.$uniqid.' = chart'.$uniqid.'.getChartLayoutInterface().getBoundingBox("chartarea");
	
	jQuery("#vchart_' . $uniqid . '").css(\'background-position\', "0 px " + "0 px ").css(\'background-size\', (boundingBox'.$uniqid.'.width+2*boundingBox'.$uniqid.'.left) + "px " + (boundingBox'.$uniqid.'.height+2*boundingBox'.$uniqid.'.top) + "px");';}
	else
	{
		 
	$scripts .= ' var boundingBox'.$uniqid.' = chart'.$uniqid.'.getChartLayoutInterface().getChartAreaBoundingBox();
	jQuery("#vchart_' . $uniqid . '").css(\'background-position\', "0 px " + "0 px ").css(\'background-size\', (boundingBox'.$uniqid.'.width+2*boundingBox'.$uniqid.'.left) + "px " + (boundingBox'.$uniqid.'.height+2*boundingBox'.$uniqid.'.top) + "px");';	
		
		}
	$scripts .= ' });
  ';}

 $scripts .= 'chart' . $uniqid . '.draw(data' . $uniqid . ', options' . $uniqid . ');
}
	 prevButton' . $uniqid . '.onclick = function() { 
	maximum_index -= 1; 
	minimum_index -= 1; 
	options' . $uniqid . '.hAxis.viewWindow.min = data'.$uniqid.'.getValue(minimum_index,0); 
	options' . $uniqid . '.hAxis.viewWindow.max = data'.$uniqid.'.getValue(maximum_index,0); 
	drawCharts(); } ;
	nextButton' . $uniqid . '.onclick = function() { 
	maximum_index += 1; 

	minimum_index += 1; 
	options' . $uniqid . '.hAxis.viewWindow.min =data'.$uniqid.'.getValue(minimum_index,0); 
	options' . $uniqid . '.hAxis.viewWindow.max = data'.$uniqid.'.getValue(maximum_index,0); 
	drawCharts(); }
	var zoomed'.$uniqid.' = false;
changeZoomButton'.$uniqid.'.onclick = function() {
	if (zoomed'.$uniqid.') {
options' . $uniqid . '.hAxis.viewWindow.min = '.$minimum_value.';
options' . $uniqid . '.hAxis.viewWindow.max = '.$maximum_value.';
} else {
options' . $uniqid . '.hAxis.viewWindow.min = '.$view_min_value.';
options' . $uniqid . '.hAxis.viewWindow.max = data'.$uniqid.'.getValue(data'.$uniqid.'.getNumberOfRows()-1,0);
}
zoomed'.$uniqid.' = !zoomed'.$uniqid.';
drawCharts();
}
drawCharts();
';}	}
		  else{
				
				$scripts = '';
			}
			
  
 if($chart_type=='GeoChart' && count($url_array)>0){ 
 $url_array = "'".implode("','", $url_array)."'";
     $scripts .= 'google.visualization.events.addListener(chart'.$uniqid.', "select", function(){ 
		           var selectionIdx = chart'.$uniqid.'.getSelection()[0].row;
				    var url_array = new Array('.$url_array.');
					var value = url_array[selectionIdx];																		                 
					if (value != "#")
                       window.open(value); 
                       });';
 }
          $scripts .= '}';
            $total_data = array();
			$total_data[0] = $scripts;
			$total_data[1] = $package;
			$total_data[2] = $data;
			$total_data[3] = $options;
			$total_data[4] = $chart_title_option;
			$total_data[5] = $chart_option;
			$total_data[6] = $chart_type;
			$total_data[7] =  $chart_data->chart_data;
			$total_data[8] =  $color_array;
			$total_data[9] =  $chart_data;
			
			$obj->result = 'success';
			$obj->data = $total_data;
           return $obj;
	
	}
		static function data_from_existing_database($tablename,$axis_values,$column_name,$x,$s,$chart_type,$chart_options,$current_limit)
		{ 
			
			
			$obj = new stdClass();
			$obj->result = 'error';	
			$user_id = JFactory::getUser();
			if($tablename->database_type=='chart_data_from_existing'){
			  $db = JFactory::getDbo();	
			}
			if($tablename->database_type=='chart_data_from_other_database')
			{
				$option = array(); 
				try
				{
					$option['driver']   = $tablename->db_driver;            
					$option['host']     = $tablename->db_host;  
					$option['user']     = $tablename->db_root;  
					$option['password'] = $tablename->db_pass; 
					$option['database'] = $tablename->db_database; 
					$option['prefix']   = $tablename->db_prefix;  
					$db = JDatabaseDriver::getInstance( $option );
					$db->connect(); 
				}
				catch (RuntimeException $e)
				{                   
					$obj->result = 'error';
					$obj->error = $e->getMessage(); 
					return $obj;
				
				}
			}
		
			
			$data = $datas = array();
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!=''){
			       $regex = '/{(.*?)}/i';
				   $regex_userid = '/{loggedinuserid}/i';
		   
		          preg_match_all($regex, $tablename->chart_extra_parms, $matches, PREG_SET_ORDER); 
				  $url_parameters  = $_GET; 
                  
				 if($matches){ 
				     
						 foreach ($matches as $match)
						 {
						  
						     preg_match_all($regex_userid, $tablename->chart_extra_parms, $usermatches, PREG_SET_ORDER);
							  
							  if($usermatches){
								  if(!$user_id->id)
								     return;
							   foreach ($usermatches as $match_updates){
								  $tablename->chart_extra_parms = preg_replace("|$match_updates[0]|", $db->quote($user_id->id), $tablename->chart_extra_parms, 1); 
								   }
							  }
						
						   if (array_key_exists($match[1],$url_parameters)==1){
							  $return_key = array_search($match[1],$url_parameters);
							  $tablename->chart_extra_parms = preg_replace("|$match[0]|", $url_parameters[$match[1]], $tablename->chart_extra_parms, 1);	 
							   
							   }
						  
						   }
				       
				      }	
			
				}
			if($chart_type=='Line Chart' || $chart_type=='Area Chart'){
			$item = '';
				if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' )
				{
				
					 $query = $tablename->chart_extra_parms; 
					 if(strpos(strtolower($query), 'limit')!== false){
					  $query = substr($query, 0, strpos(strtolower($query), 'limit'));
					  
					  $query .= ' LIMIT '.($current_limit+1).' , 1';
					}
					else
					{
					  
					  $query .= ' LIMIT '.($current_limit+1).' , 1';	
					}
						
					   $db->setQuery($query);
						
						if($db->getErrorNum())	
						{
						$obj->result = 'error';
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
					
					$data = $db->loadObjectList();
					$item = array();
					$label = isset($x->x_axis)?$x->x_axis:'ID';
						if(isset($x->x_axis_header_type)){
						$y = new stdClass;
						$y->type = $x->x_axis_header_type;
						$y->label = $label;
						array_push($item, $y);
						}
						else{
						$y = new stdClass;
						$y->type = 'string';
						$y->label = $label;
						array_push($item, $y);
						}
						
						
					  $s = explode(',', $s);
					  for($g=0;$g<count($s);$g++){
						array_push($item, $s[$g]);   
					   }
					array_push($datas,$item);
					$chart_series = count($s);
					for($i=0;$i<count($data);$i++)
					{ 
						$arr = $data[$i];
						$h_axis = 0;
						$item = '[';
						$item = array();
						$using_series = count(get_object_vars($arr))-1;
						if( $using_series != $chart_series){
						$obj->result = 'error';
						$obj->error = "Number of Columns for series and Number of series should be equal";
						return $obj;}
						foreach ($arr as $key => $value) {
							if($h_axis==0)
							{
									$h_axis=1;
									
									if($value=='')
									continue;
								
									if(isset($x->x_axis_header_type))
									{
										if($x->x_axis_header_type=='date'||$x->x_axis_header_type=='datetime')
										{
											$date_type = strlen(trim($value))>4?'Y,m,d,H,i,s':'Y';
											if($date_type=='Y')
											{ 
											$date_value = date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$value))),'Y');
											
											}
											else
											{
												
											if(strpos(substr($value,0,10), ':')!== false){
											$value = substr_replace($value,str_replace(':', '-', substr($value,0,10)),0,10);
											//$value = date('Y-m-d', strtotime($date)); 
											}
											if(strpos(substr($value,0,10), '/')!== false){
											$value =  substr_replace($value,str_replace('/', '-', substr($value,0,10)),0,10);
											//$value = date('Y-m-d', strtotime($date)); 	
											}

											$date_value = date_format(new DateTime($value), $date_type);
											$update_date = explode(',', $date_value);
											$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
												
											}
										
										   
										   array_push($item, 'new Date('.$date_value.')');
										
										 }
										elseif($x->x_axis_header_type=='number')
									    array_push($item, $value);
										else
										array_push($item, '"'.$value.'"');
									 }
								else
								array_push($item, '"'.$value.'"');
							}
							else
							{
								array_push($item, (float)$value);
						
							
							}
							
						}
					
						array_push($datas,$item);
						
					}
				
				}
				else
				{
				$chart_setting_option = json_decode($tablename->chart_option);
				$chart_setting_data = ($tablename->chart_data);
				
				if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
					$query = 'select '.$db->quotename($chart_setting_data->x_axis_columns).',`'.implode("`,`" ,$column_name).'` from '.$tablename->existing_database_table;
				if(!empty($tablename->extra_condition))
				$query .= ' where '.$tablename->extra_condition;
			    if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				
				if(isset($chart_setting_option->orderbycolumn) && $chart_setting_option->orderbycolumn!=''){
					 if(isset($tablename->ordering) && $tablename->ordering!='')
					$query .= ' ORDER BY '.$chart_setting_option->orderbycolumn.' '.$tablename->ordering; 
					}
					
				   $query .= ' LIMIT 1'; 
				}
				else{
				 $query = 'select '.$db->quotename($chart_setting_data->x_axis_columns).',`'.implode("`,`" ,$column_name).'` from '.$tablename->existing_database_table;
				if(!empty($tablename->extra_condition))
				$query .= ' where '.$tablename->extra_condition;
			    if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				
				if(isset($chart_setting_option->orderbycolumn) && $chart_setting_option->orderbycolumn!=''){
					 if(isset($tablename->ordering) && $tablename->ordering!='')
					$query .= ' ORDER BY '.$chart_setting_option->orderbycolumn.' '.$tablename->ordering; 
					}
					
				  $query .= ' LIMIT '.($current_limit).' , 1';
				}
				
				
				
				$db->setQuery($query);
				if($db->getErrorNum())	{
				$obj->result = 'error';
				$obj->error = $db->getErrorMsg(); 
				return $obj;
				}
				$data = $db->loadObjectList(); 
                     
			
				$item = array();
				
				$label = isset($x->x_axis)&&$x->x_axis!=''?$x->x_axis:'"ID"';
					if(isset($x->x_axis_header_type))	{
						$y = new stdClass;
						$y->type = $x->x_axis_header_type;
						$y->label = $label;
						array_push($item, $y); 
					//array_push($item, '{type:"'.$x->x_axis_header_type.'", label:"'.$label.'"}');
					}
					else	{
						$y = new stdClass;
						$y->type = 'string';
						$y->label = $label;
						array_push($item, $y);
					//array_push($item, '{type:"string", label:"'.$label.'"}');
					}
				$s = explode(',', $s);
					  for($g=0;$g<count($s);$g++){
						array_push($item, $s[$g]);   
					   }
				
				
				array_push($datas,$item);
				for($i=0;$i<count($data);$i++)	{
				
				$item = array();
				$g=0;
				foreach($data[$i] as $key => $value){
				
			   
			    if($g==0)
				{ $g++;
				if(isset($x->x_axis_header_type)){
				if($x->x_axis_header_type=='date'||$x->x_axis_header_type=='datetime'){
				$date_type = strlen(trim($value))>4?'Y,m,d,H,i,s':'Y';
				if($date_type=='Y'){ 
				$date_value = date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$value))),'Y');}else{
					
					if(strpos(substr($value,0,10), ':')!== false){
					$value = substr_replace($value,str_replace(':', '-', substr($value,0,10)),0,10);
					//$value = date('Y-m-d', strtotime($date)); 
					}
					if(strpos(substr($value,0,10), '/')!== false){
					$value =  substr_replace($value,str_replace('/', '-', substr($value,0,10)),0,10);
					//$value = date('Y-m-d', strtotime($date)); 	
					}

					$date_value = date_format(new DateTime($value), $date_type);
					$update_date = explode(',', $date_value);
					$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
					
					
					/* $date_value = date_format(new DateTime($axis_values[$i]), $date_type);
				$date_value = explode(',', $date_value);
                $date_value = $date_value[0].','.($date_value[1]-1).','.$date_value[2].','.$date_value[3].','.$date_value[4].','.$date_value[5]; */ 
				}
				
				 array_push($item, 'new Date('.$date_value.')');
				}
				elseif($x->x_axis_header_type=='number')
				array_push($item, (float)$value);
				else
				array_push($item, $value);
				}
				else
				array_push($item, $value);
				}
				else
				  array_push($item, (float)$value);
				
				}
				
				array_push($datas,$item);
				}
				}
			}
		elseif($chart_type=='Timeline Chart')
		{
			
			
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
		     $query = $tablename->chart_extra_parms;
			  if(strpos(strtolower($query), 'limit')!== false){
					  $query = substr($query, 0, strpos(strtolower($query), 'limit'));
					  
					  $query .= ' LIMIT '.($current_limit+1).' , 1';
					}
					else
					{
					  
					  $query .= ' LIMIT '.($current_limit+1).' , 1';	
					}
		     $db->setQuery($query);
			if($db->getErrorNum())	{
			$obj->result = 'error';
			$obj->error = $db->getErrorMsg();
			return $obj;
			}
			 
		     $data = $db->loadObjectList();
			 $item = array();
			 $time_line = new stdClass;
			
			
						if(isset($tablename->chart_data->s_header[0]->section))
						    {
							$time_line->type = 'string';
							$time_line->id = $tablename->chart_data->s_header[0]->section;
							//'{type:"string",id:"'.$tablename->chart_data->s_header[0]->section.'"},'
							}
						else
						{
							$time_line->type = 'string';
							$time_line->id = 'Section';;
							
							//'{ type: "string", id:"Section" },';
					    }
						array_push($item, $time_line);
						$time_line = new stdClass;
						if(isset($tablename->chart_data->s_header[1]->title))
						    {
							$time_line->type = 'string';
							$time_line->id = $tablename->chart_data->s_header[1]->title;
							//'{type:"string",id:"'.$tablename->chart_data->s_header[0]->section.'"},'
							}
						else
						{
							$time_line->type = 'string';
							$time_line->id = 'Label';;
							
							//'{ type: "string", id:"Section" },';
					    }
						array_push($item, $time_line);
						$time_line = new stdClass;
						if(isset($tablename->chart_data->s_header[2]->start))
						    {
							$time_line->type = 'date';
							$time_line->id = $tablename->chart_data->s_header[2]->start;
							//'{type:"string",id:"'.$tablename->chart_data->s_header[0]->section.'"},'
							}
						else
						{
							$time_line->type = 'date';
							$time_line->id = 'Start';;
							
							//'{ type: "string", id:"Section" },';
					    }
						array_push($item, $time_line);
						$time_line = new stdClass;
						if(isset($tablename->chart_data->s_header[3]->end))
						    {
							$time_line->type = 'date';
							$time_line->id = $tablename->chart_data->s_header[3]->end;
							//'{type:"string",id:"'.$tablename->chart_data->s_header[0]->section.'"},'
							}
						else
						{
							$time_line->type = 'date';
							$time_line->id = 'End';;
							
							//'{ type: "string", id:"Section" },';
					    }
						array_push($item, $time_line);
						/* $time_line = new stdClass;
						//$item .= isset($tablename->chart_data->s_header[1]->title)?'{type:"string",id:"'.$tablename->chart_data->s_header[1]->title.'"},':'{ type: "string", id:"Label" },';
						
						$item .= isset($tablename->chart_data->s_header[2]->start)?'{type:"date",id:"'.$tablename->chart_data->s_header[2]->start.'"},':'{ type: "date", id:"Start" },';
						$item .= isset($tablename->chart_data->s_header[3]->end)?'{type:"date",id:"'.$tablename->chart_data->s_header[3]->end.'"}':'{ type: "date", id:"End" }';
						
			  $item .= ']'; */
			array_push($datas,$item);
			
			for($i=0;$i<count($data);$i++)
			        {
						$arr = $data[$i];
						$item = array();
						$c=0;$start=''; $end = '';
								
								foreach ($arr as $key => $value)
								{
								
										if($c==0){
									   array_push($item, "Id");
									   array_push($item ,'"'.$value.'"');
									
										}
										
										if($c==1)
										{
											$start =$value; 
											if(strpos(substr($value,0,10), ':')!== false){
											$value = substr_replace($value,str_replace(':', '-', substr($value,0,10)),0,10);
											//$value = date('Y-m-d', strtotime($date)); 
											}
											if(strpos(substr($value,0,10), '/')!== false){
											$value =  substr_replace($value,str_replace('/', '-', substr($value,0,10)),0,10);
											//$value = date('Y-m-d', strtotime($date)); 	
											}

											$date_value = date_format(new DateTime($value), $date_type);
											$update_date = explode(',', $date_value);
											$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
								            array_push($item ,' new Date('. $data_value.')');
										
										
										
										}
										if($c==2){$end = $value;
											if(strpos(substr($value,0,10), ':')!== false){
											$value = substr_replace($value,str_replace(':', '-', substr($value,0,10)),0,10);
											//$value = date('Y-m-d', strtotime($date)); 
											}
											if(strpos(substr($value,0,10), '/')!== false){
											$value =  substr_replace($value,str_replace('/', '-', substr($value,0,10)),0,10);
											//$value = date('Y-m-d', strtotime($date)); 	
											}

											$date_value = date_format(new DateTime($value), $date_type);
											$update_date = explode(',', $date_value);
											$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
											array_push($item ,' new Date('. $data_value.')');
										
										}
										$c++;
								} 
								
								
							  
								array_push($datas,$item);
								
						}	
			}
		
			else{
			        $chart_setting_options = json_decode($tablename->chart_option);
					$limit_option = '';
					if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
					$limit_option = ' LIMIT 1';
					}
					else{ 
					$current_limit= JRequest::getString('current_limit', '');
				    $limit_option = ' LIMIT '.($current_limit).' , 1';	
					}
					$query = 'select '.$db->quotename($tablename->chart_data->labeling_section_columns_name).' from '.$db->quotename($tablename->existing_database_table);
					if(!empty($tablename->extra_condition))
					$query .= ' where '.$tablename->extra_condition;
					if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
					if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
					$query .= $limit_option;
					 
					$db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$data_section = $db->loadObjectList();
					
					$query = 'select '.$db->quotename($tablename->chart_data->bar_label_columns_name).' from '.$db->quotename($tablename->existing_database_table);
					if(!empty($tablename->extra_condition))
					$query .= ' where '.$tablename->extra_condition;
					if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
					if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
					$query .= $limit_option;
					
					$db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$data_bar = $db->loadObjectList();
		   
					$query = 'select '.$db->quotename($tablename->chart_data->start_date_columns_name).' from '.$db->quotename($tablename->existing_database_table);
					if(!empty($tablename->extra_condition))
					$query .= ' where '.$tablename->extra_condition;
					if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
					if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
					$query .= $limit_option;
					
					$db->setQuery($query); 
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$data_start = $db->loadObjectList();
					
					$query = 'select '.$db->quotename($tablename->chart_data->end_date_columns_name).' from '.$db->quotename($tablename->existing_database_table);
					if(!empty($tablename->extra_condition))
					$query .= ' where '.$tablename->extra_condition;
					if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
					if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
					$query .= $limit_option;
					
					$db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$data_end = $db->loadObjectList();
					
					$var_section =$tablename->chart_data->labeling_section_columns_name;
					$var_bar =$tablename->chart_data->bar_label_columns_name;$var_start =$tablename->chart_data->start_date_columns_name; $var_end =$tablename->chart_data->end_date_columns_name;
						for($i=0;$i<count($data_bar);$i++)
						{
							$item=array();
							$diff=date_diff(new DateTime($data_end[$i]->$var_end),new DateTime($data_start[$i]->$var_start));
							$diff=$diff->format("%s");
							if($diff>=0){
							
							if(isset($data_section[$i]->$var_section))
							{
							array_push($item, '"'.$data_section[$i]->$var_section.'"');	
							}
							else{
							array_push($item, '""');	
								
							}
							if(isset($data_bar[$i]->$var_bar))
							{
							array_push($item, '"'.$data_bar[$i]->$var_bar.'"');	
							}
							else{
							array_push($item, '""');	
								
							}
							
							
							
							if(isset($data_start[$i]->$var_start))
							 {
								if(strpos(substr($data_start[$i]->$var_start,0,10), ':')!== false){
								$data_start[$i]->$var_start = substr_replace($data_start[$i]->$var_start,str_replace(':', '-', substr($data_start[$i]->$var_start,0,10)),0,10);
								//$value = date('Y-m-d', strtotime($date)); 
								}
								if(strpos(substr($data_start[$i]->$var_start,0,10), '/')!== false){
								$data_start[$i]->$var_start =  substr_replace($data_start[$i]->$var_start,str_replace('/', '-', substr($data_start[$i]->$var_start,0,10)),0,10);
								//$value = date('Y-m-d', strtotime($date)); 	
								}

								$date_value = date_format(new DateTime($data_start[$i]->$var_start), $date_type);
								$update_date = explode(',', $date_value);
								$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];	
								array_push($item, 'new Date('.$data_value.')');
								
							
							}
							if(isset($data_end[$i]->$var_end)){
								if(strpos(substr($data_end[$i]->$var_end,0,10), ':')!== false){
								$data_end[$i]->$var_end = substr_replace($data_end[$i]->$var_end,str_replace(':', '-', substr($data_end[$i]->$var_end,0,10)),0,10);
								//$value = date('Y-m-d', strtotime($date)); 
								}
								if(strpos(substr($data_end[$i]->$var_end,0,10), '/')!== false){
								$data_end[$i]->$var_end =  substr_replace($data_end[$i]->$var_end,str_replace('/', '-', substr($data_end[$i]->$var_end,0,10)),0,10);
								//$value = date('Y-m-d', strtotime($date)); 	
								}

								$date_value = date_format(new DateTime($data_end[$i]->$var_end), $date_type);
								$update_date = explode(',', $date_value);
								$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
								array_push($item, 'new Date('.$data_value.')');
							
							}
								
							array_push($datas,$item);
							}
						}	
		 
			      }
			}
		elseif($chart_type=='Scatter Chart'){
		$item = '';
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' )
			{
				$query = $tablename->chart_extra_parms; 
				if(strpos(strtolower($query), 'limit')!== false){
				$query = substr($query, 0, strpos(strtolower($query), 'limit'));
				
				$query .= ' LIMIT '.($current_limit+1).' , 1';
				}
				else
				{
				
				$query .= ' LIMIT '.($current_limit+1).' , 1';	
				}
				$db->setQuery($query);
				if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
				$data = $db->loadObjectList();
				$item = array();$scatter_series = explode(',', $s);
				array_push($item, "Demo");
				for($f=0;$f<count($scatter_series);$f++){
				array_push($item , '"'.$scatter_series[$f].'"');	
				}
				
				array_push($datas,$item);
				$chart_series = count($scatter_series);
					for($i=0;$i<count($data);$i++)	
					{
						$arr = $data[$i];
						$item = array();
						$t =0;
						$using_series = count(get_object_vars($arr))-1;
						if( $using_series != count($scatter_series)){
						$obj->result = 'error';
						$obj->error = "Number of Columns for series and Number of series should be equal";
						return $obj;}
						foreach ($arr as $key => $value){
							array_push($item, (float)$value);
						
						}
					
						array_push($datas,$item);
					}	
				
					
					}else{
					
					$chart_setting_options = json_decode($tablename->chart_option);
					$limit_option = '';
					if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc')
					{ 
					$limit_option = ' LIMIT 1';
					}
					else
					{
					
				    $limit_option = ' LIMIT '.($current_limit).' , 1';	
					}
					$query = 'select `'.implode('`,`', $column_name).' from '.$db->quotename($tablename->existing_database_table);
					if(!empty($tablename->extra_condition))
					$query .= ' where '.$tablename->extra_condition;
					if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
					if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
					$query .= $limit_option;
					
					$db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$data = $db->loadObjectList();
					
					$item = array();$scatter_series = explode(',', $s);
					array_push($item, "Demo");
					for($f=0;$f<count($scatter_series);$f++){
					array_push($item , '"'.$scatter_series[$f].'"');	
					}

					array_push($datas,$item);
					$item = array();
					for($i=0;$i<count($data);$i++)	{
					$item = array();
					foreach($data[$i] as $key=>$value){
					array_push($item, (float)$value);	
					}
					
					array_push($datas,$item);
					}	
				}
					
			}
		
			elseif($chart_type=='Table'){
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
				        $chart_option = json_decode($tablename->chart_option);
						$query = $tablename->chart_extra_parms; 
							if(strpos(strtolower($query), 'limit')!== false){
							$query = substr($query, 0, strpos(strtolower($query), 'limit'));
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';
							}
							else
							{
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';	
							}
						$db->setQuery($query);
						if($db->getErrorNum())
						{
						$obj->result = 'error';
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
						$data = $db->loadObjectList();
						
					    $series = explode(',', $tablename->chart_data->series);
						$item = array();
						for($i=0;$i<count($chart_option->table_column_format);$i++){
							
							$data_type = isset($chart_option->table_column_format[$i])&& $chart_option->table_column_format[$i]!=''?$chart_option->table_column_format[$i]:"string";
							$y = new stdClass;
							$y->type = $data_type;
						    $y->label = $series[$i];
							array_push($item, $y);
							
							}
					
						
						
						array_push($datas, $item);
						
						for($i=0;$i<count($data);$i++)
						{
						$data_new = $data[$i];
						$item = array();
						
						$g = 0;
							foreach ($data_new as $key => $value)
							{
						      if($g == 0){
							    if(isset($chart_option->table_column_format[$g])&& $chart_option->table_column_format[$g]=='number'){
									array_push($item, (float)$value);
								
									}
								elseif(isset($chart_option->table_column_format[$g])&& $chart_option->table_column_format[$g]=='string'){
									array_push($item, '"'.$value.'"');
									
									}
								elseif(isset($chart_option->table_column_format[$g])&& $chart_option->table_column_format[$g]=='boolen'){
									array_push($item, (int)$value);
								
									}
							    else
								array_push($item, '"'.$value.'"');
							   }
							  else{
							  if(isset($chart_option->table_column_format[$g])&& $chart_option->table_column_format[$g]=='number'){
									array_push($item, (float)$value);
									}
								elseif(isset($chart_option->table_column_format[$g])&& $chart_option->table_column_format[$g]=='string'){
									array_push($item, '"'.$value.'"');
									}
								elseif(isset($chart_option->table_column_format[$g])&& $chart_option->table_column_format[$g]=='boolen'){
									array_push($item, (int)$value);
									}
							    else
									array_push($item, '"'.$value.'"');
							  
							  }
							  $g++;
							}
						
						array_push($datas, $item);
					}
			 
			 }
			 else {
			$chart_setting_options = json_decode($tablename->chart_option); 
			$limit_option = '';
			if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
			$limit_option = ' LIMIT 1';
			}
			else{
			$current_limit= JRequest::getString('current_limit', '');
			$limit_option = ' LIMIT '.($current_limit).' , 1';	
			}
			$column_name = explode(',',$tablename->chart_data->series_column_name);
		$item=array();
		//echo count($tablename->chart_data->s_header); jexit();
		
		for($k=0;$k<count($tablename->chart_data->s_header);$k++)
		{   $header_title = $tablename->chart_data->s_header[$k];
	        array_push($item, '"'.$header_title->title.'"');
			
			}
			
		
		array_push($datas,$item);
		for($k=0;$k<count($column_name);$k++){
			
		 $query = 'select '.$db->quotename($column_name[$k]).' from '.$db->quotename($tablename->existing_database_table);
		
		if(!empty($tablename->extra_condition))
		$query .= ' where '.$tablename->extra_condition;
		if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				$query .= $limit_option;
				
		$db->setQuery($query);
		if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		$data[$k] = $db->loadObjectList();
		
		}
		
					
					
					for($i=0;$i<count($data[0]);$i++)	{
					$item = array();
					
					for($j=0;$j<count($column_name);$j++)	{
						$col_name = $column_name[$j];
						$col = $data[$j]; 
						array_push($item, $col[$i]->$col_name);
						
						}
					
					array_push($datas,$item);
					}
			      }
				}
			elseif($chart_type=='Stepped AreaChart'){
			        $column_name = explode(',',$tablename->chart_data->series_column_name);
					$item = '["ID","'.implode('","', explode(',',$tablename->chart_data->series)).'"]';
					array_push($datas,$item);
					if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' )
					{       
					
					$query = $tablename->chart_extra_parms; 
							if(strpos(strtolower($query), 'limit')!== false){
							$query = substr($query, 0, strpos(strtolower($query), 'limit'));
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';
							}
							else
							{
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';	
							}
					$db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$data = $db->loadObjectList();
					for($i=0;$i<count($data);$i++)	
					{
					$arr = $data[$i];
					$item = array();
					$total = 0;
					foreach ($arr as $key => $value) {
					if($total==0){$total=1;
					if($value=='' || $value==0)
					break;
					array_push($item,'"'.trim($value).'"');
					
					}else{
						array_push($item, (float)$value);
					
					
					}
					
					}
				
					array_push($datas,$item);
				}
			}else{
		$limit_option = '';
		if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
		$limit_option = ' LIMIT 1';
		}
		else{
		$current_limit= JRequest::getString('current_limit', '');
		$limit_option = ' LIMIT '.($current_limit).' , 1';	
		}
		$chart_setting_options = json_decode($tablename->chart_option); 
		 $query = 'select '.$db->quotename($tablename->x_axis_columns).' from '.$db->quotename($tablename->existing_database_table);
		if(!empty($tablename->extra_condition))
		$query .= ' where '.$tablename->extra_condition; 
		if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
		if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
		
		$query .= $limit_option;
		$db->setQuery($query);
		if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		$data_vertical = $db->loadObjectList();
		
	
		for($k=0;$k<count($column_name);$k++){
			
		 $query = 'select '.$db->quotename($column_name[$k]).' from '.$db->quotename($tablename->existing_database_table);
		
		if(!empty($tablename->extra_condition))
		$query .= ' where '.$tablename->extra_condition;
	    if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
		if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
		
		$query .= $limit_option;
	
		$db->setQuery($query);
		if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		$data[$k] = $db->loadObjectList();
		
		}
					$vertical_column = $tablename->x_axis_columns;
					$item = array();
					for($i=0;$i<count($data[0]);$i++)	{
						$item = array();
						if(isset($data_vertical[$i]->$vertical_column)){
							
							$vert = $data_vertical[$i];
					    array_push($item, '"'.$vert->$vertical_column.'"');}
								  else continue;
					
					for($j=0;$j<count($column_name);$j++)	{
						$col_name = $column_name[$j];
						$col = $data[$j]; 
						if($j==count($column_name)-1)
						array_push($item, $col[$i]->$col_name);
						else
						array_push($item, $col[$i]->$col_name);
						
						
						}
					
					
					array_push($datas,$item);
					}
					
			     }
				
				}
			elseif($chart_type=='Annotation chart'){
				$column_name = explode(',',$tablename->chart_data->series_column_name);
			    $annotation_title = explode(',',$tablename->chart_data->annotation_title);
			    $annotation_text = explode(',',$tablename->chart_data->annotation_text);
		         if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
					    $query = $tablename->chart_extra_parms; 
							if(strpos(strtolower($query), 'limit')!== false){
							$query = substr($query, 0, strpos(strtolower($query), 'limit'));
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';
							}
							else
							{
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';	
							}
						$db->setQuery($query);
						if($db->getErrorNum())	{
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
						$data = $db->loadObjectList();
						$total_header = (count(get_object_vars($data[0]))-1)/3;
						$item = array();
						$y = new stdClass;
						$y->type = 'date';
						$y->label = 'Date';
						array_push($item, $y);
	             
					for($s=0;$s<$total_header;$s++){
					if(isset($tablename->chart_data->s_header[$s]->header)){
					array_push($item, '"'.$tablename->chart_data->s_header[$s]->header.'"');	
					}else{
						array_push($item, '""');
					}
				    if(isset($tablename->chart_data->s_header[$s]->title)){
					array_push($item, '"'.$tablename->chart_data->s_header[$s]->title.'"');	
					}else{
						array_push($item, '""');
					}
					if(isset($tablename->chart_data->s_header[$s]->text)){
					array_push($item, '"'.$tablename->chart_data->s_header[$s]->text.'"');	
					}else{
						array_push($item, '""');
					}
					
					}
				
			 
			   array_push($datas,$item);
					 
						for($i=0;$i<count($data);$i++) 
						{
						$data_new = $data[$i];
						
						$item = array();
						$g = 0;$s = 0;$t = 0;$text = 0;
							foreach ($data_new as $key => $value)
							{
						
						  if($g==0){
									if(strpos(substr($value,0,10), ':')!== false){
									$value = substr_replace($value,str_replace(':', '-', substr($value,0,10)),0,10);
									//$value = date('Y-m-d', strtotime($date)); 
									}
									if(strpos(substr($value,0,10), '/')!== false){
									$value =  substr_replace($value,str_replace('/', '-', substr($value,0,10)),0,10);
									//$value = date('Y-m-d', strtotime($date)); 	
									}

									$date_value = date_format(new DateTime($value), $date_type);
									$update_date = explode(',', $date_value);
									$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
								array_push($item ,' new Date('. $data_value.')'); 
								}
							
							elseif($t==0){
							array_push($item ,(float)$value); 
							$t++;
							}
							elseif($t==1){
								array_push($item ,'"'.$value.'"'); 
							
							$t++;}
							elseif($t==2){
							array_push($item ,'"'.$value.'"'); 
							$t=0;}
							$g++;
							}
						
						array_push($datas, $item);
					}
			    
			 }
			else {
					$limit_option = '';
					if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
					$limit_option = ' LIMIT 1';
					}
					else{
					$current_limit= JRequest::getString('current_limit', '');
					$limit_option = ' LIMIT '.($current_limit).' , 1';	
					}   

					   $item = array();
						$y = new stdClass;
						$y->type = 'date';
						$y->label = 'Date';
						array_push($item, $y);
				
				$chart_setting_options = json_decode($tablename->chart_option); 
			  for($s=0;$s<count($tablename->chart_data->s_header);$s++){
				    if(isset($tablename->chart_data->s_header[$s]->header)){
					array_push($item, '"'.$tablename->chart_data->s_header[$s]->header.'"');	
					}else{
					array_push($item, '""');	
					}
					
					if(isset($tablename->chart_data->s_header[$s]->title)){
					array_push($item, '"'.$tablename->chart_data->s_header[$s]->title.'"');}
					else{
					array_push($item, '""');	
					}
					if(isset($tablename->chart_data->s_header[$s]->text)){
					array_push($item, '"'.$tablename->chart_data->s_header[$s]->text.'"');}
					else{
					array_push($item, '""');	
					}
					
				  }
			  
			   array_push($datas,$item);

			      $data_value = $data_title = $data_text = array();
                    $query = 'select '.$db->quotename($tablename->x_axis_columns).' from '.$db->quotename($tablename->existing_database_table);
                    
                    if(!empty($tablename->extra_condition))
                    $query .= ' where '.$tablename->extra_condition;
                    if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
                   if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
                   $query .= $limit_option;
                       
                    $db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
                    $date_value = $db->loadObjectList();
		      
		   for($k=0;$k<count($column_name);$k++)
		   {
                                      if(isset($column_name[$k]))
                                        {
                                                $query = 'select '.$db->quotename($column_name[$k]).' from '.$db->quotename($tablename->existing_database_table);
                                                
                                                if(!empty($tablename->extra_condition))
                                                $query .= ' where '.$tablename->extra_condition;
                                                if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
                                                if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
                                                
                                                $query .= $limit_option;
                                                $db->setQuery($query);
												if($db->getErrorNum())	{
												$obj->result = 'error';
												$obj->error = $db->getErrorMsg();
												return $obj;
												}
                                                $data_value[$k] = $db->loadObjectList();
                                        }
						
                                      if(isset($annotation_title[$k]))
                                        {
                                                $query1 = 'select '.$db->quotename($annotation_title[$k]).' from '.$db->quotename($tablename->existing_database_table);
                                                if(!empty($tablename->extra_condition))
                                                $query .= ' where '.$tablename->extra_condition;
                                                if(!empty($tablename->groupby)){$query1 .= ' GROUP BY '.$tablename->groupby; }
                                               if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query1 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
                                                
                                               
                                                $query1 .= $limit_option;
                                                $db->setQuery($query1);
												if($db->getErrorNum())	{
												$obj->result = 'error';
												$obj->error = $db->getErrorMsg();
												return $obj;
												}
                                                $data_title[$k] = $db->loadObjectList();
												
                                              
                                        }
                                        if(isset($annotation_text[$k]))
                                        {
                                              $query = 'select '.$db->quotename($annotation_text[$k]).' from '.$db->quotename($tablename->existing_database_table);
                                                if(!empty($tablename->extra_condition))
                                                $query .= ' where '.$tablename->extra_condition;
                                                if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
                                               if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
                                               
                                                $query .=  $limit_option;
                                                $db->setQuery($query);
												if($db->getErrorNum())	{
												$obj->result = 'error';
												$obj->error = $db->getErrorMsg();
												return $obj;
												}
                                                $data_text[$k] = $db->loadObjectList();
                                             
                                        }
					}
	       $date_column_name = $tablename->x_axis_columns;
		   
          for($i=0;$i<count($date_value);$i++)
								{
								$item = array();
										
										if(strpos(substr($date_value[$i]->$date_column_name,0,10), ':')!== false){
										$value = substr_replace($date_value[$i]->$date_column_name,str_replace(':', '-', substr($date_value[$i]->$date_column_name,0,10)),0,10);
										//$value = date('Y-m-d', strtotime($date)); 
										}
										if(strpos(substr($date_value[$i]->$date_column_name,0,10), '/')!== false){
										$value =  substr_replace($date_value[$i]->$date_column_name,str_replace('/', '-', substr($date_value[$i]->$date_column_name,0,10)),0,10);
										//$value = date('Y-m-d', strtotime($date)); 	
										}

										$date_value = date_format(new DateTime($date_value[$i]->$date_column_name), $date_type);
										$update_date = explode(',', $date_value);
										$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
										array_push($item , 'new Date('.$data_value.')');
										
								
										for($j=0;$j<count($column_name);$j++)
										{
											$annotation_title_n = $annotation_title[$j];
											$annotation_text_n = $annotation_text[$j];
											$column_name_n = $column_name[$j];
											$col_value = $data_value[$j];
											$col_value = $col_value[$i]->$column_name_n; 
											
													if(count($data_title)>0){
													$col_title = $data_title[$j];
													$col_title = $col_title[$i]->$annotation_title_n;
													
													}
													else
													$col_title='undefined';
											
													if(count($data_text)>0)
													{
													$col_text = $data_text[$j];
													$col_text = $col_text[$i]->$annotation_text_n;
													}
													else
													$col_text='undefined';  
													array_push($item, $col_value);
													array_push($item, $col_title);
													array_push($item, $col_text);
													
											
											
											}
								
							
								array_push($datas,$item);
								}
		            	}
			}
			elseif($chart_type=='Bar Chart' || $chart_type=='Column Charts'){
				$items = array();
			
				$animation=0;
			    $x_axis_label = isset($x->x_axis)&&$x->x_axis!=''? $x->x_axis:'';
					if(isset($x->x_axis_header_type)&& $x->x_axis_header_type!=''){
						$y = new stdClass;
						$y->type = $x->x_axis_header_type;
						$y->label = $x_axis_label;
						array_push($item , $y);
					}
					else
					{
					array_push($item , '"label"');	
					}
				if(isset($tablename->chart_data->row_styles) || isset($tablename->chart_data->range))
				{
                    $option_series = array();
                    $data_series = explode(',', $tablename->chart_data->series);
                    $k = count($data_series);
                    for($i=0;$i<$k;$i++){ 
					   $b_data = array();	
                       array($b_data, $data_series[$i]); 
                    if((isset($tablename->chart_data->rolestyle[$i])||(isset($tablename->chart_data->range)&& count($tablename->chart_data->range->value)>0 && count($data_series)<2)))
					{
					if(isset($tablename->chart_data->rolestyle[$i])&& $tablename->chart_data->rolestyle[$i]!='')	
				     $rols_style_data = $tablename->chart_data->rolestyle[$i];
					 
				    if(isset($tablename->chart_data->rolestyle[$i])&& $tablename->chart_data->rolestyle[$i]!='' && isset($rols_style_data->animation) && $rols_style_data->animation!='' ){
					    $y = new stdClass;
						$y->role = "style";
						array($b_data, $y);
						$y = new stdClass;
						$y->role = "annotation";
						array($b_data, $y);
                         $animation=1;
					}
					elseif(isset($tablename->chart_data->rolestyle[$i])&& $tablename->chart_data->rolestyle[$i]!=''){
						$y = new stdClass;
						$y->role = "style";
						array($b_data, $y);
						
					}
					
					elseif(isset($tablename->chart_data->range)&& count($tablename->chart_data->range->value)>0 && count($data_series)<2){
						$y = new stdClass;
						$y->role = "style";
						array($b_data, $y);
						
					}
					
					
					}
                    
                    array_push($item,$b_data);
                    
                      }
					
                   
				}
				
				
				else
				
				{
				
				$total_column_series =	explode(',', $tablename->chart_data->series);
				for($column=0;$column<count($total_column_series);$column++){
				array_push($item, '"'.$tablename->chart_data->series.'"' );	
				}
				
				}
				
				
				if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
		                    $query = $tablename->chart_extra_parms; 
							if(strpos(strtolower($query), 'limit')!== false){
							$query = substr($query, 0, strpos(strtolower($query), 'limit'));
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';
							}
							else
							{
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';	
							}
		     $db->setQuery($query);
			 if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		     $data = $db->loadObjectList();
		    $chart_series = count(explode(',', $tablename->chart_data->series));
		    array_push($datas,$item);
			$item = array();
				for($i=0;$i<count($data);$i++)	{
				$arr = $data[$i];
					$item = array();
					$t =0;$j=0;
					$using_series = count(get_object_vars($arr))-1;
					if( $using_series != $chart_series){
					$obj->result = 'error';
					$obj->error = "Number of Columns for series and Number of series should be equal";
					return $obj;}
						foreach ($arr as $key => $value)
						{
							
							 if($t==0)
							 {
								
							  array_push($item , '"'.trim($value).'"');
							 }
							else
							{
								if(isset($tablename->chart_data->rolestyle[$j]))
								$r = $tablename->chart_data->rolestyle[$j];
								
								
								
								$item_extra = (int)$value;
								
								$option = array();
								
								//if(isset($tablename->chart_data->rolestyle[$j]))
								if((isset($tablename->chart_data->rolestyle[$j])|| (isset($tablename->chart_data->range) && $using_series==1))){
								if(isset($tablename->chart_data->rolestyle[$j])&& $tablename->chart_data->rolestyle[$j])
								$rols_style_data = $tablename->chart_data->rolestyle[$j];
								
								if(isset($rols_style_data->stroke_color) && $rols_style_data->stroke_color!=0)
								array_push($option,'stroke-color:'.$rols_style_data->stroke_color);
								if(isset($rols_style_data->stroke_opacity) &&$rols_style_data->stroke_opacity!='')
								array_push($option,'stroke-opacity:'.$rols_style_data->stroke_opacity);
								if(isset($rols_style_data->stroke_width) && $rols_style_data->stroke_width!='')
								array_push($option,'stroke-width:'.$rols_style_data->stroke_width);
								
								for($k=0;$k<count($tablename->chart_data->range->value);$k++){
								$fill_color='';
								//$values = $tablename->chart_data->range->value[$k];
								if($value<=$tablename->chart_data->range->value[$k]){
								$fill_color = $tablename->chart_data->range->color[$k]; 
								break;
								}
								}
								
								if($fill_color!='')
								array_push($option,'fill-color:'.$fill_color);
								elseif(isset($rols_style_data->fill_color) && $rols_style_data->fill_color!=''){
								array_push($option,'fill-color:'.$rols_style_data->fill_color);
								
								}
								
								if(isset($rols_style_data->fill_opacity)&& $rols_style_data->fill_opacity!='')
								array_push($option,'fill-opacity:'.$rols_style_data->fill_opacity);
								if(count($option)>0)
								$item_extra .= ", '".implode("; " ,  $option)."'";
								$option_an = array();
								$blank = '';
								if(isset($rols_style_data->animation) && $animation==1 ){
								array_push($option_an, $rols_style_data->animation);}
								
								if(count($option_an)>0)
								$item_extra .= ", '".implode(", " ,  $option_an)."'";
							}
							}
							$t++;$j++;
				     }
				   array_push($item, $item_extra);
				
				
				  array_push($datas, $item);
				}
				
		 } else{
				if(isset($tablename->chart_data->row_styles) || isset($tablename->chart_data->range))
				{
                    $items = array();
			
				$animation=0;
			    $x_axis_label = isset($x->x_axis)&&$x->x_axis!=''? $x->x_axis:'';
					if(isset($x->x_axis_header_type)&& $x->x_axis_header_type!=''){
						$y = new stdClass;
						$y->type = $x->x_axis_header_type;
						$y->label = $x_axis_label;
						array_push($item , $y);
					}
					else
					{
					array_push($item , '"label"');	
					}
				if(isset($tablename->chart_data->row_styles) || isset($tablename->chart_data->range))
				{
                    $option_series = array();
                    $data_series = explode(',', $tablename->chart_data->series);
                    $k = count($data_series);
                    for($i=0;$i<$k;$i++){
					   $b_data = array();	
                       array($b_data, $data_series[$i]);
                    if((isset($tablename->chart_data->rolestyle[$i])||(isset($tablename->chart_data->range)&& count($tablename->chart_data->range->value)>0 && count($data_series)<2)))
					{
					if(isset($tablename->chart_data->rolestyle[$i])&& $tablename->chart_data->rolestyle[$i]!='')	
				     $rols_style_data = $tablename->chart_data->rolestyle[$i];
					 
				    if(isset($tablename->chart_data->rolestyle[$i])&& $tablename->chart_data->rolestyle[$i]!='' && isset($rols_style_data->animation) && $rols_style_data->animation!='' ){
					    $y = new stdClass;
						$y->role = "style";
						array($b_data, $y);
						$y = new stdClass;
						$y->role = "annotation";
						array($b_data, $y);
                         $animation=1;
					}
					elseif(isset($tablename->chart_data->rolestyle[$i])&& $tablename->chart_data->rolestyle[$i]!=''){
						$y = new stdClass;
						$y->role = "style";
						array($b_data, $y);
						
					}
					
					elseif(isset($tablename->chart_data->range)&& count($tablename->chart_data->range->value)>0 && count($data_series)<2){
						$y = new stdClass;
						$y->role = "style";
						array($b_data, $y);
						
					}
					
					
					}
                    
                    array_push($item,$b_data);
                    
                      }
					
                   
				}
				
				
				else
				
				{
				
				$total_column_series =	explode(',', $tablename->chart_data->series);
				for($column=0;$column<count($total_column_series);$column++){
				array_push($item, '"'.$tablename->chart_data->series.'"' );	
				}
				
				}
				
				
				array_push($datas, $item);
				$chart_setting_options = json_decode($tablename->chart_option); 
				$column_name = explode(',',$tablename->chart_data->series_column_name);
				for($k=0;$k<count($column_name);$k++){
			$limit_option = '';
			if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
			$limit_option = ' LIMIT 1';
			}
			else{
			$current_limit= JRequest::getString('current_limit', '');
			$limit_option = ' LIMIT '.($current_limit).' , 1';	
			}	
		 $query = 'select '.$db->quotename(trim($column_name[$k])).' from '.$db->quotename($tablename->existing_database_table);
		
		if(!empty($tablename->extra_condition))
		$query .= ' where '.$tablename->extra_condition;
		if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				
				$query .= $limit_option;
				
		$db->setQuery($query);
		if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		$data[$k] = $db->loadObjectList();
		
		}
		
		 $query = 'select '.$db->quotename($tablename->chart_data->x_axis_columns).' from '.$db->quotename($tablename->existing_database_table);
		
		if(!empty($tablename->extra_condition))
		$query .= ' where '.$tablename->extra_condition;
		if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				
				$query .= $limit_option;
				
		$db->setQuery($query);
		if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		$data_axis_value = $db->loadObjectList();	
				
				
				
				$x_column = $tablename->chart_data->x_axis_columns;
				for($i=0;$i<count($data_axis_value);$i++)	{
				if($data_axis_value[$i]->$x_column=='')
				continue;
				//$item = '["'.$data_axis_value[$i]->$x_column.'"';
											  $item = array();
			if(isset($chart_option->x_axis_header_type)){
			     
				 if($x->x_axis_header_type=='date'||$x->x_axis_header_type=='datetime'){
					  $date_type = strlen($data_axis_value[$i]->$x_column)>4?'Y,m,d,H,i,s':'Y';
				if($date_type=='Y'){ $date_value = '"'.date_format(new DateTime(date("Y-m-d", mktime(0, 0, 0, 1, 1,$data_axis_value[$i]->$x_column))),'Y').'"';}else{
					if(strpos(substr($data_axis_value[$i]->$x_column,0,10), ':')!== false){
					$data_axis_value[$i]->$x_column = substr_replace($data_axis_value[$i]->$x_column,str_replace(':', '-', substr($data_axis_value[$i]->$x_column,0,10)),0,10);
					//$value = date('Y-m-d', strtotime($date)); 
					}
					if(strpos(substr($data_axis_value[$i]->$x_column,0,10), '/')!== false){
					$data_axis_value[$i]->$x_column =  substr_replace($data_axis_value[$i]->$x_column,str_replace('/', '-', substr($data_axis_value[$i]->$x_column,0,10)),0,10);
					//$value = date('Y-m-d', strtotime($date)); 	
					}

					$date_value = date_format(new DateTime($data_axis_value[$i]->$x_column), $date_type);
					$update_date = explode(',', $date_value);
					$date_value = $update_date[0].','.((int)$update_date[1]<=10?'0'.($update_date[1]-1):($update_date[1]-1)).','.$update_date[2].','.$update_date[3].','.$update_date[4].','.$update_date[5];
					
					
					
					//$date_value = date_format(new DateTime($data_axis_value[$i]->$x_column), $date_type);
					
					}
				  array_push($item , 'new Date('.$date_value.')');
				  }
			       elseif($chart_option->x_axis_header_type=='number')
				   array_push($item ,(float)$data_axis_value[$i]->$x_column);
				     else
			           array_push($item , '"'.trim($data_axis_value[$i]->$x_column).'"');}
					  else
					   array_push($item , '"'.trim($data_axis_value[$i]->$x_column).'"');
				for($j=0;$j<count($data);$j++)	{
				$c_value = $data[$j];
				$c_value = $c_value[$i];
				$c_name = $column_name[$j];
				if(isset($tablename->chart_data->rolestyle[$j]))
				$r = $tablename->chart_data->rolestyle[$j];
				
				
				
				$item_extra = (float)$c_value->$c_name;
				
				
				$option = array();
				if(isset($tablename->chart_data->rolestyle[$j]))
				if((isset($tablename->chart_data->rolestyle[$i])|| (isset($tablename->chart_data->range) && count($column_name)<2))&& $chart_option->show_3d!=1){
				$rols_style_data = $tablename->chart_data->rolestyle[$j];
				
				if(isset($rols_style_data->stroke_color) && $rols_style_data->stroke_color!=0)
				array_push($option,'stroke-color:'.$rols_style_data->stroke_color);
				if(isset($rols_style_data->stroke_opacity) &&$rols_style_data->stroke_opacity!='')
				array_push($option,'stroke-opacity:'.$rols_style_data->stroke_opacity);
				if(isset($rols_style_data->stroke_width) && $rols_style_data->stroke_width!='')
				array_push($option,'stroke-width:'.$rols_style_data->stroke_width);
				
				for($k=0;$k<count($tablename->chart_data->range);$k++){
				$fill_color='';
				$value = $tablename->chart_data->range[$k]->value;
					if($tablename->chart_data->data[$j][$i]<=$value){
					$fill_color = $tablename->chart_data->range[$k]->color; 
					break;
					}
				}
			
		      if($fill_color!='')
				array_push($option,'fill-color:'.$fill_color);
			  elseif(isset($rols_style_data->fill_color) && $rols_style_data->fill_color!=''){
				array_push($option,'fill-color:'.$rols_style_data->fill_color);
				
				}
				
				if(isset($rols_style_data->fill_opacity)&& $rols_style_data->fill_opacity!='')
				array_push($option,'fill-opacity:'.$rols_style_data->fill_opacity);
				if(count($option)>0)
				$item_extra .= ", '".implode("; " ,  $option)."'";
				$option_an = array();
				$blank = '';
				if(isset($rols_style_data->animation) && $animation==1 && $chart_option->show_3d!=1){
				array_push($option_an, $rols_style_data->animation);}
				
				if(count($option_n)>0&& $chart_option->show_3d!=1)
				if(count($option_an)>0)
				$item_extra .= ", '".implode(", " ,  $option_an)."'";}
				
				}
				array_push($item, $item_extra);
				
				array_push($datas, $item);
				}
			  }
			}
			}
			elseif($chart_type=='Pie Chart' || $chart_type=='Slice Pie Chart'){
			$series = array();
			$series = explode(',', $tablename->chart_data->series);
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' )
			{
					$query = $tablename->chart_extra_parms; 
					if(strpos(strtolower($query), 'limit')!== false){
					$query = substr($query, 0, strpos(strtolower($query), 'limit'));
					
					$query .= ' LIMIT '.($current_limit+1).' , 1';
					}
					else
					{
					
					$query .= ' LIMIT '.($current_limit+1).' , 1';	
					}
				$db->setQuery($query);
				if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
				$data = $db->loadObjectList();
				$item = array();
				
				if(isset($tablename->chart_data->label_title) && $tablename->chart_data->label_title!='')
				{
				array_push($item, '"'.$tablename->chart_data->label_title.'"');	
				}
				else
				{
				array_push($item, '"Label"');		
				}
				if(isset($tablename->chart_data->value_title) && $tablename->chart_data->value_title!='')
				{
				array_push($item, '"'.$tablename->chart_data->value_title.'"');	
				}
				else
				{
				array_push($item, '"value"');		
				}
				
				array_push($datas,$item);
				$item = array();
				for($i=0;$i<count($data);$i++)	{
			    $item = array();
				
				$t =0;
				foreach ($data[$i] as $key => $value){
				if($t==0)
				array_push($item, '"'.$value.'"');
				else
			     array_push($item, (float)$value);
				
				$t++;
				
				}
				
				array_push($datas,$item);
				}	
				
				
			}else{
                    $chart_setting_options = json_decode($tablename->chart_option);
						$limit_option = '';
						if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
						$limit_option = ' LIMIT 1';
						}
						else{
						$current_limit= JRequest::getString('current_limit', '');
						$limit_option = ' LIMIT '.($current_limit).' , 1';	
						}
					$query = 'select '.$tablename->chart_data->series_title_value.' from '.$db->quotename($tablename->existing_database_table);
					if(!empty($tablename->extra_condition))
					$query .= ' where '.$tablename->extra_condition;
					if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
					if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
					
					$query .= $limit_option;
					
					$db->setQuery($query);
					if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
					$item_detail = $db->loadObjectList();
				    $item = array();
					array_push($item, "Task");
					array_push($item, "Value");
					$c_name = $tablename->chart_data->series_title_value;
					array_push($datas, $item);
						for($i=0;$i<count($item_detail);$i++){
							 $item = array();
							 array_push($item, '"'.$series[$i].'"');
							 array_push($item, (float)$item_detail[$i]->$c_name);
						
						array_push($datas, $item);
						}
					}
			
			}
			elseif($chart_type=='Candlestick Charts'){
		    //$series = array();
			$series = explode(',', $tablename->chart_data->series);
		
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' )
			{
						$query = $tablename->chart_extra_parms; 
						if(strpos(strtolower($query), 'limit')!== false){
						$query = substr($query, 0, strpos(strtolower($query), 'limit'));
						
						$query .= ' LIMIT '.($current_limit+1).' , 1';
						}
						else
						{
						
						$query .= ' LIMIT '.($current_limit+1).' , 1';	
						}
						$db->setQuery($query);
						if($db->getErrorNum())	{
						$obj->result = 'error';
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
						$data = $db->loadObjectList();
						$item = array();
						if(isset($chart_option->label_title) && $chart_option->label_title!=''){
							array_push($item, '"'.$chart_option->label_title.'"');
						}
						else
						{
							array_push($item, '"Label"');
						}
						if(isset($chart_option->candle_minimum_title) && $chart_option->candle_minimum_title!=''){
							array_push($item, '"'.$chart_option->candle_minimum_title.'"');
						}
						else
						{
							array_push($item, '"minimum"');
						}
						if(isset($chart_option->candle_opening_title) && $chart_option->candle_opening_title!=''){
							array_push($item, '"'.$chart_option->candle_opening_title.'"');
						}
						else
						{
							array_push($item, '"opening"');
						}
						if(isset($chart_option->candle_closing_title) && $chart_option->candle_closing_title!=''){
							array_push($item, '"'.$chart_option->candle_closing_title.'"');
						}
						else
						{
							array_push($item, '"closing"');
						}
						if(isset($chart_option->candle_maximum_title) && $chart_option->candle_maximum_title!=''){
							array_push($item, '"'.$chart_option->label_title.'"');
						}
						else
						{
							array_push($item, '"maximum"');
						}
						
						array_push($datas,$item);
						for($i=0;$i<count($data);$i++)	{
						$arr = $data[$i];
						$item = array();
						$t =0;
						foreach ($arr as $key => $value){
						if($t==0)
							array_push($item, '"'.$value.'"');
					
						else
							array_push($item, (float)$value);
					
						$t++;
						
						}
						
						array_push($datas,$item);
						}	
						
						
		}else{
			$chart_setting_options = json_decode($tablename->chart_option);
			$limit_option = '';
			if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
			$limit_option = ' LIMIT 1';
			}
			else{
			$current_limit= JRequest::getString('current_limit', '');
			$limit_option = ' LIMIT '.($current_limit).' , 1';	
			}			
			$query1 = 'select `'.$db->quotename($tablename->chart_data->labeling_axis_columns_name).'`,`'.$db->quotename($tablename->chart_data->minimum_axis_columns_name).'`, `'.$db->quotename($tablename->chart_data->opening_axis_columns_name).'` , `'.$db->quotename($tablename->chart_data->closing_axis_columns_name).'`, `'.$db->quotename($tablename->chart_data->maximum_axis_columns_name).'` from '.$db->quotename($tablename->existing_database_table);
			if(!empty($tablename->extra_condition))
		    $query1 .= ' where '.$tablename->extra_condition;
			 if(!empty($tablename->groupby)){$query1 .= ' GROUP BY '.$tablename->groupby; }
		     if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query1 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
		     $query1 .= $limit_option;
			
			
			$db->setQuery($query1);
			if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		    $item_detail1 = $db->loadObjectList();
			
			
				
				$lable = $tablename->chart_data->labeling_axis_columns_name;
				$min = $tablename->chart_data->minimum_axis_columns_name;
				$open = $tablename->chart_data->opening_axis_columns_name;
				$close = $tablename->chart_data->closing_axis_columns_name;
				$maxs = $tablename->chart_data->maximum_axis_columns_name;
					$item = array();
					array_push($item, "");
					array_push($item, '"'.$tablename->chart_data->series.'"');
					array_push($item, "");
					array_push($item, "");
					array_push($item, "");
					
						
						array_push($datas, $item);
					for($i=0;$i<count($item_detail1);$i++)
					{
						$c =0;
						$item = array();
					 foreach($item_detail1[$i] as $key=>$value)
					 {
					$c==0?array_push($item, '"'.$value.'"'):array_push($item , (float)$value);
					$c++;	 
					 }	
					
						array_push($datas, $item);
					}
		        }
					
				}
			elseif($chart_type == 'Bubble Chart'){
			$series = explode(',', $tablename->chart_data->series_bubble_label_name);
			if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
					$query = $tablename->chart_extra_parms; 
					if(strpos(strtolower($query), 'limit')!== false){
					$query = substr($query, 0, strpos(strtolower($query), 'limit'));
					
					$query .= ' LIMIT '.($current_limit+1).' , 1';
					}
					else
					{
					
					$query .= ' LIMIT '.($current_limit+1).' , 1';	
					}
						$db->setQuery($query);
						if($db->getErrorNum())	{
						$obj->result = 'error';
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
						$data = $db->loadObjectList();
						$item = array();
						if(isset($chart_option->header_title) && $chart_option->header_title!=''){
							array_push($item , '"'.$chart_option->header_title.'"');
						}
						else{
							array_push($item , "Label");
						}
						if(isset($chart_option->header_x_title) && $chart_option->header_x_title!=''){
							array_push($item , '"'.$chart_option->header_x_title.'"');
						}
						else{
							array_push($item , "X axis");
						}
						if(isset($chart_option->header_y_title) && $chart_option->header_y_title!=''){
							array_push($item , '"'.$chart_option->header_y_title.'"');
						}
						else{
							array_push($item , "Y axis");
						}
						if(isset($tablename->chart_data->series_column_region) && $tablename->chart_data->series_column_region!=''){
							if(isset($tablename->chart_data->header_region)&&!empty($tablename->chart_data->header_region)){
								array_push($item , '"'.$tablename->chart_data->header_region.'"');
							}
							else
							 {
							array_push($item , "Region");
						     }
						}
						if(isset($chart_option->header_title) && $chart_option->header_title!=''){
							array_push($item , '"'.$chart_option->header_title.'"');
						}
						else{
							array_push($item , "Label");
						}
						
						$r_title  = isset($chart_option->header_y_title)?$chart_option->header_y_title:'Y axis';
						$value_title  = isset($chart_option->header_value_title) && $chart_option->header_value_title!=''?$chart_option->header_value_title:'Value';
						
						
						array_push($datas, $item);
						
						for($i=0;$i<count($data);$i++)
						{
						$data_new = $data[$i];
						$item = array();
						
						$g = 0;
							foreach ($data_new as $key => $value)
							{
						
							if($g==0)
							{
							array_push($item , '"'.$value.'"');
							}
							if($g==1)
							{
							array_push($item , (float)$value);	
							
							}
							if($g==2)
							{
							array_push($item , (float)$value);	
							}
							if($g==3){
							array_push($item , '"'.$value.'"');
							}
							$g++;
							}
						
						array_push($datas, $item);
					}
			 
			 }
			 else {
			$chart_setting_options = json_decode($tablename->chart_option);
			$limit_option = '';
			if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
			$limit_option = ' LIMIT 1';
			}
			else{
			$current_limit= JRequest::getString('current_limit', '');
			$limit_option = ' LIMIT '.($current_limit).' , 1';	
			}	
       			
		
			$query1 = 'select `'.$db->quotename($tablename->chart_data->series_bubble_label).'`, `'.$db->quotename($tablename->chart_data->series_x_axis).'`, `'.$db->quotename($tablename->chart_data->series_y_axis).'`'.(isset($tablename->chart_data->series_column_region) && $tablename->chart_data->series_column_region!=''?', `'.$tablename->chart_data->series_column_region.'`':'').', `'.$db->quotename($tablename->chart_data->series_x_axis_column_value).'`'.' from '.$db->quotename($tablename->existing_database_table);
			if(!empty($tablename->extra_condition))
		    $query1 .= ' where '.$tablename->extra_condition;
			 if(!empty($tablename->groupby)){$query1 .= ' GROUP BY '.$tablename->groupby; }
		     if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query1 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
		 
			 $query1 .= $limit_option;
			
			
			$db->setQuery($query1);
			if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
		    $item_detail1 = $db->loadObjectList();
			
			
			$lable='';$region='';
			$item = array();
			    if(isset($tablename->chart_data->series_bubble_label)){
		    	array_push($item, '"'.$tablename->chart_data->series_bubble_label.'"');
				}
				else{
					array_push($item, '""');
				}
				if(isset($option_details->x_axis) && $option_details->x_axis!=''){
		    	array_push($item, '"'.$option_details->x_axis.'"');
				}
				else{
					array_push($item, '"x"');
				}
				if(isset($option_details->y_axis) && $option_details->y_axis!=''){
		    	array_push($item, '"'.$option_details->y_axis.'"');
				}
				else{
					array_push($item, '"y"');
				}
				if(isset($tablename->chart_data->series_column_region) && $tablename->chart_data->series_column_region!=''){
				if(isset($tablename->chart_data->header_region)){	
		    	array_push($item, '"'.$tablename->chart_data->header_region.'"');
				}
				else{
					array_push($item, '"Region"');
				}
			 }
			 if(isset($chart_option->header_title) && $chart_option->header_title!=''){
		    	array_push($item, '"'.$chart_option->header_title.'"');
				}
				else{
					array_push($item, '"Label"');
				}
				
				$x = $tablename->chart_data->series_x_axis;
				$y = $tablename->chart_data->series_y_axis;
				$value = $tablename->chart_data->series_x_axis_column_value;
				if(isset($tablename->chart_data->series_column_region))
				$region = $tablename->chart_data->series_column_region;
				
				$option_details= json_decode($tablename->chart_option);
				$x_axis = isset($option_details->x_axis) && $option_details->x_axis!=''?$option_details->x_axis:'x';
				$y_axis = isset($option_details->y_axis) && $option_details->y_axis!=''?$option_details->y_axis:'y';
				$legend = isset($tablename->chart_data->series_column_region)?$tablename->chart_data->series_column_region:'Legend';
				$label_title = isset($chart_option->header_title) && $chart_option->header_title!=''?$chart_option->header_title:'Label';	
				
						
				array_push($datas, $item);
					for($i=0;$i<count($item_detail1);$i++)
					{
						$item = array();
						if(isset($tablename->chart_data->series_bubble_label))
						array_push($item , '"'.$item_detail1[$i]->$lable.'"');
						else
							array_push($item , '""');
						//$item .= '"",';
						array_push($item , (float)$item_detail1[$i]->$x);
						array_push($item , (float)$item_detail1[$i]->$y);
						
						
						if(isset($tablename->chart_data->series_column_region) && $tablename->chart_data->series_column_region!='')
							array_push($item , '"'.$item_detail1[$i]->$region.'"');
						
						array_push($item , (float)$item_detail1[$i]->$value);
						
						array_push($datas, $item);
					}
			
				}
			}
			elseif($chart_type=='Maps'){
			   if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
							$query = $tablename->chart_extra_parms; 
							if(strpos(strtolower($query), 'limit')!== false){
							$query = substr($query, 0, strpos(strtolower($query), 'limit'));
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';
							}
							else
							{
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';	
							}
						$db->setQuery($query);
						if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
						$data = $db->loadObjectList();
						
						for($i=0;$i<count($data);$i++)
						{
						$data_new = $data[$i];
						if($i==0 && count(get_object_vars($data_new))==3){
							$item = array();
							array_push($item, "latitude");
							array_push($item, "longitude");
							array_push($item, "info");
							$info_mod = count(get_object_vars($data_new));
						array_push($datas, $item);
						}
						
						if($i==0 && count(get_object_vars($data_new))==2)
						{
							$item = array();
							array_push($item, "Region");
							array_push($item, "info");

							$info_mod = count(get_object_vars($data_new));
							array_push($datas, $item);
						}
						$item = array();
						$g = 0;
							foreach ($data_new as $key => $value)
							{
						    if($info_mod==3)
							{
								if($g==0)
								{
								array_push($item, (float)$value);
								
								}
								if($g==1)
								{
								array_push($item, (float)$value);
								}
								if($g==2)
								 {
								  array_push($item, '"'.$value.'"');
								
								 }
							}
							if($info_mod==2)
							{
								if($g==0){
								array_push($item, '"'.$value.'"');}
								if($g==1){
								array_push($item, '"'.$value.'"');}	
							}
							$g++;
							}
						
						array_push($datas, $item);
					}
			 
			 }
			 else {
		   	     $chart_setting_options = json_decode($tablename->chart_option);
				$limit_option = '';
				if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
				$limit_option = ' LIMIT 1';
				}
				else{
				$current_limit= JRequest::getString('current_limit', '');
				$limit_option = ' LIMIT '.($current_limit).' , 1';	
				}				 
				if($tablename->chart_data->series_mod_name =='latlng')
				{      
			            $item = array();
						array_push($item , "latitude");
						array_push($item , "longitude");
						array_push($item , "info");
						
						$latitude_info = $tablename->chart_data->series_latitude;
						
						
										if(isset($tablename->chart_data->series_latitude))
										{
										$query1 = 'select '.$db->quotename($tablename->chart_data->series_latitude).' from '.$db->quotename($tablename->existing_database_table);
										if(!empty($tablename->extra_condition))
										$query1 .= ' where '.$tablename->extra_condition;
										
											if(!empty($tablename->groupby)){$query1 .= ' GROUP BY '.$tablename->groupby; }
											
											if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query1 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
										
															
															$query1 .= $limit_option;
															
															$db->setQuery($query1);
															if($db->getErrorNum())	{
															$obj->result = 'error';
															$obj->error = $db->getErrorMsg();
															return $obj;
															}
															$item_detail1 = $db->loadObjectList();
															
										}
																	if(isset($tablename->chart_data->series_longitude))
																	{
																	$longitude_info = $tablename->chart_data->series_longitude;
																	$query2 = 'select '.$db->quotename($tablename->chart_data->series_longitude).' from '.$db->quotename($tablename->existing_database_table);
																		if(!empty($tablename->extra_condition))
																		$query2 .= ' where '.$tablename->extra_condition;
																		
																		if(!empty($tablename->groupby)){$query2 .= ' GROUP BY '.$tablename->groupby; }
																		
																		if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query2 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
																		
																		$query1 .= $limit_option;
																		
																		$db->setQuery($query2);
																		if($db->getErrorNum())	{
																		$obj->result = 'error';
																		$obj->error = $db->getErrorMsg();
																		return $obj;
																		}
																		$item_detail2 = $db->loadObjectList();
																		
															}
			}
										if($tablename->chart_data->series_mod_name =='region'){
												$item = array();
												array_push($item , "region");
												array_push($item , "info");
						
												$region_info = $tablename->chart_data->series_region;
												if(isset($tablename->chart_data->series_region))
												{
												$query4 = 'select '.$db->quotename($tablename->chart_data->series_region).' from '.$db->quotename($tablename->existing_database_table);
												if(!empty($tablename->extra_condition))
												$query4 .= ' where '.$tablename->extra_condition;
												   if(!empty($tablename->groupby)){$query4 .= ' GROUP BY '.$tablename->groupby; }
													if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query4 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
												
															
															$query4 .= $limit_option;
															$db->setQuery($query2);
															if($db->getErrorNum())	{
															$obj->result = 'error';
															$obj->error = $db->getErrorMsg();
															return $obj;
															}
															$item_detail4 = $db->loadObjectList();
															
												}
										}
				

				
				if(isset($tablename->chart_data->series_markerinfo))
				{
			    $marker_info = $tablename->chart_data->series_markerinfo;
				$query3 = 'select '.$db->quotename($tablename->chart_data->series_markerinfo).' from '.$db->quotename($tablename->existing_database_table);
				if(!empty($tablename->extra_condition))
				$query3 .= ' where '.$tablename->extra_condition;
				if(!empty($tablename->groupby)){$query3 .= ' GROUP BY '.$tablename->groupby; }
				if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query3 .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				
			
			
				$query3 .= $limit_option;;
				$db->setQuery($query3);
				if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
				$item_detail3 = $db->loadObjectList();
				
				
				
				}
				
				array_push($datas, $item);
				
				for($i=0;$i<count($item_detail3);$i++){
					$item = array();
				if($tablename->chart_data->series_mod_name =='region' && !empty($item_detail4[$i]->region_info)){
				     array_push($item, '"'.$item_detail4[$i]->region_info.'"');
					 array_push($item, '"'.$item_detail3[$i]->$marker_info.'"');
					
					array_push($datas, $item);
					}
				if($tablename->chart_data->series_mod_name =='latlng' && !empty($item_detail1[$i]->$latitude_info) && !empty($item_detail2[$i]->$longitude_info)){
					   array_push($item, (float)$item_detail1[$i]->$latitude_info);
					   array_push($item, (float)$item_detail2[$i]->$longitude_info);
					   array_push($item, (float)$item_detail3[$i]->$marker_info);
				
					array_push($datas, $item);
					}
				
				
				}
			
			 }
			
			}
			elseif($chart_type=='Geo Charts'){
				if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
						$query = $tablename->chart_extra_parms; 
							if(strpos(strtolower($query), 'limit')!== false){
							$query = substr($query, 0, strpos(strtolower($query), 'limit'));
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';
							}
							else
							{
							
							$query .= ' LIMIT '.($current_limit+1).' , 1';	
							}
						$db->setQuery($query);
						if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
						$data = $db->loadObjectList();
						$item = array();
						array_push($item, "Country");
						if(isset($tablename->chart_data->datalegend) && $tablename->chart_data->datalegend!=''){
						array_push($item, '"'.$tablename->chart_data->datalegend.'"');	
						}
						else{
							array_push($item, '"Value"');	
						}
						
						
						array_push($datas, $item);
						
						for($i=0;$i<count($data);$i++)
						{
						$data_new = $data[$i];
						
						$item = array();
						$g = 0;
							foreach ($data_new as $key => $value)
							{
						
							if($g==0){
								array_push($item, '"'.$value.'"');	
							}
							if($g==1){
								array_push($item, (float)$value);	
							}
							
							$g++;
							}
						
						array_push($datas, $item);
					}
			 
			 }
			 else {
				 $chart_setting_options = json_decode($tablename->chart_option); 
				$limit_option = '';
				if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
				$limit_option = ' LIMIT 1';
				}
				else{
				$current_limit= JRequest::getString('current_limit', '');
				$limit_option = ' LIMIT '.($current_limit).' , 1';	
				}
			    $query = 'select '.$tablename->chart_data->series_title_name.' from '.$db->quotename($tablename->existing_database_table);
				if(!empty($tablename->extra_condition))
				$query .= ' where '.$tablename->extra_condition;
				if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				
				$query .= $limit_option;
				
				$db->setQuery($query);
				if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
				$title_name = $db->loadObjectList();
				$query = 'select '.$tablename->chart_data->series_title_value.' from '.$db->quotename($tablename->existing_database_table);
				if(!empty($tablename->extra_condition))
				$query .= ' where '.$tablename->extra_condition;
				if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
				if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				
				$query .= $limit_option;
				
				$db->setQuery($query);
				if($db->getErrorNum())	{
					$obj->result = 'error';
					$obj->error = $db->getErrorMsg();
					return $obj;
					}
				$title_value = $db->loadObjectList();
				$item  =  array();
				array_push($item, "Country");
			    if(isset($tablename->chart_data->datalegend) && $tablename->chart_data->datalegend!=''){
				array_push($item, '"'.$tablename->chart_data->datalegend.'"');	
				}
				else{
				array_push($item, '"value"');		
				}
				
				  array_push($datas, $item);
					for($i=0;$i<count($title_value);$i++){
					$t_name = $tablename->chart_data->series_title_value;
					$t_value = $tablename->chart_data->series_title_value;
                     $item = array();
					 array_push($item, '"'.$item_detail[$i]->$t_name.'"');
					 array_push($item, (float)$item_detail[$i]->$t_value);
					
					array_push($datas, $item);
					}
				  }
				}
			
			
			elseif($chart_type=='Gauge')
			{
						if(isset($tablename->chart_extra_parms) && $tablename->chart_extra_parms!='' ){
						$query = $tablename->chart_extra_parms;
						if(strpos(strtolower($query), 'limit')!== false){
						$query = substr($query, 0, strpos(strtolower($query), 'limit'));
						
						$query .= ' LIMIT '.($current_limit+1).' , 1';
						}
						else
						{
						
						$query .= ' LIMIT '.($current_limit+1).' , 1';	
						}
						$db->setQuery($query);
						if($db->getErrorNum())	{
						$obj->result = 'error';
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
						$data = $db->loadObjectList();
						$item = array();
						
						if($tablename->chart_data->label_title && $tablename->chart_data->label_title!=''){
							array_push($item,$tablename->chart_data->label_title);
						}
						else
							array_push($item,'Label');
						if($tablename->chart_data->value_title && $tablename->chart_data->value_title!='')
						{
						array_push($item,$tablename->chart_data->value_title);	
						}
						else
							array_push($item,'value');
					
						
						array_push($datas, $item);
						$item = array();
						$series = explode(',',$s);
						for($i=0;$i<count($data);$i++)
						{
						$data_new = $data[$i];
						
						$item = array();
						$g = 0;
						foreach ($data_new as $key => $value)
						{
						if($g==0){
						$gauge_label = isset($series[$i])?$series[$i]:$series[0];	
						array_push($item,$gauge_label); 
						array_push($item,$value); 
                        	$g++;					
						}
						
						
						}
						
						array_push($datas, $item);
						}
						
						}
						else
							{
						$chart_setting_options = json_decode($tablename->chart_option); 
						if(isset($tablename->ordering) && strtolower($tablename->ordering)=='desc'){ 
						$query = 'select '.$db->quotename($tablename->chart_data->series_title_value).' from '.$db->quotename($tablename->existing_database_table);
						if(!empty($tablename->extra_condition))
						$query .= ' where '.$tablename->extra_condition;
						if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
						if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
				         $query .= ' LIMIT 1'; 
						}
						else
						{ 
						$query = 'select '.$db->quotename($tablename->chart_data->series_title_value).' from '.$db->quotename($tablename->existing_database_table);
						if(!empty($tablename->extra_condition))
						$query .= ' where '.$tablename->extra_condition;
						if(!empty($tablename->groupby)){$query .= ' GROUP BY '.$tablename->groupby; }
						if(isset($chart_setting_options->orderbycolumn) && $chart_setting_options->orderbycolumn!=''){if(isset($tablename->ordering) && $tablename->ordering!=''){$query .= ' ORDER BY '.$chart_setting_options->orderbycolumn.' '.$tablename->ordering; }}
						
					     if($current_limit)
				         $query .= ' LIMIT '.($current_limit+1).' , 1'; 	
						}
						$db->setQuery($query);
						if($db->getErrorNum())	{
						$obj->result = 'error';
						$obj->error = $db->getErrorMsg();
						return $obj;
						}
						$title_name = $db->loadObjectList(); 
						
						$item = array();
						
						if(isset($tablename->chart_data->label_title) && $tablename->chart_data->label_title!='')
						{
						array_push($item, $tablename->chart_data->label_title);
					   }else
						array_push($item, 'Label');
						if(isset($tablename->chart_data->value_title) && $tablename->chart_data->value_title!='')
						{
						array_push($item, $tablename->chart_data->value_title);	
						}
						else
						  array_push($item, 'value');
							
						array_push($datas, $item);
						$series = explode(',',$s);
						for($i=0;$i<count($title_name);$i++)
						{
						
							$item = array();
							$res =0;
							foreach($title_name[$i] as $key => $value)
							{
								if($res==0){
								 $gauge_label = isset($series[$i])?$series[$i]:$series[0];
								  array_push($item, $gauge_label);							
								 array_push($item, (int)$value);
								  $res++;						 
								}
							
											  
							}
						
						
						array_push($datas, $item);
						}
						
						}
					
		   }
		$obj->result = 'success';
		$obj->data = $datas;
		return $obj;
		}

	function data_from_other_database($chartdata){
			
			$option = array(); //prevent problems
			
			$option['driver']   = $chartdata->db_driver;            // Database driver name
			$option['host']     = $chartdata->db_host;   // Database host name
			$option['user']     = $chartdata->db_root;    // User for database authentication
			$option['password'] = $chartdata->db_pass;  // Password for database authentication
			$option['database'] = $chartdata->db_database;    // Database name
			$option['prefix']   = $chartdata->db_prefix;         // Database prefix (may be empty)
 
            $db = JDatabase::getInstance( $option );
			
			$data = $datas = array();
			$item = '';
		switch($chart_data->vchart_type){
			
		case 'Area Chart':
		case 'Column Chart':
		case 'Line Chart':
		case 'SteppedAreaChart':	
			
			for($k=0;$k<count($column_name);$k++){
				
			$query = 'select '.$column_name[$k].' from '.$tablename;
			$db->setQuery($query);
			if($db->getErrorNum())	{
			$obj->result = 'error';
			$obj->error = $db->getErrorMsg();
			return $obj;
			}
			$data[$k] = $db->loadObjectList();
			}
			$item = '';
			$item = '["'.$x.'", "'.implode('", "', explode(',', $s)).'"]';
			array_push($datas,$item);
			for($i=0;$i<count($axis_values);$i++)	{
						
						$item = '["'.$axis_values[$i].'"';
						
							for($j=0;$j<count($column_name);$j++)	{
							$col_name = $column_name[$j];
							$col = $data[$j]; 
							$item .= ', '.(float)$col[$i]->$col_name;
							
							
							}
						$item .= ']';
						array_push($datas,$item);
						}
		
			return $datas;
			
			break;
			}
		
		}
   public static function return_type_date($value,$type){
				if($type!='')
				{
				if($type=='date' || $type=='datetime' || $type=='timeofday')
				{
				$date_value = explode('/', $value);
				$date_value[1]= $date_value[1]-1;
					
				   return 'new Date('.implode(',',$date_value).')';
				
				}elseif($type=='string'){
				  return '"'.$value.'"';
				}elseif($type=='number'){
					  return $value;
				}elseif($type=='boolean'){
					  if($value==1)
					  return 'true';
					  elseif($value==0)
					  return 'false';
					  else
					   return $value;
				}	 
					
				}
				else
				return ',';
	           
	   
	   }
}

?>
